MODULE BesideMe;
(*
  Created:   14.09.1988 by
             Stefan Salewski
             Stolper Weg 3
             2160 Stade   West-Germany
             Tel: 04141/61130
             
  Note: compiled with AMIGA Modula-2 System by AMSoft from 5.5.88
   
  This Module may be freely copied. But please
  leave my name in. Thanks....Stefan  

  Dieses kleine Programm verbindet zwei asscii-Textfiles miteinander,
  indem jeweils eine Zeile von FileA und FileB gelesen werden und Sie
  dann nebeneinander in FileC geschrieben. Durch wiederholte Anwendung
  kann man z.B. wenn die Zeilen aus Zahlen bestehen, Tabellen aufbauen.
  Die Filenamen werden als CLI-Parameter an das Programm uebergeben.
  Aufruf vom CLI: BesideMe LeftFile RightFile DestinationFile
*)

  FROM InOut IMPORT WriteInt,WriteString,WriteLn;
  FROM Arguments IMPORT NumArgs,GetArg;
  FROM FileSystem IMPORT File,Response,Lookup,Close,WriteChar,ReadChar;
  FROM Strings IMPORT Length,Insert,last;
  CONST
    CR=12C;
    LineLen=160;
  TYPE
    Line=ARRAY[0..LineLen] OF CHAR;
  VAR
    error:(noError,eof,err,toLong);
    leftFile,rightFile,destination:ARRAY[0..30] OF CHAR;
    leftCounter,rightCounter,l:INTEGER;
    lLine,rLine:Line;
    lFile,rFile,dFile:File;
    
  PROCEDURE ReadLine(VAR file:File;VAR str:Line):BOOLEAN;
  VAR 
    i:INTEGER;
    c:CHAR;
  BEGIN
    i:=0;
    REPEAT
      ReadChar(file,c);
      str[i]:=c;
      INC(i);
    UNTIL (i=LineLen) OR (c=CR) OR (file.res#done) OR (file.eof);
    IF i=LineLen THEN
      error:=toLong
    ELSIF (file.res#done) THEN
      error:=err
    ELSIF file.eof THEN
      error:=eof
    ELSE
      str[i-1]:=0C;
      error:=noError
    END;
    RETURN error=noError
  END ReadLine;
  
  PROCEDURE WriteLines(VAR file:File;VAR l1,l2:Line):BOOLEAN;
  VAR
    s:Line;
    l,i:INTEGER;
  BEGIN
    l:=Length(l1)+Length(l2);
    IF l<LineLen THEN
      s:=l1;
      Insert(s,last,l2);
      s[l]:=CR;
      i:=0;
      REPEAT 
        WriteChar(file,s[i]);
        INC(i)
      UNTIL (i>l) OR (file.res#done);
      IF i>l THEN
        error:=noError;
      ELSE
        error:=err;
      END
    ELSE
      error:=toLong
    END;
    RETURN error=noError
  END WriteLines;
       
BEGIN
  WriteLn;
  IF NumArgs()=3 THEN
    GetArg(1,leftFile,l);
    GetArg(2,rightFile,l);
    GetArg(3,destination,l);
    Lookup(lFile,leftFile,512,FALSE);
    IF lFile.res=done THEN
      Lookup(rFile,rightFile,512,FALSE);
      IF rFile.res=done THEN
        Lookup(dFile,destination,512,TRUE);
        IF dFile.res=done THEN    
          leftCounter:=0;
          rightCounter:=0;
          REPEAT
            IF ReadLine(lFile,lLine) THEN
              INC(leftCounter);
            END;
            IF ReadLine(rFile,rLine) THEN
              INC(rightCounter)
            END;
            IF (error=noError) AND (leftCounter=rightCounter) THEN
              IF WriteLines(dFile,lLine,rLine) THEN END
            END;
          UNTIL error#noError;
          IF error=toLong THEN
            WriteString('There are some too long lines in Your files')
          ELSIF error=err THEN
            WriteString('Error while working')
          ELSIF leftCounter#rightCounter THEN
            WriteString('Warning: Sourcefiles differ in the number of lines')
          ELSE
            WriteString('Destination File contains ');
            WriteInt(leftCounter,4);
            WriteString(' Lines')
          END;
          Close(dFile)
        END;
        Close(rFile)
      END;
      Close(lFile)
    END;
  ELSE
    WriteString("Usage: BesideMe LeftFile RightFile DestinationFile");
    WriteLn;
    WriteString("LeftFile and RightFile must be Ascii-Textfiles");
    WriteLn;
    WriteString("Line n from LeftFile and Line n from RightFile");
    WriteLn;
    WriteString("will be put BESIDE each other and this new Line");
    WriteLn;
    WriteString("will be written to DestinationFile while this");
    WriteLn;
    WriteString("new Line is not longer than 160 Characters.");
    WriteLn;
  END;
  WriteLn;
END BesideMe.
