IMPLEMENTATION MODULE Hardcopy;
(*
  Created:   30.12.1987
  Changed:   5.8.88 by 
             Stefan Salewski
             Stolper Weg 3
             2160 Stade   West-Germany
             Tel: 04141/61130
  Note: compiled with AMIGA Modula-2 System by AMSoft Version from 5.5.88
   
  This Module may be freely copied. But please
  leave my name in. Thanks....Stefan 
  
*)
  FROM Exec IMPORT OpenDevice,DoIO,CloseDevice,MsgPortPtr,IOFlagSet,CopyMem;
  FROM Printer IMPORT IODRPReq,IODRPReqPtr,dumpRPort,printerName,Special,
                      SpecialSet,Error;
  FROM ExecSupport IMPORT CreatePort,CreateExtIO,DeleteExtIO,DeletePort;
  FROM SYSTEM IMPORT ADR,ADDRESS,BITSET,LONGSET,CAST;
  FROM Storage IMPORT ALLOCATE,DEALLOCATE;
  FROM Intuition IMPORT DisplayBeep;
  FROM Dos IMPORT Delay;
  FROM Arts IMPORT Assert;
  FROM Graphics IMPORT ViewPortPtr,RastPortPtr,ColorMapPtr,ViewModeSet,
    GetRGB4,SetRGB4CM;
  VAR
    vPtr:ViewPortPtr;
    rPtr:RastPortPtr;
    colorMPtr:ColorMapPtr;
    modes:ViewModeSet;
    
  PROCEDURE Beep;
    VAR i:[0..7];
  BEGIN
    FOR i:=1 TO 3 DO
      DisplayBeep(NIL); (* All Screens*)
      Delay(5);
    END
  END Beep;
  
  PROCEDURE RGB(rgb:LONGCARD;VAR r,g,b:CARDINAL);
    (* Sortiert die einzelfarben aus rgb heraus  *)
    VAR
      color:CARDINAL;
  BEGIN
    color:=CARDINAL(rgb);
    b:=(color MOD 16);
    color:=color DIV 16;
    g:=(color MOD 16);
    r:=(color DIV 16);
  END RGB;
    
  PROCEDURE ChangeColors(VAR cPtr:ColorMapPtr;bGWhite:BOOLEAN);
  (* Macht die hellste Farbe zur Hintergrundfarbe und den Hintergrund
     hell oder weiss  
  *)
    VAR
      c:LONGCARD;
      s,r,r1,g,g1,b,b1:CARDINAL;
      n,i:INTEGER;
  BEGIN
    s:=0;
    FOR i:=0 TO 3 DO
      c:=GetRGB4(cPtr,i);
      RGB(c,r,g,b);
      IF (r+g+b) > s THEN
        s:=r+g+b;
        n:=i; (*Nunner der hellsten Farbe merken*)
        r1:=r;g1:=g;b1:=b;
      END;
    END;
    c:=GetRGB4(cPtr,0);
    RGB(c,r,g,b);
    SetRGB4CM(cPtr,n,r,g,b);
    IF bGWhite THEN
      SetRGB4CM(cPtr,0,15,15,15);
    ELSE 
      SetRGB4CM(cPtr,0,r1,g1,b1)
    END;
  END ChangeColors;
  
  PROCEDURE DumpRPort(rPort:RastPortPtr;vPortPtr:ViewPortPtr;
                      srcx,srcy,srcw,srch:CARDINAL;
                      destcols,destrows:LONGINT;s:SpecialSet;
                      wB,White:BOOLEAN);
    VAR 
      cm:ColorMapPtr;
      myColorTable:ARRAY[0..31] OF INTEGER;
      printerPort:MsgPortPtr;
      requestPtr:IODRPReqPtr;
      m:BITSET;
      i:CARDINAL;
  BEGIN
    Assert(rPort#NIL,ADR('Hardcopy:RastPortPtr=NIL'));
    Assert(vPortPtr#NIL,ADR('Hardcopy:ViewPortPtr=NIL'));
    printerPort:=CreatePort(ADR('myPrintPort'),0);
    IF printerPort#NIL THEN
      requestPtr:=CreateExtIO(printerPort,SIZE(IODRPReq));
      IF requestPtr#NIL THEN
        ALLOCATE(cm,SIZE(cm^));
        IF cm#NIL THEN
          OpenDevice(ADR(printerName),0,requestPtr,LONGSET{});
          IF requestPtr^.error=e0 THEN
            cm^:=vPortPtr^.colorMap^;
            cm^.colorTable:=ADR(myColorTable);
            CopyMem(vPortPtr^.colorMap^.colorTable,cm^.colorTable,
                    SIZE(myColorTable));
            IF wB THEN
              ChangeColors(cm,White);
            END;   
            m:=CAST(BITSET,vPortPtr^.modes);
            WITH requestPtr^ DO
              command:=dumpRPort;
              rastPort:=rPort;
              colorMap:=cm;
              modes:=LONGSET{};
              FOR i:=0 TO 15 DO
                IF i IN m THEN INCL(modes,i) END;
              END;
              srcX:=srcx;
              srcY:=srcy;
              srcWidth:=srcw;
              srcHeight:=srch;
              destCols:=destcols;
              destRows:=destrows;
              special:=s;
            END;
            DoIO(ADR(requestPtr^));
            IF requestPtr^.error#e0 THEN
              Beep
            END;
            CloseDevice(requestPtr);
          END;
          DEALLOCATE(cm,SIZE(cm^));
        END;
        DeleteExtIO(requestPtr);
      END;
      DeletePort(printerPort);
    END;
  END DumpRPort;
END Hardcopy.mod

