IMPLEMENTATION MODULE VarIO;
(*
  Created:   29.3.88
  Changed:   5.8.88/9.10.88 by
             Stefan Salewski
             Stolper Weg 3
             2160 Stade   West-Germany
             Tel: 04141/61130
             
  Note: compiled with AMIGA Modula-2 System by AMSoft from 5.5.88
   
*)

  FROM Formelauswertung IMPORT GetLongValue,ClearVar,DefFormel,LongBerechnung,
                               AssignLong;
  FROM MyMathLibLong IMPORT unit,AngleUnit;
  FROM FormelausFText IMPORT GetFehlertext;
  FROM Arts IMPORT TermProcedure,Assert;
  FROM Exec IMPORT GetMsg,ReplyMsg,MessagePtr,WaitPort;
  FROM FileMessage IMPORT StrPtr,ResponseText;
  FROM FileSystem IMPORT Lookup,Close,ReadBytes,WriteBytes,File,Response;
  FROM DOS IMPORT Delay;
  FROM SYSTEM IMPORT ADR;
  FROM MakeMenu IMPORT MenuRecord,InitMenu,FreeMenu,MenuNum,ItemNum,SubNum;
  FROM StringInOut IMPORT OpenNewWindow,CloseNewWindow,ReadString,ClearWindow,
    WriteString,inputOK,Flags,FlagSet,GetKey,SetPos,DeleteChar,SetClear;
  FROM Intuition IMPORT WindowPtr,MenuPtr,SetMenuStrip,ModifyIDCMP,menuNull,
    IntuiMessagePtr,IDCMPFlagSet,IDCMPFlags,MenuItemPtr,ItemAddress,
    ClearMenuStrip,Screen,ScreenPtr,GetScreenData;
  FROM MyUties IMPORT Buchstabe;
  FROM Storage IMPORT ALLOCATE,DEALLOCATE;
  FROM MyRemember IMPORT RememberNodePtr;
  FROM MyLongRealConversions IMPORT RealToStr;
  FROM Preference IMPORT CharSize;
  CONST
    Key=123123123.123456789;
    Dateiname='VariablenDatei';
    MaxLongReal=MAX(LONGREAL);
    WBScreen=1;
  VAR
    wPtrVarIO:WindowPtr;
    rememberKey:RememberNodePtr;
    pal,ok:BOOLEAN;
    wbScreenBuffer:ScreenPtr;
    
  PROCEDURE CleanupVarIO;
  BEGIN
    IF wPtrVarIO#NIL THEN
      ClearMenuStrip(wPtrVarIO);
      CloseNewWindow(wPtrVarIO);
      wPtrVarIO:=NIL;
      IF rememberKey#NIL THEN
        FreeMenu(rememberKey);
        rememberKey:=NIL
      END
    END
  END CleanupVarIO;
  
  PROCEDURE VarInOut;
    VAR
      windowX:INTEGER;
      width,height:INTEGER;
      ende:BOOLEAN;
      ergebnis:LONGREAL;
      fehler:CARDINAL;
      bottom:INTEGER;
      string,fehlertext:ARRAY[0..80] OF CHAR;
      char:CHAR;
      s:ARRAY[0..2] OF CHAR;
      menurecords:ARRAY[0..1] OF MenuRecord;
      firstMenu:MenuPtr;
      
    PROCEDURE InitVarInOutMenu;
    BEGIN
      WITH menurecords[0] DO
        mname:='Aktionen';
        anzahlItems:=4;
        WITH mItems[0] DO
          iname:='Laden';
          commandKey:='L';
          anzahlSubitems:=0;
        END;
        WITH mItems[1] DO
          iname:='Speichern';
          commandKey:='S';
          anzahlSubitems:=0;
        END;
        WITH mItems[2] DO
          iname:='Lschen';
          commandKey:='D';
          anzahlSubitems:=0;
        END;
        WITH mItems[3] DO
          iname:='Ins Hauptmen';
          commandKey:='E';
          anzahlSubitems:=0;
        END;
      END;
      WITH menurecords[1] DO
        mname:='Winkel';
        anzahlItems:=1;
        WITH mItems[0] DO
          iname:='Winkeleinheit';
          commandKey:=0C;
          anzahlSubitems:=3;
          subrecords[0].subName:='Rad';
          subrecords[0].commandKey:=0C;
          subrecords[1].subName:='Deg';
          subrecords[1].commandKey:=0C;
          subrecords[2].subName:='Gon';
          subrecords[2].commandKey:=0C;
        END
      END;
      InitMenu(menurecords,firstMenu,rememberKey);
      IF SetMenuStrip(wPtrVarIO,firstMenu) THEN END;
    END InitVarInOutMenu;
(*************************************************************************)  
    PROCEDURE RespondMessage;
      VAR
        class:IDCMPFlagSet;
        code:CARDINAL;
        msgPtr:IntuiMessagePtr;
      PROCEDURE MenuReaction;
        PROCEDURE Delete;
          VAR
            char:CHAR;
        BEGIN
          SetPos(wPtrVarIO,1,bottom);
          WriteString(wPtrVarIO,'Welche Variable soll gelscht werden ?',TRUE);
          char:=GetKey(wPtrVarIO);
          IF inputOK AND Buchstabe(char) THEN
            ClearVar(char);
          END;
        END Delete;
        PROCEDURE Load;
          VAR p:StrPtr;
            f:File;
            str,fileName:ARRAY[0..32] OF CHAR;
            end:BOOLEAN;
            x:LONGREAL;
            actlen:LONGINT;
            i:CARDINAL;
            c:CHAR;
        BEGIN
          fileName:=Dateiname;
          REPEAT
            SetPos(wPtrVarIO,1,bottom);
            DeleteChar(wPtrVarIO,windowX);
            ReadString(wPtrVarIO,'Dateiname:',fileName,30);
            IF inputOK AND (fileName[0]#0C) THEN
              Lookup(f,fileName,512,FALSE);
              end:=FALSE;
              IF f.res = done THEN
                char:='a';
                ReadBytes(f,ADR(x),SIZE(x),actlen);
                IF x=Key THEN
                  WHILE  NOT end DO
                    FOR i:=0 TO 25 DO
                      c:=CHAR(CARDINAL(char)+i);
                      ReadBytes(f,ADR(x),SIZE(x),actlen);
                      IF NOT(f.res = done) THEN
                        WriteString(wPtrVarIO,'ReadError',TRUE)
                      END;
                      IF x=MaxLongReal THEN
                        ClearVar(c)
                      ELSE
                        IF AssignLong(c,x) THEN END;
                      END;
                    END;
                    IF char='a' THEN
                      char:='A'
                    ELSE
                      end:=TRUE
                    END
                  END;
                ELSE
                  SetPos(wPtrVarIO,1,bottom);
                  DeleteChar(wPtrVarIO,windowX-1);
                  WriteString(wPtrVarIO,'Falscher Dateityp',TRUE);
                  Delay(50)
                END;
                Close(f);
              ELSE
                ResponseText(f.res,p);
                SetPos(wPtrVarIO,1,bottom);
                DeleteChar(wPtrVarIO,windowX-1);
                WriteString(wPtrVarIO,p^,TRUE);
                Delay(50)
              END
            END
          UNTIL end OR (fileName[0]=0C) OR NOT inputOK;
        END Load;
        PROCEDURE Save;
          VAR p:StrPtr;
            f:File;
            fileName:ARRAY[0..32] OF CHAR;
            end:BOOLEAN;
            x:LONGREAL;
            actlen:LONGINT;
            i:CARDINAL;
            c:CHAR;
        BEGIN
          fileName:=Dateiname;
          REPEAT
            SetPos(wPtrVarIO,1,bottom);
            DeleteChar(wPtrVarIO,windowX-1);
            ReadString(wPtrVarIO,'Dateiname:',fileName,30);
            IF inputOK AND (fileName[0]#0C) THEN
              Lookup(f,fileName,512,TRUE);
              end:=FALSE;
              IF f.res = done THEN
                x:=Key;
                WriteBytes(f,ADR(x),SIZE(x),actlen);
                char:='a';
                WHILE  NOT end DO
                  FOR i:=0 TO 25 DO
                    c:=CHAR(CARDINAL(char)+i);
                    IF NOT GetLongValue(c,x) THEN
                      x:=MaxLongReal
                    END;
                    WriteBytes(f,ADR(x),SIZE(x),actlen);
                    IF NOT(f.res = done) THEN
                      WriteString(wPtrVarIO,'WriteError',TRUE)
                    END;
                  END;
                  IF char='a' THEN
                    char:='A'
                  ELSE
                    end:=TRUE
                  END
                END;
                Close(f)
              ELSE
                ResponseText(f.res,p);
                SetPos(wPtrVarIO,1,bottom);
                DeleteChar(wPtrVarIO,windowX-1);
                WriteString(wPtrVarIO,p^,TRUE);
                Delay(50)
              END
            END
          UNTIL end OR (fileName[0]=0C) OR NOT inputOK;
        END Save;
        
        VAR
          menuNr,itemNr,subNr:CARDINAL;
          menuIPtr:MenuItemPtr;
      BEGIN (*MenuReaction*)
        WHILE code#menuNull DO
          menuNr:=MenuNum(code);
          itemNr:=ItemNum(code);
          subNr:=SubNum(code);
          CASE menuNr OF
            0:CASE itemNr OF
                0:Load|
                1:Save|
                2:Delete|
                3:ende:=TRUE
              END|
            1:CASE itemNr OF
                0:CASE subNr OF
                    0:unit:=rad|
                    1:unit:=deg|
                    2:unit:=gon|
                  END
              END
          END;  
          menuIPtr:=ItemAddress(firstMenu,code);
          code:=menuIPtr^.nextSelect;
        END;
      END MenuReaction;
(*************************************************************************)
    BEGIN
      WaitPort(wPtrVarIO^.userPort);
      msgPtr:=GetMsg (wPtrVarIO^.userPort); 
      IF msgPtr#NIL THEN
        class:=msgPtr^.class;
        code:=msgPtr^.code;
        ReplyMsg(msgPtr);
        IF class=IDCMPFlagSet{menuPick} THEN
          MenuReaction
        END
      END
    END RespondMessage;
(*************************************************************************)
    PROCEDURE WriteVar;
      VAR
        c:ARRAY[0..2] OF CHAR;
        s:ARRAY[0..25] OF CHAR;
        spalte,stellen,zeilen:INTEGER;
        i:[-1..255];
        x:LONGREAL;
      PROCEDURE ToStr(x:LONGREAL;VAR str:ARRAY OF CHAR);
      BEGIN
        IF ABS(x)>1.0 THEN
          RealToStr(x,str,-stellen,stellen);
        ELSE
          RealToStr(x,str,-stellen,-stellen)
        END;
      END ToStr;
    BEGIN
      IF pal THEN
        zeilen:=26;
        stellen:=14
      ELSE
        zeilen:=18;
        IF width=10 THEN
          stellen:=11
        ELSE
          stellen:=14
        END
      END;
      ClearWindow(wPtrVarIO);
      c[0]:='a';
      c[1]:='=';
      c[2]:=0C;
      FOR i:=0 TO 51 DO
        spalte:=1+(i DIV zeilen)*(stellen+10);
        SetPos(wPtrVarIO,spalte,1+(i MOD zeilen));
        WriteString(wPtrVarIO,c,FALSE);
        IF GetLongValue(c[0],x) THEN
          ToStr(x,s);
          WriteString(wPtrVarIO,s,FALSE);
        END;
        INC(c[0]);
        IF c[0]=CHAR(ORD('z')+1) THEN
          c[0]:='A'
        END
      END;
      SetPos(wPtrVarIO,1,bottom);
    END WriteVar;
(*************************************************************************)
  BEGIN
    wPtrVarIO:=NIL;
    rememberKey:=NIL;
    CharSize(width,height);
    IF pal THEN
      windowX:=49;
      IF height=8 THEN
        bottom:=28;
        OpenNewWindow(wPtrVarIO,40,0,windowX,bottom,FlagSet{drag,depth},
        'Variable Definieren');
      ELSE
        bottom:=27;
        OpenNewWindow(wPtrVarIO,40,0,windowX,bottom,FlagSet{},'');
      END
    ELSE
      IF height=8 THEN
        windowX:=73;
        bottom:=20
      ELSE
        windowX:=63;
        bottom:=19
      END;
      OpenNewWindow(wPtrVarIO,0,0,windowX,bottom,FlagSet{drag,depth},
      'Variable Definieren');
    END;
    Assert(wPtrVarIO#NIL,ADR('VarIO:Cannot open window'));
    SetClear(wPtrVarIO,FALSE);
    ModifyIDCMP(wPtrVarIO,IDCMPFlagSet{menuPick});
    InitVarInOutMenu;
    ende:=FALSE;
    unit:=rad;
    REPEAT
      ClearWindow(wPtrVarIO);
      WriteVar;
      WriteString(wPtrVarIO,'Variable: ',FALSE);
      char:=GetKey(wPtrVarIO);
      IF inputOK AND Buchstabe(char) THEN
        s[0]:=char;
        s[1]:=0C;
        string[0]:=0C;
        REPEAT
          SetPos(wPtrVarIO,1,bottom);
          DeleteChar(wPtrVarIO,windowX-1);
          WriteString(wPtrVarIO,'Variable: ',FALSE);
          WriteString(wPtrVarIO,s,FALSE);
          ReadString(wPtrVarIO,':=',string,20);
          IF (string[0]#0C) AND (inputOK) THEN
            fehler:=DefFormel(9,string,TRUE,TRUE);
            IF fehler=0 THEN
              LongBerechnung(9,ergebnis,fehler)
            END;
            IF fehler#0 THEN
              SetPos(wPtrVarIO,1,bottom);
              DeleteChar(wPtrVarIO,windowX-1);
              GetFehlertext(fehler,fehlertext);
              WriteString(wPtrVarIO,fehlertext,FALSE);
              Delay(50)
            ELSE
              IF AssignLong(char,ergebnis) THEN END;
            END;
          END
        UNTIL (fehler=0) OR (string[0]=0C) OR (NOT inputOK);
      END;
      IF NOT inputOK THEN
        SetPos(wPtrVarIO,1,bottom);
        DeleteChar(wPtrVarIO,windowX-1);
        RespondMessage
      END;
    UNTIL ende;
    CleanupVarIO;
  END VarInOut;
BEGIN
  ALLOCATE(wbScreenBuffer,SIZE(Screen));
  ok:=GetScreenData(wbScreenBuffer,SIZE(Screen),WBScreen,NIL);
  Assert(ok,ADR('VarIO:Cannot get WBScreenData'));
  pal:=wbScreenBuffer^.height=256;
  DEALLOCATE(wbScreenBuffer,SIZE(Screen));
  TermProcedure(CleanupVarIO);
  wPtrVarIO:=NIL;  
END VarIO.mod  
