IMPLEMENTATION MODULE SymTab;

(* Autor:	Bernd Preusing, Gerhardstr. 166, D-2200 Elmshorn
   Version:	1.0  27-Jul-88
   Copyright:	public domain
   Zweck:	Verwaltung einer Label-Liste, bestehend aus Adresse und
		zugehrigem Namen.
   Anmerkung:	Dies Modul ist nur fr das Programm DisObject. Es ist eine
		stark erweiterte und vebesserte Version in Arbeit!
   Importe:	---
*)

FROM SYSTEM IMPORT CAST, ADR, ADDRESS;

FROM Exec IMPORT MinNode, MinNodePtr, List, ListPtr, NodePtr;

CONST Max = 1000;

TYPE
  MyNode = RECORD
    node: MinNode;
    ad: LONGINT;
    str: SymName
  END;
  MyNodePtr=POINTER TO MyNode;

VAR
 Feld: ARRAY[0..Max] OF MyNode; (* spart das ewige Allocate etc. *)

 l:List; lPtr:ListPtr;
 recs:LONGCARD;
 mn:MyNodePtr;
 actName: SymName;

 PROCEDURE IncName();
 VAR i:CARDINAL;
 BEGIN
  i:=6;
  LOOP
    INC(actName[i]);
    IF actName[i]>'9' THEN
      actName[i]:='0';
      DEC(i)
    ELSE
      EXIT
    END
  END
 END IncName;

PROCEDURE GenSyms();
BEGIN
 actName:='L000001';
 mn:=CAST(MyNodePtr,lPtr);
 LOOP
   mn:=CAST(MyNodePtr,mn^.node.succ);
   IF mn=NIL THEN EXIT END;
   WITH mn^ DO
     IF str[0]=0C THEN
       str:=actName;
       IncName()
     END
   END;
 END;
END GenSyms;

PROCEDURE Init();
BEGIN
 lPtr:=ADR(l);
 WITH l DO
   head:=ADR(tail);
   tail:=CAST(NodePtr,0);
   tailPred:=ADR(head)
 END;
 recs:=0;

END Init;

PROCEDURE SearchAd(a:LONGINT):AdRecPtr;
VAR a2,d0:MyNodePtr;
BEGIN
 a2:=ADR(l);
 d0:=CAST(MyNodePtr,a2^.node.succ);
 IF d0=NIL THEN RETURN NIL END;
 LOOP
  a2:=d0;
  d0:=CAST(MyNodePtr,a2^.node.succ);
  IF d0=NIL THEN RETURN NIL END;
  IF a=a2^.ad THEN EXIT END;
 END;
 d0:=a2;
 RETURN CAST(AdRecPtr,ADR(d0^.ad));
END SearchAd;

PROCEDURE InsertAd(s:SymName;a:LONGINT);
VAR actual,a0,d0:MyNodePtr;
BEGIN
 a0:=ADR(l); (* sihe enqueue *)
 d0:=CAST(MyNodePtr,a0^.node.succ);
 actual:=ADR(Feld[recs]);
 LOOP
   a0:=d0;
   d0:=CAST(MyNodePtr,a0^.node.succ);
   IF (d0=NIL) OR (a<=a0^.ad) THEN EXIT END;
 END;
 d0:=CAST(MyNodePtr,a0^.node.pred);
 a0^.node.pred:=CAST(MinNodePtr,actual);
 WITH actual^ DO
  node.succ:=CAST(MinNodePtr,a0);
  node.pred:=CAST(MinNodePtr,d0);
  ad:=a;
  str:=s;
 END;
 d0^.node.succ:=CAST(MinNodePtr,actual);
 INC(recs); IF recs>Max THEN HALT END;
END InsertAd;

PROCEDURE FirstAd():AdRecPtr;
BEGIN
 mn:=CAST(MyNodePtr,lPtr);
 mn:=CAST(MyNodePtr,mn^.node.succ);
 IF mn=NIL THEN RETURN NIL
 ELSE RETURN CAST(AdRecPtr,ADR(mn^.ad)) END
END FirstAd;

PROCEDURE NextAd():AdRecPtr;
BEGIN
 IF mn=NIL THEN RETURN NIL END;
 mn:=CAST(MyNodePtr,mn^.node.succ);
 IF mn=NIL THEN RETURN NIL
 ELSE RETURN CAST(AdRecPtr,ADR(mn^.ad))
 END;
END NextAd;

BEGIN
 Init
END SymTab.mod
