MODULE Motoren;

(******************************************************************)
(*                                                                *)
(*    Autor:     Klapczynski Norbert                              *)
(*               Kochelseestr. 9                                  *)
(*                                                                *)
(*               D 8900 Augsburg 1                                *)
(*                                                                *)
(*    Version    1.0             31. Okt. 1988                    *)
(*                                                                *)
(******************************************************************)

FROM Arts      IMPORT Assert;
FROM SYSTEM    IMPORT ADDRESS,ADR ;
FROM Intuition IMPORT ScreenFlags,ScreenFlagSet,NewWindow,WindowPtr,
		      IDCMPFlags,IDCMPFlagSet,WindowFlags,WindowFlagSet,
                      OpenWindow,CloseWindow,IntuiMessage,Gadget,GadgetPtr,
                      boolGadget,GadgetFlags,GadgetFlagSet,ActivationFlags,
                      ActivationFlagSet,Border,IntuiText,
                      AutoRequest,RefreshGadgets;
FROM Graphics  IMPORT Text,Move,jam1,jam2 ;
FROM Exec      IMPORT GetMsg,ReplyMsg,WaitPort;
FROM Interface IMPORT Init,Write,PrepareM,Motor,Richtung;


CONST booleangadget = 10 ;

TYPE Title = ARRAY [0..70] OF CHAR ;
     MotorStatus = ARRAY Motor OF Richtung;

VAR 
    ActiveMotor              : Motor;
    ActiveMotorGadgetPtr     : GadgetPtr; 
    ActiveDirection          : Richtung;
    ActiveDirectionGadgetPtr : GadgetPtr;
    ActStatus                : MotorStatus;

    MyWindow                              : NewWindow ;
    MyWindowPtr                           : WindowPtr ;
    WindowTitle                           : Title ;
    class                                 : IDCMPFlagSet ;
    IntuiMsg                              : POINTER TO IntuiMessage ;
    Motor1Gadget,Motor2Gadget,
    Motor3Gadget,Motor4Gadget,
    R1Gadget,R2Gadget,R3Gadget,R4Gadget   : Gadget ;
    Rahmen10u,Rahmen11u,
    Rahmen10s,Rahmen11s                   : Border ;
    xy10Feld,xy11Feld                     : ARRAY [0..9]  OF INTEGER ;
    Motor1Text,Motor2Text,
    Motor3Text,Motor4Text                 : ARRAY [0..12] OF CHAR ;
    code                                  : CARDINAL;
    iAdress                               : ADDRESS;
    Motor1text,Motor2text,
    Motor3text,Motor4text,
    R1text,R2text,R3text,R4text,
    body50text,body51text,body52text,
    CopyRight                             : IntuiText;
    Motor1textmess,Motor2textmess,
    Motor3textmess,Motor4textmess,
    R1mess,R2mess,R3mess,R4mess,
    body50textmess,body51textmess,
    body52textmess                        :ARRAY [0..20] OF CHAR;
    CopyRightMess                         :ARRAY [0..45] OF CHAR;


CONST blue  = 0;
      white = 1;
      black = 2;
      orange= 3;
      
PROCEDURE init;
VAR i: Motor;
BEGIN
   
   FOR i:= M1 TO M4 DO
      ActStatus[i]:= Aus;
   END;
   ActiveMotor := M1;
   ActiveMotorGadgetPtr:= ADR(Motor1Gadget);
   ActiveDirection := Aus;
   ActiveDirectionGadgetPtr:= ADR(R1Gadget);
   
   Init(); (* Interface initialisieren *);
      
(*------------ Fr das Window ---------------------------------*) 
   WindowTitle := " Fischertechnik Motoren steuern " ;
   
   WITH MyWindow DO
      leftEdge := 0 ; topEdge := 20 ;
      width := 640 ; height := 200 ;
      detailPen := 0 ; blockPen := 1 ;
      idcmpFlags := IDCMPFlagSet{closeWindow,gadgetDown} ;
      flags := WindowFlagSet{windowDrag,
                             windowDepth,
                             windowClose} ;
      firstGadget := ADR(Motor1Gadget) ;
      checkMark := NIL ;
      title := ADR(WindowTitle) ;
      bitMap := NIL ;
      type := ScreenFlagSet{wbenchScreen} ;
   END ;   
  
(*------------ Fr das 1.MotorGadget #1----------------------*) 

   xy10Feld[0] := 0  ; xy10Feld[1] := 0  ;
   xy10Feld[2] := 115; xy10Feld[3] := 0  ;
   xy10Feld[4] := 115; xy10Feld[5] := 15 ;
   xy10Feld[6] := 0  ; xy10Feld[7] := 15 ;
   xy10Feld[8] := 0  ; xy10Feld[9] := 0  ;

   
   xy11Feld[0] := 0  ; xy11Feld[1] := 0  ;
   xy11Feld[2] := 111; xy11Feld[3] := 0  ;
   xy11Feld[4] := 111; xy11Feld[5] := 11 ;
   xy11Feld[6] := 0  ; xy11Feld[7] := 11 ;
   xy11Feld[8] := 0  ; xy11Feld[9] := 0  ;
   
   WITH Rahmen10u DO  
      leftEdge := -3 ; topEdge := -3 ;
      frontPen := blue ; backPen := blue ;
      drawMode := jam1 ; 
      count := 5 ; xy := ADR(xy10Feld) ;
      nextBorder := ADR(Rahmen11u); 
   END;
   
   WITH Rahmen11u DO 
      leftEdge := -1 ; topEdge := -1 ;
      frontPen := white ; backPen := blue ;
      drawMode := jam1 ; 
      count := 5 ; xy := ADR(xy11Feld) ;
      nextBorder := NIL ;
   END;
   
   Rahmen10s:=Rahmen10u;
   Rahmen11s:=Rahmen11u;
   Rahmen10s.nextBorder:=ADR(Rahmen11s);
   Rahmen10s.frontPen := orange;
   Rahmen11s.frontPen := orange;


   Motor1textmess := " Motor 1 " ;
   Motor2textmess := " Motor 2 " ;
   Motor3textmess := " Motor 3 " ;
   Motor4textmess := " Motor 4 " ;
   
   WITH Motor1text DO
      frontPen := white ; backPen := blue ;
      drawMode := jam1 ;
      leftEdge := 1 ; topEdge := 2 ;
      nextText := NIL ; 
      iText := ADR(Motor1textmess) ;
   END ;
   
   Motor2text:=Motor1text;
   Motor3text:=Motor1text;
   Motor4text:=Motor1text;

   Motor4text.nextText:=ADR(CopyRight);
   CopyRightMess:="Programmiert von N. Klapczynski  Nov. 1988";
   
   WITH CopyRight DO
      frontPen := black ; backPen := blue ;
      drawMode := jam1 ;
      leftEdge := 220 ; topEdge := 2 ;
      nextText := NIL ; 
      iText := ADR(CopyRightMess);
   END;
      
   Motor2text.iText:=ADR(Motor2textmess);
   Motor3text.iText:=ADR(Motor3textmess);
   Motor4text.iText:=ADR(Motor4textmess);
   
   WITH Motor1Gadget DO
      nextGadget := ADR(Motor2Gadget);
      leftEdge := 30 ; topEdge := 30 ;
      width := 110 ; height := 10 ;
      flags := GadgetFlagSet{gadgHImage,selected} ;
      activation := ActivationFlagSet{gadgImmediate,relVerify,toggleSelect} ;
      gadgetType := boolGadget ;
      gadgetRender := ADR(Rahmen10u) ; selectRender := ADR(Rahmen10s); 
      gadgetText := ADR(Motor1text) ; specialInfo := NIL ;
      gadgetID := booleangadget ;
      userData := NIL ;
   END ;
   
   Motor2Gadget:=Motor1Gadget;
   Motor3Gadget:=Motor1Gadget;   
   Motor4Gadget:=Motor1Gadget;
   

   WITH Motor2Gadget DO
      nextGadget := ADR(Motor3Gadget);
      topEdge := 60 ;
      flags := GadgetFlagSet{gadgHImage} ;
      gadgetText := ADR(Motor2text) ; 
   END ;
   
   WITH Motor3Gadget DO
      nextGadget := ADR(Motor4Gadget);
      topEdge := 110 ;
      flags := GadgetFlagSet{gadgHImage} ;
      gadgetText := ADR(Motor3text) ; 
   END ;
   
   WITH Motor4Gadget DO
      nextGadget := ADR(R1Gadget);
      topEdge := 140 ;
      flags := GadgetFlagSet{gadgHImage} ;
      gadgetText := ADR(Motor4text) ; 
   END ;

(*------------ Fr die RichtungsGadgets ------------------*) 

   R1mess := "     AUS      " ;
   R2mess := " EIN / RECHTS " ;
   R3mess := "     LINKS    " ;
   R4mess := "     Aus2     " ;
   
   WITH R1text DO
      frontPen := white ; backPen := blue ;
      drawMode := jam1 ;
      leftEdge := 1 ; topEdge := 2 ;
      nextText := NIL ; 
      iText := ADR(R1mess) ;
   END ;
   
   R2text:=R1text;
   R3text:=R1text;
   R4text:=R1text;
   
   R2text.iText:=ADR(R2mess);
   R3text.iText:=ADR(R3mess);
   R4text.iText:=ADR(R4mess);
       
   WITH R1Gadget DO
      nextGadget := ADR(R2Gadget);
      leftEdge := 130 ; topEdge := 85 ;
      width := 110 ; height := 10 ;
      flags := GadgetFlagSet{gadgHImage,selected} ;
      activation := ActivationFlagSet{gadgImmediate,relVerify,toggleSelect} ;
      gadgetType := boolGadget ;
      gadgetRender := ADR(Rahmen10u) ; selectRender := ADR(Rahmen10s); 
      gadgetText := ADR(R1text) ; specialInfo := NIL ;
      gadgetID := booleangadget ;
      userData := NIL ;
   END;

   R2Gadget:=R1Gadget;
   R3Gadget:=R1Gadget;
   R4Gadget:=R1Gadget;
   
   WITH R2Gadget DO
      flags := GadgetFlagSet{gadgHImage} ;
      nextGadget := ADR(R3Gadget);
      leftEdge := 250 ;
      gadgetText := ADR(R2text) ;
   END;

   WITH R3Gadget DO
      flags := GadgetFlagSet{gadgHImage} ;
      nextGadget := ADR(R4Gadget);
      leftEdge := 370 ;
      gadgetText := ADR(R3text) ;
   END;

   WITH R4Gadget DO
      flags := GadgetFlagSet{gadgHImage} ;
      nextGadget := NIL;
      leftEdge := 490 ;
      gadgetText := ADR(R4text) ;
   END;
   
(*------------ Fr den Requester #5----------------------------*) 

   body50textmess := "Programm verlassen ?";
   
   WITH body50text DO
      frontPen:= black; backPen:= white;
      leftEdge :=6; topEdge:= 3;
      iTextFont:= NIL;
      iText    := ADR(body50textmess);
      nextText := NIL;
   END;
 
   body51textmess := "Ja";
   
   WITH body51text DO
      frontPen:= orange; backPen:= white;
      leftEdge := 5; topEdge:= 4;
      iTextFont:= NIL;
      iText    := ADR(body51textmess);
      nextText := NIL;
   END;
   
   body52textmess := "Nein";
   
   WITH body52text DO
      frontPen:= blue; backPen:= white;
      leftEdge:= 5; topEdge:= 4;
      iTextFont:= NIL;
      iText    := ADR(body52textmess);
      nextText := NIL;
   END;
END init;

PROCEDURE GadgetOff(x:GadgetPtr);
VAR  a:ADDRESS;
BEGIN
  WITH x^ DO
    a:=nextGadget;
    nextGadget:=NIL;
    flags := flags-GadgetFlagSet{selected} ;
    RefreshGadgets(x,MyWindowPtr,NIL);
    nextGadget:=a;
  END;
END GadgetOff;

PROCEDURE GadgetOn(x:GadgetPtr);
VAR  a:ADDRESS;
BEGIN
  WITH x^ DO
    a:=nextGadget;
    nextGadget:=NIL;
    flags := flags+GadgetFlagSet{selected} ;
    RefreshGadgets(x,MyWindowPtr,NIL);
    nextGadget:=a;
  END;
END GadgetOn;


PROCEDURE ChangeDirection( wie:Richtung; adr:ADDRESS );
BEGIN
  GadgetOff(ActiveDirectionGadgetPtr);
  ActiveDirection:=wie;
  ActStatus[ActiveMotor]:=wie;
  ActiveDirectionGadgetPtr:=GadgetPtr(adr);
  GadgetOn(ActiveDirectionGadgetPtr);
  PrepareM(ActiveMotor,wie);
END ChangeDirection;


PROCEDURE ChangeMotor( m:Motor; adr:ADDRESS);
VAR adres: ADDRESS;
BEGIN
 GadgetOff(ActiveMotorGadgetPtr);
 ActiveMotor:=m;
 ActiveMotorGadgetPtr:=GadgetPtr(adr); 
 GadgetOn(ActiveMotorGadgetPtr);
     (* Nun zeige noch die richtige Richtung an 
        <=> simuliere eine entsprechende Gadgetactivierung *);
 CASE ActStatus[m] OF
      Aus        : adres:= ADR(R1Gadget);
    | Ein,Rechts : adres:= ADR(R2Gadget);
    | Links      : adres:= ADR(R3Gadget);
    | Aus2       : adres:= ADR(R4Gadget);
 END;
 ChangeDirection(ActStatus[m], adres);
END ChangeMotor;


BEGIN 
   init();
   MyWindowPtr := OpenWindow(MyWindow) ;
   Assert(MyWindowPtr # NIL, ADR("Fenster nicht geffnet"));
   LOOP
      Write();
      IntuiMsg := GetMsg(MyWindowPtr^.userPort) ;
      WHILE IntuiMsg # NIL DO
         class := IntuiMsg^.class ;
         iAdress:= IntuiMsg^.iAddress;
         code:=IntuiMsg^.code;
         ReplyMsg(IntuiMsg) ;
         IF (closeWindow IN class) THEN
            IF AutoRequest(MyWindowPtr,ADR(body50text),
               ADR(body51text),ADR(body52text),
               IDCMPFlagSet {},IDCMPFlagSet {}, 200,50)  THEN
              EXIT;
            END;
         ELSIF (gadgetDown IN class)  THEN
            IF    (iAdress=ADR(Motor1Gadget)) THEN
                   ChangeMotor(M1,iAdress);
            ELSIF (iAdress=ADR(Motor2Gadget)) THEN
                   ChangeMotor(M2,iAdress);
            ELSIF (iAdress=ADR(Motor3Gadget)) THEN
                   ChangeMotor(M3,iAdress);
            ELSIF (iAdress=ADR(Motor4Gadget)) THEN
                   ChangeMotor(M4,iAdress);
            ELSIF (iAdress=ADR(R1Gadget))     THEN
                   ChangeDirection(Aus,iAdress);
            ELSIF (iAdress=ADR(R2Gadget))     THEN
                   ChangeDirection(Rechts,iAdress);
            ELSIF (iAdress=ADR(R3Gadget))     THEN
                   ChangeDirection(Links,iAdress);
            ELSIF (iAdress=ADR(R4Gadget))     THEN
                   ChangeDirection(Aus2,iAdress);
            END;
         END;
         IntuiMsg := GetMsg(MyWindowPtr^.userPort) ;
      END;
   END;

   (* Schlieen des Fensters und der Intuition-Library *)
   
   CloseWindow(MyWindowPtr);
END Motoren.
