(*---------------------------------------------------------------------------
    :Program.    StripText.mod
    :Author.     Bernd Preusing
    :Address.    Gerhardstr. 16  D-2200 Elmshorn
    :Phone.      04121/22486
    :Shortcut.   [bep]
    :Version.    1.0
    :Date.       Oct-88
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga
    :Imports.    TwoFiles, InOut2
    :UpDate.     
    :Contents.   convert text to tabs, kill trailing spaces
    :Remark.     
---------------------------------------------------------------------------*)
MODULE StripText;

FROM SYSTEM IMPORT
	ADR, BITSET, CAST;

FROM ASCII IMPORT
	eol, eof, nul, ht;

FROM Terminal IMPORT
	WriteString, WriteLn;

FROM TwoFiles IMPORT
	OpenFiles;

FROM InOut2 IMPORT
	termCh, ReadLn, WriteCount, CloseOutput, CloseInput;



TYPE Zeile=ARRAY[0..150] OF CHAR;

VAR
 Old: Zeile;
 n:Zeile;
 ch:CHAR;
 len:INTEGER;

(* $ S- $ R - $ V- das bringt nicht viel! *)

PROCEDURE StripIt(VAR s:Zeile; Len: INTEGER):INTEGER;
VAR
 l,x,i,pos,Spaces:INTEGER;
 nt, npos:INTEGER;

BEGIN
 l:=Len; pos:=0; i:=0; Spaces:=0;
 FOR x:=0 TO l-1 DO
   ch:=s[x];
   IF ch=' ' THEN
     INC(Spaces)
   ELSIF ch=ht THEN
     INC(Spaces,
        CAST(INTEGER,CAST(BITSET,pos+Spaces)+BITSET{0..2})+1-(pos+Spaces));
   ELSE
   (*  PutSpaces; *)
   WHILE Spaces>0 DO
     nt:=CAST(INTEGER,CAST(BITSET,pos)+BITSET{0..2})+1; (* NextTab(pos) *)
     npos:=pos+Spaces;
     IF nt>npos THEN
        REPEAT
          n[i]:=' ';
          INC(i);
          INC(pos);
        UNTIL pos=npos;
        Spaces:=0
     ELSE
        n[i]:=ht;
        INC(i);
        DEC(Spaces,nt-pos);
        pos:=nt;
     END;
   END; (* PutSpaces *)
     n[i]:=ch;
     INC(i);
     INC(pos);
   END;
 END;
 n[i]:=nul;
 WHILE (i>0) AND ((n[i-1]=' ') OR (n[i-1]=ht)) DO
   DEC(i);
   n[i]:=nul
 END;
 RETURN i
END StripIt;

BEGIN
 WriteString('StripText 1.0   1988 Bernd Preusing'); WriteLn;
 WHILE OpenFiles(TRUE,TRUE) DO
   LOOP
     ReadLn(Old,len);
     IF termCh=eof THEN EXIT END;
     len:=StripIt(Old,len);
     n[len]:=eol;
     WriteCount(ADR(n),len+1);
   END;
   CloseOutput; CloseInput; (* nicht unbedingt ntig, aber nett *)
   WriteString('--- fertig ---'); WriteLn;
 END;
END StripText.
