(*------------------------------------------------------------------------
             
:Program.    CompControl.MOD
:Author.     Ralf Kaiser
:Address.    Winckelmannstr. 1, 5600 Wuppertal 2
:Phone.      02 02/59 28 10
:ShortCut.   [rk]
:Version.    2.1
:Copyright.  Public Domain
:Date.       21.01.89
:Language.   Modula 2
:Translator. M2 Amiga Version 3.2d
:Imports.    CCInitWin, Meldung, GetConfig [rk]
:Imports.    ARP.DEF , Friedtjof Siebert (AMOK)
:Contents.   Steuerprogramm fr Editor, Compiler und Linker
:Contents.   Erlaubt das Arbeiten mit 2 verschiedenen bersetzern.
:Contents.   So kann man auch einen Compiler sowie einen Assembler
:Contents.   benutzen.

--------------------------------------------------------------------------*)

MODULE CompControl;

FROM CCInitWin IMPORT
 MakeMainWindow, EDITG, COMPG, LINKG, START, NAMEG,
 ALLGA, EXT1G, EXT2G, DOITG, ABOUT, FREQG, QUITG, NameSIBuff, UNDOBUFFER,
 MainGadgets;
 
FROM ARP IMPORT
 FileRequester, FileRequest, FileReqFlags, FileReqFlagSet;
 
FROM GetConfig IMPORT
 CCCONFIG, ConfigLesen;
 
FROM Meldung IMPORT
 ShowMeldung;

FROM SYSTEM IMPORT
 ADR, ADDRESS;

IMPORT Terminal;

FROM Arts IMPORT
 BreakPoint, Assert, TermProcedure;
 
FROM Strings IMPORT
 first, last, Copy, Length, Insert, Delete, Occurs;
   
FROM Arguments IMPORT
 NumArgs, GetArg, GetLock;

FROM Intuition IMPORT
 Gadget, GadgetPtr, StringInfo, IDCMPFlags, IDCMPFlagSet, IntuiMessage, 
 IntuiMessagePtr, NewWindow, WindowPtr, OpenWindow, CloseWindow, 
 ActivateGadget, RefreshGadgets, ModifyIDCMP;
 
FROM DOS IMPORT
 Delay, Execute, accessRead, FileLockPtr, FileLock, CurrentDir, Lock,
 Open, Close, FileHandlePtr, readWrite;
 
FROM Exec IMPORT
 GetMsg, ReplyMsg, WaitPort;
 
 

VAR         Konfig          :        CCCONFIG;
            dummy           :        WindowPtr;
            MainW           :        WindowPtr;
            MainNw          :        NewWindow;
            Action, Erfolg  :        INTEGER;            
            Workname        :        ARRAY [0..200] OF CHAR;
            aktEx           :        ARRAY [0..5] OF CHAR;
            aktComp         :        ARRAY [0..30] OF CHAR;
            Pfad            :        ARRAY [0..30] OF CHAR;
            len, num        :        INTEGER;
            OK              :        BOOLEAN;
            FREQ            :        FileRequester;
            StartDir, Leave :        FileLockPtr;
            
                             
PROCEDURE Cleanup;

BEGIN

IF dummy # NIL THEN CloseWindow (dummy);   END;
IF MainW # NIL THEN CloseWindow (MainW);   END;
Leave := CurrentDir (StartDir);

END Cleanup;


PROCEDURE Aboutproc;

VAR         Text             :        ARRAY [0..6],[0..80] OF CHAR;
            Zaehler          :        CARDINAL;
            
BEGIN

Text [0] := "SoftWareArmy prsentiert : |*SwA* CompilerController";
Text [1] := "Version 2.1 vom 21.1.1988|Autor : Ralf Kaiser";
Text [2] := "Dieses Programm ist PD !!|Lat aber bitte meinen Namen drin.";
Text [3] := "DANKE !";

FOR Zaehler := 0 TO 3 DO
 ShowMeldung (dummy, Text[Zaehler], 100);
END;
                     
END Aboutproc;


PROCEDURE AskGadgets (win: WindowPtr): INTEGER;

VAR      msg        :    IntuiMessagePtr;
         msgclass   :    IDCMPFlagSet;
         msgcode    :    CARDINAL;
         gadgetid   :    INTEGER;
         msgadr     :    GadgetPtr;
                    
BEGIN

  WaitPort (win^.userPort);
  msg := GetMsg (win^.userPort);
  msgclass := msg^.class; 
  msgcode := msg^.code;
  msgadr  := msg^.iAddress;
  gadgetid := msgadr^.gadgetID; 
  ReplyMsg (msg);
  
  IF (gadgetUp IN msgclass) THEN
   RETURN gadgetid;
  END;
  
END AskGadgets;
   
   
PROCEDURE DoCommand (Tool: ARRAY OF CHAR;
                     Name : ARRAY OF CHAR;
                     Extension : ARRAY OF CHAR);
                     
VAR       Zeile:     ARRAY [0..100] OF CHAR;

BEGIN

ModifyIDCMP (MainW, IDCMPFlagSet{});
Zeile := "";
Insert (Zeile, last, Tool);
Insert (Zeile, last, Name);
Insert (Zeile, last, Extension);
Erfolg := Execute (ADR(Zeile), NIL, NIL);
ModifyIDCMP (MainW, IDCMPFlagSet{gadgetUp});

END DoCommand;


PROCEDURE MachAlles;

BEGIN

DoCommand (aktComp, Workname, aktEx);
DoCommand (Konfig.Link, Workname, Konfig.Obj);
Erfolg := Execute (ADR(Workname), NIL, NIL);

END MachAlles;



PROCEDURE GetName (VAR Name : ARRAY OF CHAR;
                   VAR Path : ARRAY OF CHAR) : BOOLEAN;

VAR       REQOK       :       ADDRESS;
          TITEL       :       ARRAY [0..26] OF CHAR;
          EX          :       ARRAY [0..10] OF CHAR;
          len, pos    :       INTEGER;
         
BEGIN

TITEL := "Bitte Arbeitstitel whlen";

WITH FREQ DO
 hail := ADR(TITEL);
 ddef := ADR(Name);
 ddir := ADR(Path);
 wind := NIL;
END;

REQOK := FileRequest (ADR(FREQ));

IF REQOK # NIL THEN
 pos := Occurs (Name, 0, ".", FALSE);
 IF pos # last THEN
  Delete (Name, pos, Length (Name)-pos);
 END;
 
(* len := Length (Path);
 IF len # 0 THEN
  IF Path [len - 1] # ":" THEN
   Insert (Path, last, "/");
  END;
  Insert (Name, first, Path);
 END;
 *)
 
 RETURN TRUE;
END;
RETURN FALSE;

END GetName;



PROCEDURE CD (Path: ARRAY OF CHAR);
VAR         NewCurrentD     :        FileLockPtr;
            CurrentD        :        FileLockPtr;
BEGIN
NewCurrentD := Lock (ADR (Path), accessRead);
CurrentD := CurrentDir (NewCurrentD);
END CD;




BEGIN

TermProcedure (Cleanup);
StartDir := GetLock (0);
IF NumArgs() # 0 THEN
 GetArg (1, NameSIBuff, len);
 Copy (Workname, NameSIBuff, 0, len);
END;

MakeMainWindow (MainNw);
MainW := OpenWindow (MainNw);
Assert (MainW # NIL, ADR("Tja, kein Main-Window ! ABBRUCH !!"));
OK := ActivateGadget (ADR(MainGadgets[4]), MainW, NIL);

ConfigLesen (Konfig);
Copy (aktEx, Konfig.End1, 0, Length(Konfig.End1));
Copy (aktComp, Konfig.Comp1, 0, Length(Konfig.Comp1));

REPEAT

 Action := AskGadgets (MainW);
 CASE Action OF
  
   EDITG:     ShowMeldung (dummy, "Start Editor ...", 20);
              DoCommand (Konfig.Editor, Workname, aktEx);
   
  | COMPG:    ShowMeldung (dummy, "Start bersetzer ...", 20);
              DoCommand (aktComp, Workname, aktEx);
              
  | LINKG:    ShowMeldung (dummy, "Start Linker ...", 20);
              DoCommand (Konfig.Link, Workname, Konfig.Obj);
              
  | START:    ShowMeldung (dummy, "Start Programm ...", 20);
              Erfolg := Execute (ADR(Workname), NIL, NIL);

  | NAMEG:    Delete (Workname , 0, last);
              Copy (Workname, NameSIBuff, 0, Length(NameSIBuff));
              
  | ALLGA:    ShowMeldung (dummy, "Start Batch ...", 20);
              MachAlles ();
              
  | EXT1G:    ShowMeldung (dummy, "Extension 1 ist aktiv ...", 20);
              Copy (aktEx, Konfig.End1, 0, Length (Konfig.End1));
             
  | EXT2G:    ShowMeldung (dummy, "Extension 2 ist aktiv ...", 20);
              Copy (aktEx, Konfig.End2, 0, Length(Konfig.End2));
             
  | DOITG:    ShowMeldung (dummy, "Start eines NewCli ...", 20);
              Erfolg := Execute (ADR("NewCli"), NIL, NIL);
              
  | ABOUT:    Aboutproc;
  
  | FREQG:    OK := GetName (Workname, Pfad);
              CD (Pfad);
              IF OK THEN
               Copy (NameSIBuff, Workname, 0, Length(Workname));
               RefreshGadgets (ADR(MainGadgets[4]), MainW, NIL);
              END;
              
  | QUITG:    ShowMeldung (dummy, "Ende !|Bis zum nchsten mal ...", 20);
  
 END;  
 
UNTIL Action = QUITG;

END CompControl.                   
