#ifndef	ARPFUNCTIONS_H
#define ARPFUNCTIONS_H

/* ARPfunctions.h -- declarations of the arp functions for 'C' convenience */
/* Created 11/8/87 by -=+SDB+=- 					   */
/* Corrected to provide function prototypes 11/30/87 by John Toebes        */
/* Corrected function and argument typing errors 1/10/88 -=+SDB+=-         */
/* more corrections, + V33 additions, 2/14/88 -=+SDB+=-			   */

#ifdef __ARGS
#undef	__ARGS
#endif

#ifdef AZTEC_C
#define NO_PRAGMAS 1 /* MANX doesn't support the Builtin Pragmas */
#define __ARGS(a) () /* Nor intelligent prototype checking */
#else
#define __ARGS(a) a  /* Lattice supports full prototype checking */
#endif

#ifndef LIBRARIES_DOS_H
#include <libraries/dos.h>	/* For BPTR declaration */
#endif !LIBRARIES_DOS_H

extern struct ArpBase *ArpBase;

LONG Printf __ARGS( (char *,) );
LONG FPrintf __ARGS( (BPTR, char*,) );
LONG Puts  __ARGS( ( char * ) );
LONG Readline __ARGS( (char *) );
LONG GADS  __ARGS( (char *,long, char *, char **, char *) );
LONG Atol __ARGS( (char *) );
ULONG EscapeString  __ARGS( (char *) );
LONG CheckAbort __ARGS( (void(*)) );
LONG CheckBreak __ARGS( (long, void(*)) );
BYTE *Getenv __ARGS( (char *, char *, long) );
BOOL Setenv __ARGS( (char *, char *) );
BYTE *FileRequest  __ARGS( (struct FileRequester *) );
VOID CloseWindowSafely __ARGS( (struct Window *, long) );
struct MsgPort	*CreatePort __ARGS( (char *, LONG) );
VOID DeletePort  __ARGS( (struct MsgPort *) );
LONG SendPacket  __ARGS( (long, long *, struct MsgPort *) );
VOID InitStdPacket __ARGS( (long, long *, struct DosPacket *, struct MsgPort *) );
ULONG PathName __ARGS( (BPTR, char *,long) );
ULONG Assign __ARGS( (char *, char *) );
VOID *DosAllocMem __ARGS( (long) );
VOID DosFreeMem __ARGS( (VOID *) );
ULONG BtoCStr __ARGS( (char *, BSTR, long) );
ULONG CtoBStr __ARGS( (char *, BSTR, long) );
struct DeviceList *GetDevInfo __ARGS( (struct DeviceList *) );
BOOL FreeTaskResList __ARGS( (void) );
VOID ArpExit  __ARGS( (long,long) );
VOID *ArpAlloc __ARGS( (long) );
VOID *ArpAllocMem __ARGS( (long, long) );
BPTR ArpOpen __ARGS( (char *, long) );
BPTR ArpDupLock __ARGS( (BPTR) );
BPTR ArpLock __ARGS( (char *, long) );
VOID *RListAlloc __ARGS( ( struct ArpResList *, long) );
struct Process *FindCLI __ARGS( (long) );
BOOL QSort __ARGS( (void *, long, long, int(*)) );
BOOL PatternMatch __ARGS( (char *,char *) );
LONG FindFirst __ARGS( (char *, struct AnchorPath *) );
LONG FindNext __ARGS( (struct AnchorPath *) );
VOID FreeAnchorChain __ARGS( (struct AnchorPath *) );
ULONG CompareLock __ARGS( (BPTR, BPTR) );
struct ArpResList *FindTaskResList __ARGS( (void) );
struct ArpResList *CreateTaskResList __ARGS( (void) );
VOID FreeResList __ARGS( (struct ArpResList *) );
VOID FreeTrackedItem __ARGS( (struct DefaultTracker *) );
struct DefaultTracker *GetTracker __ARGS( (long) );
VOID *GetAccess __ARGS( (struct DefaultTracker *) );
VOID FreeAccess __ARGS( (struct DefaultTracker *) );
VOID FreeDAList __ARGS( (struct DirectoryEntry *) );
struct DirectoryEntry *AddDANode __ARGS( (char *, struct DirectoryEntry **, long, long) );
ULONG AddDADevs __ARGS( (struct DirectoryEntry **, long) );
LONG Strcmp __ARGS( (char *, char *) );
LONG Strncmp __ARGS( (char *, char *, long) );
BYTE Toupper __ARGS( (BYTE) );
LONG SyncRun __ARGS( (char *, char *, BPTR, BPTR) );
/* Version 32+ stuff */
LONG ASyncRun __ARGS( (char *, char *, struct ProcessControlBlock *) );
BPTR LoadPrg __ARGS( (char *) );
BOOL PreParse __ARGS( (char *, char *) );
BOOL StamptoStr __ARGS( (struct DateTime *) );
BOOL StrtoStamp __ARGS( (struct DateTime *) );
struct ResidentProgramNode *ObtainResidentPrg __ARGS( (char *) );
struct ResidentProgramNode *AddResidentPrg __ARGS( (BPTR, char *) );
LONG RemResidentPrg __ARGS( (char *) );
VOID UnLoadPrg __ARGS( (BPTR) );
LONG LMult __ARGS( (LONG, LONG) );
LONG LDiv __ARGS( (LONG, LONG) );
LONG LMod __ARGS( (LONG, LONG) );
ULONG CheckSumPrg __ARGS( (struct ResidentProgramNode *) );
VOID TackOn __ARGS( (char *, char *));
BYTE *BaseName __ARGS( (char *) );
struct ResidentProgramNode *ReleaseResidentPrg __ARGS( (BPTR) );

#ifndef NO_PRAGMAS
#include "libraries/arp_pragmas.h"
#endif !NO_PRAGMAS

#undef __ARGS
#endif !ARPFUNCTIONS_H

