(*---------------------------------------------------------------------------
    :Program.    DevsDemo.mod
    :Author.     Fridtjof Siebert
    :Address.    Nobileweg 67, D-7-Stgt-40
    :Shortcut.   [fbs]
    :Version.    1.0
    :Date.       14-Jan-88
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga v3.1d
    :Imports.    arp.library
    :Contents.   example for use of ARP.AddDADevs & ARP.FreeDAList.
---------------------------------------------------------------------------*)

MODULE DevsDemo;

FROM SYSTEM IMPORT ADR;
FROM ARP    IMPORT AddDADevs, FreeDAList, DirectoryEntryPtr, DirEntryTypes,
                   DirEntryTypeSet;
FROM InOut  IMPORT WriteString, WriteLn, WriteInt;

VAR
  Head: DirectoryEntryPtr;
  DEPtr: DirectoryEntryPtr;
  numEntries: INTEGER;

BEGIN
  WriteString("List of Mounted Disk-Devices:  # ");
  (* Get Devices: *)
  Head := NIL;
  WriteInt(AddDADevs(ADR(Head),DirEntryTypeSet{devices,diskonly}),4); WriteLn;
  DEPtr := Head;
  WHILE DEPtr#NIL DO
    WriteString(DEPtr^.name); WriteLn;     (* Write volume name         *)
    DEPtr := DEPtr^.next;                  (* next volume               *)
  END;
  FreeDAList(Head);                        (* free list's memory        *)
END DevsDemo.
