(*---------------------------------------------------------------------------
    :Program.    PatternDemo.mod
    :Author.     Fridtjof Siebert
    :Address.    Nobileweg 67, D-7-Stgt-40
    :Shortcut.   [fbs]
    :Version.    1.0
    :Date.       31-Dec-88 03:48:57
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga v3.1d
    :Imports.    arp.library
    :Contents.   example for use of ARP.FindFirst and ARP.FindNext
---------------------------------------------------------------------------*)

MODULE PatternDemo;

FROM SYSTEM IMPORT ADR;
FROM ARP    IMPORT StdAnchorPathPtr, FindFirst, FindNext, FreeAnchorChain,
                   ArpAlloc, AnchorPathPtr, stdAnchorSize;
FROM InOut  IMPORT WriteString, ReadString, WriteLn;

VAR
  ap: StdAnchorPathPtr;
  Pattern: ARRAY[0..79] OF CHAR;

BEGIN
  WriteString(" Please enter a Pattern (e.g. DF0:*/*.in?o): ");
  ReadString(Pattern);
  ap := ArpAlloc(SIZE(ap^));                            (* get anchorbase    *)
  IF ap=NIL THEN
    WriteString("No memory!"); WriteLn;
  ELSE
    ap^.anchor.length := stdAnchorSize;                 (* set buffer length *)
    IF FindFirst(ADR(Pattern),AnchorPathPtr(ap))=0 THEN (* get first match   *)
      REPEAT
        WriteString(ap^.buffer); WriteLn;               (* print pattern     *)
      UNTIL FindNext(AnchorPathPtr(ap))#0;              (* get next one      *)
    END;
    FreeAnchorChain(AnchorPathPtr(ap));                 (* free chain        *)
    WriteString("Done"); WriteLn;                       (* That's it         *)
  END;
END PatternDemo.
