(**********************************************************************

    :Program.    Detach.mod
    :Contents.   Sets position of icons to noIconPosition
    :Author.     Nicolas Benezan [bne]
    :Address.    Postwiesenstr. 2, D7000 Stuttgart 60
    :Phone.      711/333679
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga A+L V3.2d (do not use V3.11 or older !!!)
    :History.    V1.0c [bne] 21.Feb.1989

**********************************************************************)

MODULE Detach;

FROM Arguments  IMPORT NumArgs,GetArg,GetLock;
FROM Dos        IMPORT Examine,UnLock,FileInfoBlockPtr,FileInfoBlock,
                FileLockPtr,ParentDir,CurrentDir;
FROM Exec       IMPORT AllocMem,FreeMem,MemReqSet;
FROM Icon       IMPORT GetDiskObject,PutDiskObject,FreeDiskObject;
FROM Workbench  IMPORT DiskObjectPtr,noIconPosition;
FROM SYSTEM     IMPORT ADR,ADDRESS;

TYPE    Name=ARRAY [0..31] OF CHAR;

VAR     IconName:Name;
        IconNamePtr:POINTER TO Name;
        Nr,Len:INTEGER;
        Info:FileInfoBlockPtr;
        Dir,Parent,OldDir:FileLockPtr;

PROCEDURE DetachIcon(Name:ADDRESS);
VAR     Icon:DiskObjectPtr;
BEGIN
  Icon:=GetDiskObject(Name);
  IF Icon#NIL THEN
    WITH Icon^ DO
      currentX:=noIconPosition;
      currentY:=noIconPosition;
    END;
    IF PutDiskObject(Name,Icon)#0 THEN END;
    FreeDiskObject(Icon);
  END;
END DetachIcon;

BEGIN
  Info:=AllocMem(SIZE(FileInfoBlock),MemReqSet{});
  IF Info#NIL THEN
    FOR Nr:=1 TO NumArgs() DO
      GetArg(Nr,IconName,Len);
      IF Len=0 THEN
        Dir:=GetLock(Nr);
        IF Examine(Dir,Info) THEN
          Parent:=ParentDir(Dir);
          IF Parent=NIL THEN (* disk root dir *)
            DetachIcon(ADR("Disk")); (* Disk.info *)
          ELSE
            OldDir:=CurrentDir(Parent);
            DetachIcon(ADR(Info^.fileName));
            OldDir:=CurrentDir(OldDir);
            UnLock(Parent);
          END;
        END;
        UnLock(Dir);
      ELSE
        DetachIcon(ADR(IconName));
      END;
    END;
    FreeMem(Info,SIZE(FileInfoBlock));
  END;
END Detach.


