(*---------------------------------------------------------------------------
   :Program.    Kurve
   :Author.     Jrg Wesemann
   :Address.    Auf der Heide 10, 2807 Achim - Baden
   :Phone.      (0)4202 / 70658
   :Shortcut.   [jwe]
   :Version.    2.94
   :Date.       23.03.89
   :Copyright.  PD
   :Language.   Modula-II
   :Translator. M2Amiga
   :Imports.    none.
   :Update.     none.
   :Contents.   Intervalleingaberoutinen
   :Remark.     none
---------------------------------------------------------------------------*)



IMPLEMENTATION MODULE intervall ;

FROM Arts 		IMPORT 	Assert;
FROM SYSTEM 		IMPORT 	ADDRESS,ADR;
FROM Intuition 		IMPORT 	ScreenFlags,ScreenFlagSet,NewWindow,WindowPtr,
		      		IDCMPFlags,IDCMPFlagSet,WindowFlags,strGadget,
                                WindowFlagSet,OpenWindow,CloseWindow,Border,
                                IntuiMessage,Gadget,GadgetFlags,GadgetFlagSet,
                                ActivationFlags,boolGadget,ActivationFlagSet,
                                StringInfo,IntuiText,Image;
FROM Graphics 		IMPORT 	Text,Move,jam1,RastPortPtr,Draw,SetAPen;
FROM Exec 		IMPORT 	GetMsg,ReplyMsg,WaitPort,FreeMem,UByte;
FROM Strings 		IMPORT 	Length ;
FROM InOut 		IMPORT 	WriteLn,WriteString,WriteInt;
FROM startupproc 	IMPORT 	stringbuffergr,stringbufferkl,STRING;
FROM imagedata 		IMPORT 	okimagedata,okhimagedata,CopyToChip,oksize,
				okhsize,CARDPTR;


  VAR
    ok,okh			  : Image;
    imageptr,himageptr		  : CARDPTR;

  PROCEDURE rand(rast: RastPortPtr; x,y,dx,dy: INTEGER);

  BEGIN
    Move(rast,x,y);
    Draw(rast,x+dx,y);
    Draw(rast,x+dx,y+dy);
    Draw(rast,x,y+dy);
    Draw(rast,x,y);
  END rand;


  PROCEDURE fktstring(VAR Buffer: STRING;art: CARDINAL);

    CONST
      stringfkt     	= 1 ;
      booleangadget 	= 2 ;
        
    VAR 
      MyWindow    		: NewWindow ;
      MyWindowPtr         	: WindowPtr ;
      class			: IDCMPFlagSet ;
      IntuiMsg    		: POINTER TO IntuiMessage ;
      myintuitext		: IntuiText ;
      gad,gad2 			: Gadget ;
      Info 			: StringInfo ;
      Rahmen			: Border;
      xyFeld			: ARRAY [0..9]  OF INTEGER ;
      UndoBuffer		: STRING;
      rp			: RastPortPtr;
     
  BEGIN
    WITH MyWindow DO
      leftEdge:= 0; topEdge:= 0;       
      width:= 640; height:= 256;
      detailPen:= 0; blockPen:= 0;
      idcmpFlags:= IDCMPFlagSet{gadgetUp}; 
      flags:= WindowFlagSet{};  
      firstGadget:=  ADR(gad);
      checkMark:= NIL;
      title:= ADR("Eingabe der Funktion");
      bitMap:= NIL;
      type:= ScreenFlagSet{wbenchScreen};
      minWidth:= 640; maxWidth:= 640;
      minHeight:= 256; maxHeight:= 256;     
    END;
    WITH Rahmen DO				
      leftEdge:= -1; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1;
      count:= 5; xy:= ADR(xyFeld);
      nextBorder:= NIL;
    END;
    xyFeld[0]:= 0;   xyFeld[1]:= 0;
    xyFeld[2]:= 261; xyFeld[3]:= 0;
    xyFeld[4]:= 261; xyFeld[5]:= 11;
    xyFeld[6]:= 0;   xyFeld[7]:= 11;
    xyFeld[8]:= 0;   xyFeld[9]:= 0;
    UndoBuffer:= " ";
    WITH Info DO
      buffer:= ADR(Buffer); undoBuffer:= ADR(UndoBuffer);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END; 
    WITH gad DO			
      nextGadget:= ADR(gad2);
      leftEdge:= 220; topEdge:= 120;
      width:= 260; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info);
      gadgetID:= stringfkt;
      userData:= NIL;
    END;
    CopyToChip(ADR(okimagedata),imageptr,oksize);
    CopyToChip(ADR(okhimagedata),himageptr,okhsize);
    WITH ok DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= imageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH okh DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= himageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH gad2 DO
      nextGadget:= NIL;
      leftEdge:= 280; topEdge:= 205;
      width:= 80; height:= 20;
      flags:= GadgetFlagSet{gadgImage,gadgHImage};
      activation:= ActivationFlagSet{gadgImmediate,relVerify};
      gadgetType:= boolGadget;
      gadgetRender:= ADR(ok); selectRender:= ADR(okh); 
      gadgetText:= NIL; specialInfo:= NIL;
      gadgetID:= booleangadget;
      userData:= NIL;
    END;
    MyWindowPtr:= OpenWindow(MyWindow);
    Assert(MyWindowPtr # NIL, ADR("Fenster nicht geffnet"));
    rp:= MyWindowPtr^.rPort;
    rand(rp,100,60,440,100);
    Move(rp,100,90); Draw(rp,540,90);
    CASE art OF  
      | 1 : Move(rp,145,79);
      	    Text(rp,ADR("E I N G A B E  der festen Integrationsgrenze"),44);
     	    Move(rp,160,126);
      	    Text(rp,ADR("A =  "),5);
      | 2 : Move(rp,210,79);
      	    Text(rp,ADR("E I N G A B E  der Funktion"),27);
     	    Move(rp,150,126);
            Text(rp,ADR("f(x) =  "),8);
      | 3 : Move(rp,200,79);
      	    Text(rp,ADR("E I N G A B E  des Dateinamens"),30);
    END;
    SetAPen(rp,2);
    rand(rp,104,62,432,26);
    rand(rp,104,92,432,66);
    SetAPen(rp,1);
    LOOP
      WaitPort(MyWindowPtr^.userPort); 
      IntuiMsg:= GetMsg(MyWindowPtr^.userPort);
      class:= IntuiMsg^.class;
      ReplyMsg(IntuiMsg);
      IF ( class=IDCMPFlagSet{gadgetUp} ) OR 
         ( class=IDCMPFlagSet{closeWindow} ) THEN
        EXIT;
      END;
    END;				
    CloseWindow(MyWindowPtr);
    FreeMem(imageptr,oksize);
    FreeMem(himageptr,okhsize);
  END fktstring;


  PROCEDURE kleinintervall(VAR Buffer: stringbufferkl;Titeladr: ADDRESS);

    CONST
      stringxmin  	= 1;
      stringxmax  	= 3;
      stringdx    	= 2;
      stringart   	= 4;
      booleangadget 	= 5;
         
    VAR 
      MyWindow    		  : NewWindow;
      MyWindowPtr         	  : WindowPtr;
      class			  : IDCMPFlagSet;
      IntuiMsg    		  : POINTER TO IntuiMessage;
      myintuitext		  : IntuiText;
      gadarray 			  : ARRAY [1..5] OF Gadget;
      Info 			  : ARRAY [1..4] OF StringInfo;
      Rahmen 			  : ARRAY [1..3] OF Border;
      xyFeld 			  : ARRAY [1..3],[0..9]  OF INTEGER;
      UndoBuffer		  : stringbufferkl;
      rp			  : RastPortPtr;
    
  BEGIN 
    WITH MyWindow DO
      leftEdge:= 0; topEdge:= 0;         
      width:= 640; height:= 256;            
      detailPen:= 0; blockPen:= 0;          
      idcmpFlags:= IDCMPFlagSet{gadgetUp}; 
      flags:= WindowFlagSet{};  
      firstGadget:=  ADR(gadarray[1]);
      checkMark:= NIL;
      title:= Titeladr;
      bitMap:= NIL;
      type:= ScreenFlagSet{wbenchScreen};
      minWidth:= 640; maxWidth:= 640;
      minHeight:= 256; maxHeight:= 256;     
    END;
    WITH Rahmen[1] DO
      leftEdge:= -1; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1;
      count:= 5; xy:= ADR(xyFeld[1]);
      nextBorder:= NIL;
    END;
    xyFeld[1,0]:= 0;   xyFeld[1,1]:= 0;
    xyFeld[1,2]:= 191; xyFeld[1,3]:= 0;
    xyFeld[1,4]:= 191; xyFeld[1,5]:= 11;
    xyFeld[1,6]:= 0;   xyFeld[1,7]:= 11;
    xyFeld[1,8]:= 0;   xyFeld[1,9]:= 0;
    UndoBuffer[1]:= " ";
    WITH Info[1] DO
       buffer:= ADR(Buffer[1,0]); undoBuffer:= ADR(UndoBuffer[1,0]);
       bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[1] DO
      nextGadget:= ADR(gadarray[2]);
      leftEdge:= 100; topEdge :=120;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[1]);
      gadgetID:= stringxmin;
      userData:= NIL;
    END;
    UndoBuffer[2]:= " ";
    WITH Info[2] DO
       buffer:= ADR(Buffer[2,0]); undoBuffer:= ADR(UndoBuffer[2,0]);
       bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[2] DO
      nextGadget:= ADR(gadarray[3]) ;
      leftEdge:= 225; topEdge :=168;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[2]);
      gadgetID:= stringdx;
      userData:= NIL;
    END;
    UndoBuffer[3]:= " ";
    WITH Info[3] DO
      buffer:= ADR(Buffer[3,0]); undoBuffer:= ADR(UndoBuffer[3,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[3] DO
      nextGadget:= ADR(gadarray[4]);
      leftEdge:= 350; topEdge :=120;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[3]);
      gadgetID:= stringxmax;
      userData:= NIL;
    END;
    WITH Rahmen[2] DO 
      leftEdge:= -2; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1; 
      count:= 5; xy:= ADR(xyFeld[2,0]);
      nextBorder:= NIL;
    END;
    xyFeld[2,0]:= 0  ; xyFeld[2,1]:= 0 ;
    xyFeld[2,2]:= 32 ; xyFeld[2,3]:= 0 ;
    xyFeld[2,4]:= 32 ; xyFeld[2,5]:= 11;
    xyFeld[2,6]:= 0  ; xyFeld[2,7]:= 11;
    xyFeld[2,8]:= 0  ; xyFeld[2,9]:= 0 ;
    UndoBuffer[4]:= " ";
    WITH Info[4] DO
      buffer:= ADR(Buffer[4,0]); undoBuffer:= ADR(UndoBuffer[4,0]);
      bufferPos:= 0; maxChars:= 10; dispPos:= 0;
    END;
    WITH gadarray[4] DO
      nextGadget:= ADR(gadarray[5]);
      leftEdge:= 305; topEdge :=78;
      width:= 30; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[2]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[4]);
      gadgetID:= stringart;
      userData:= NIL;
    END;
    CopyToChip(ADR(okimagedata),imageptr,oksize);
    CopyToChip(ADR(okhimagedata),himageptr,okhsize);
    WITH ok DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= imageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH okh DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= himageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH gadarray[5] DO
      nextGadget:= NIL;
      leftEdge:= 280; topEdge :=220;
      width:= 80; height:= 20;
      flags:= GadgetFlagSet{gadgImage,gadgHImage};
      activation:= ActivationFlagSet{toggleSelect,gadgImmediate,relVerify};
      gadgetType:= boolGadget;
      gadgetRender:= ADR(ok); selectRender:= ADR(okh); 
      gadgetText:= NIL; specialInfo:= NIL;
      gadgetID:= booleangadget;
      userData:= NIL;
    END;
    MyWindowPtr:= OpenWindow(MyWindow);
    Assert(MyWindowPtr # NIL, ADR("Fenster nicht geffnet"));
    rp:= MyWindowPtr^.rPort;
    Move(rp,215,35); Text(rp,ADR("E I N G A B E  des Intervalls"),29);
    rand(rp,70,20,500,183);
    Move(rp,70,44); Draw(rp,570,44);
    SetAPen(rp,2);
    rand(rp,74,22,492,20);
    rand(rp,74,46,492,155);
    Move(rp,180,115); Text(rp,ADR("Xmin"),4);
    Move(rp,430,115); Text(rp,ADR("Xmax"),4);
    Move(rp,305,163); Text(rp,ADR("dX"),2);
    Move(rp,306,73); Text(rp,ADR("Art"),3); 
    LOOP
      WaitPort(MyWindowPtr^.userPort); 
      IntuiMsg:= GetMsg(MyWindowPtr^.userPort);
      class:= IntuiMsg^.class;
      ReplyMsg(IntuiMsg);
      IF ( class=IDCMPFlagSet{gadgetUp} ) OR 
         ( class=IDCMPFlagSet{closeWindow} ) THEN
        EXIT;
      END;						(* IF 1		*)
    END;						(* LOOP 1	*)
    CloseWindow(MyWindowPtr);
    FreeMem(imageptr,oksize);
    FreeMem(himageptr,okhsize);
  END kleinintervall;


  PROCEDURE grossintervall(VAR Buffer: stringbuffergr );

    CONST 
      stringymax  	= 1;
      stringymin 	= 2;
      stringxmin  	= 3;
      stringxmax  	= 4;
      stringdx    	= 5;
      stringdy    	= 6;
      stringabl   	= 7;
      stringpkt   	= 8;
      stringgenau 	= 9;
      booleangadget 	= 10;
         
    VAR 
      MyWindow    			  : NewWindow;
      MyWindowPtr         		  : WindowPtr;
      class				  : IDCMPFlagSet;
      IntuiMsg    			  : POINTER TO IntuiMessage;
      gadarray 				  : ARRAY [1..10] OF Gadget;
      Info 				  : ARRAY [1..9] OF StringInfo;
      Rahmen 				  : ARRAY [1..3] OF Border;
      xyFeld 				  : ARRAY [1..10],[0..9]  OF INTEGER;
      UndoBuffer			  : stringbuffergr;
      rp				  : RastPortPtr;
    
  BEGIN 
    WITH MyWindow DO
      leftEdge:= 0; topEdge:= 0;         
      width:= 640; height:= 256;         
      detailPen:= 0; blockPen:= 0;       
      idcmpFlags:= IDCMPFlagSet{gadgetUp}; 
      flags:= WindowFlagSet{};  
      firstGadget:= ADR(gadarray[1]);
      checkMark:= NIL;
      title:= ADR("PLOTTER - Intervalleingabe");
      bitMap:= NIL;
      type:= ScreenFlagSet{wbenchScreen};
      minWidth:= 640; maxWidth:= 640;
      minHeight:= 256; maxHeight:= 256;     
    END;
    WITH Rahmen[1] DO 
      leftEdge:= -2; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1; 
      count:= 5; xy:= ADR(xyFeld[1,0]);
      nextBorder:= NIL;
    END;
    xyFeld[1,0]:=   0; xyFeld[1,1]:=  0;
    xyFeld[1,2]:= 191; xyFeld[1,3]:=  0;
    xyFeld[1,4]:= 191; xyFeld[1,5]:= 11;
    xyFeld[1,6]:=   0; xyFeld[1,7]:= 11;
    xyFeld[1,8]:=   0; xyFeld[1,9]:=  0;
    UndoBuffer[1]:= " ";
    WITH Info[1] DO
      buffer:= ADR(Buffer[1,0]); undoBuffer:= ADR(UndoBuffer[1,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[1] DO
      nextGadget:= ADR(gadarray[2]);
      leftEdge:= 225; topEdge :=70;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[1]);
      gadgetID:= stringymax;
      userData:= NIL;
    END;
    UndoBuffer[2]:= " ";
    WITH Info[2] DO
      buffer:= ADR(Buffer[2,0]); undoBuffer:= ADR(UndoBuffer[2,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[2] DO
      nextGadget:= ADR(gadarray[3]);
      leftEdge:= 225; topEdge :=132;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[2]);
      gadgetID:= stringymin;
      userData:= NIL;
    END;
    UndoBuffer[3]:= " ";
    WITH Info[3] DO
      buffer:= ADR(Buffer[3,0]); undoBuffer:= ADR(UndoBuffer[3,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[3] DO
      nextGadget:= ADR(gadarray[4]);
      leftEdge:= 100; topEdge :=101;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[3]);
      gadgetID:= stringxmin;
      userData:= NIL;
    END;
    UndoBuffer[4]:= " ";
    WITH Info[4] DO
      buffer:= ADR(Buffer[4,0]); undoBuffer:= ADR(UndoBuffer[4,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[4] DO
      nextGadget:= ADR(gadarray[5]);
      leftEdge:= 350; topEdge :=101;
      width:= 190; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[1]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[4]);
      gadgetID:= stringxmax;
      userData:= NIL;
    END;
    WITH Rahmen[2] DO 
      leftEdge:= -2; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1; 
      count:= 5; xy:= ADR(xyFeld[2,0]);
      nextBorder:= NIL;
    END;
    xyFeld[2,0]:=  0; xyFeld[2,1]:=  0;
    xyFeld[2,2]:= 82; xyFeld[2,3]:=  0;
    xyFeld[2,4]:= 82; xyFeld[2,5]:= 11;
    xyFeld[2,6]:=  0; xyFeld[2,7]:= 11;
    xyFeld[2,8]:=  0; xyFeld[2,9]:=  0;
    UndoBuffer[5]:= " ";
    WITH Info[5] DO
      buffer:= ADR(Buffer[5,0]); undoBuffer:= ADR(UndoBuffer[5,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[5] DO
      nextGadget:= ADR(gadarray[6]);
      leftEdge:= 80; topEdge :=185;
      width:= 80; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[2]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[5]);
      gadgetID:= stringdx;
      userData:= NIL;
    END;        
    UndoBuffer[6]:= " ";
    WITH Info[6] DO
      buffer:= ADR(Buffer[6,0]); undoBuffer:= ADR(UndoBuffer[6,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[6] DO
      nextGadget:= ADR(gadarray[7]);
      leftEdge:= 190; topEdge :=185;
      width:= 80; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[2]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[6]);
      gadgetID:= stringdy;
      userData:= NIL;
    END;        
    WITH Rahmen[3] DO 
      leftEdge:= -2; topEdge:= -2;
      frontPen:= 1; backPen:= 0;
      drawMode:= jam1; 
      count:= 5; xy:= ADR(xyFeld[3,0]);
      nextBorder:= NIL;
    END;
    xyFeld[3,0]:=  0; xyFeld[3,1]:=  0;
    xyFeld[3,2]:= 62; xyFeld[3,3]:=  0;
    xyFeld[3,4]:= 62; xyFeld[3,5]:= 11;
    xyFeld[3,6]:=  0; xyFeld[3,7]:= 11;
    xyFeld[3,8]:=  0; xyFeld[3,9]:=  0;
    UndoBuffer[7]:= " ";
    WITH Info[7] DO
      buffer:= ADR(Buffer[7,0]); undoBuffer:= ADR(UndoBuffer[7,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[7] DO
      nextGadget:= ADR(gadarray[8]);
      leftEdge:= 325; topEdge :=185;
      width:= 60; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[3]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[7]);
      gadgetID:= stringabl;
      userData:= NIL;
    END;       
    UndoBuffer[8]:= " ";
    WITH Info[8] DO
      buffer:= ADR(Buffer[8,0]); undoBuffer:= ADR(UndoBuffer[8,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[8] DO
      nextGadget:= ADR(gadarray[9]);
      leftEdge:= 415; topEdge :=185;
      width:= 60; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{toggleSelect,stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[3]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[8]);
      gadgetID:= stringpkt;
      userData:= NIL;
    END;        
    UndoBuffer[9]:= " ";
    WITH Info[9] DO
      buffer:= ADR(Buffer[9,0]); undoBuffer:= ADR(UndoBuffer[9,0]);
      bufferPos:= 0; maxChars:= 40; dispPos:= 0;
    END;
    WITH gadarray[9] DO
      nextGadget:= ADR(gadarray[10]);
      leftEdge:= 505; topEdge :=185;
      width:= 60; height:= 10;
      flags:= GadgetFlagSet{};
      activation:= ActivationFlagSet{stringCenter};
      gadgetType:= strGadget;
      gadgetRender:= ADR(Rahmen[3]); selectRender:= NIL; 
      gadgetText:= NIL; specialInfo:= ADR(Info[9]);
      gadgetID:= stringgenau;
      userData:= NIL;
    END;        
    CopyToChip(ADR(okimagedata),imageptr,oksize);
    CopyToChip(ADR(okhimagedata),himageptr,okhsize);
    WITH ok DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= imageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH okh DO
      leftEdge:= 0; topEdge:= 0; width:= 80; height:= 20; depth:=2;
      imageData:= himageptr; planePick:= 3; planeOnOff:= 0;
      nextImage:= NIL;
    END;
    WITH gadarray[10] DO
      nextGadget:= NIL;
      leftEdge:= 280; topEdge:= 230;
      width:= 80; height:= 20;
      flags:= GadgetFlagSet{gadgImage,gadgHImage};
      activation:= ActivationFlagSet{gadgImmediate,relVerify,toggleSelect};
      gadgetType:= boolGadget;
      gadgetRender:= ADR(ok); selectRender:= ADR(okh); 
      gadgetText:= NIL; specialInfo:= NIL;
      gadgetID:= booleangadget;
      userData:= NIL;
    END;
    MyWindowPtr:= OpenWindow(MyWindow);
    Assert(MyWindowPtr # NIL, ADR("Fenster nicht geffnet"));
    rp:= MyWindowPtr^.rPort;
    Move(rp,185,29);  Text(rp,ADR("P L O T T E R    Intervalleingabe"),33); 
    rand(rp,50,10,543,210);
    Move(rp,50,40); Draw(rp,593,40); 
    SetAPen(rp,2);  
    Move(rp,300,90);  Text(rp,ADR("Ymax"),4);
    Move(rp,177,122); Text(rp,ADR("Xmin"),4);
    Move(rp,427,122); Text(rp,ADR("Xmax"),4);
    Move(rp,300,153); Text(rp,ADR("Ymin"),4);
    Move(rp,110,206); Text(rp,ADR("dX"),2);
    Move(rp,220,206); Text(rp,ADR("dY"),2);
    Move(rp,330,206); Text(rp,ADR("Abltg."),6);
    Move(rp,420,206); Text(rp,ADR("Punkte"),6);
    Move(rp,512,206); Text(rp,ADR("Genau"),5);
    rand(rp,54,12,535,26);
    rand(rp,54,42,535,176);
    LOOP
      WaitPort(MyWindowPtr^.userPort); 
      IntuiMsg:= GetMsg(MyWindowPtr^.userPort);
      class:= IntuiMsg^.class;
      ReplyMsg(IntuiMsg);
      IF ( class=IDCMPFlagSet{gadgetUp} ) OR 
         ( class=IDCMPFlagSet{closeWindow} ) THEN
        EXIT;
      END;
    END;
    CloseWindow(MyWindowPtr);
    FreeMem(imageptr,oksize);
    FreeMem(himageptr,okhsize);
  END grossintervall;

END intervall.
