(*---------------------------------------------------------------------------
   :Program.    Kurve
   :Author.     Jrg Wesemann
   :Address.    Auf der Heide 10, 2807 Achim - Baden
   :Phone.      (0)4202 / 70658
   :Shortcut.   [jwe]
   :Version.    2.94
   :Date.       23.03.89
   :Copyright.  PD
   :Language.   Modula-II
   :Translator. M2Amiga
   :Imports.    JWELib: Parser
   :Update.     none.
   :Contents.   Berechnet die Nullstellen einer Funktion in einem Intervall
   :Remark.     none.
---------------------------------------------------------------------------*)


IMPLEMENTATION MODULE nullstellen;

FROM SYSTEM 		IMPORT 	FFP,ADR;
FROM FFPInOut 		IMPORT 	WriteReal,ReadReal;
FROM InOut 		IMPORT 	Write,WriteString,WriteLn,WriteCard,OpenOutput,
				CloseOutput;
FROM startupproc 	IMPORT 	CLS,crlf,cursorr,solve,m,n,nullbuffer,string,
				dateiabfrage,center,fragedatei,wptr;
FROM intervall 		IMPORT 	kleinintervall;
FROM JWELib 		IMPORT 	parse;    
FROM Strings 		IMPORT 	Length;
FROM menu 		IMPORT 	wartemenu;
FROM Intuition		IMPORT	WindowToFront;


PROCEDURE nullstellen;
  
  CONST
    MAXFOUND = 20;
    
  VAR
    x,dx,xmin,xmax 	: FFP;
    success        	: BOOLEAN;
    zaehler,art 	: CARDINAL;

BEGIN
  nullbuffer[2]:= "0.2";
  kleinintervall(nullbuffer,ADR("NULLSTELLEN - Intervall"));
  xmin:= parse(nullbuffer[1],0.0);
  dx:=   parse(nullbuffer[2],0.0);
  xmax:= parse(nullbuffer[3],0.0);
  art:=  CARDINAL(parse(nullbuffer[4],0.0));
  WindowToFront(wptr);
  Write(CLS);
  IF dateiabfrage THEN
    fragedatei();
  END;  
  center("N U L L S T E L L E N"); WriteLn;
  center("---------------------"); crlf(2);
  center("von"); crlf(2);
  cursorr( 20+(31-Length(string)) DIV 2 );
  WriteString("f(x) = ");
  WriteString(string); crlf(3);  
  cursorr(23); WriteString("Xmin: "); WriteReal(xmin,m,n); cursorr(5);
  WriteString("Xmax: "); WriteReal(xmax,m,n); crlf(3);
  zaehler:= 0;
  success:= FALSE;
  x:= solve(xmin,xmax,dx,0,art,success);
  IF success THEN
    REPEAT
      INC(zaehler);
      cursorr(26);
      WriteCard(zaehler,3);
      WriteString(".    N ( "); WriteReal(x,m,n);WriteString("  , 0 )");WriteLn;
      xmin:= x + dx;
      x:= solve(xmin,xmax,dx,0,art,success);
    UNTIL ( NOT success OR (x>xmax) OR (zaehler>MAXFOUND) );
  ELSE							(* IF 1		*)
    center("Keine Nullstelle gefunden"); WriteLn;
  END;							(* IF 1		*)
  WriteLn;
  CloseOutput;
  crlf(3);
  center("Bitte 'RETURN' drcken fr MENU ");
  wartemenu;
END nullstellen;


END nullstellen.
