(*---------------------------------------------------------------------------
   :Program.    Kurve
   :Author.     Jrg Wesemann
   :Address.    Auf der Heide 10, 2807 Achim - Baden
   :Phone.      (0)4202 / 70658
   :Shortcut.   [jwe]
   :Version.    2.94
   :Date.       23.03.89
   :Copyright.  PD
   :Language.   Modula-II
   :Translator. M2Amiga
   :Imports.    JWELib: Parser
   :Update.     none.
   :Contents.   Erstellt eine WWertetabelle der Funktion/Integralfunktion
   :Remark.     none.
---------------------------------------------------------------------------*)


IMPLEMENTATION MODULE wertetabelle;

FROM SYSTEM 		IMPORT	FFP,ADR;
FROM FFPInOut 		IMPORT	WriteReal, ReadReal;
FROM InOut 		IMPORT	Write,WriteString,WriteLn,WriteCard,OpenOutput,
				CloseOutput;
FROM startupproc 	IMPORT	CLS,crlf,cursorr,m,n,fn,nullbuffer,center,intf,
				string,dateiabfrage,festgrenzestr,fragedatei,
				wptr;
FROM intervall		IMPORT	kleinintervall,fktstring;
FROM JWELib 		IMPORT	parse;
FROM Strings 		IMPORT	Length;
FROM menu		IMPORT	wartemenu;
FROM Intuition		IMPORT  WindowToFront;

PROCEDURE wertetabelle;

VAR
  x,dx,xmin,xmax: FFP;

BEGIN
  nullbuffer[2]:= "1.0";
  kleinintervall(nullbuffer,ADR("WERTETABELLE - Intervall"));
  xmin:= parse(nullbuffer[1],0.0);
  dx:=   parse(nullbuffer[2],0.0);
  xmax:= parse(nullbuffer[3],0.0);
  WindowToFront(wptr);
  Write(CLS);
  IF dateiabfrage THEN
    fragedatei();
  END;
  center("TABELLIERUNG DER FUNKTION"); WriteLn; 
  center("-------------------------"); WriteLn;
  cursorr( 18+(31-Length(string)) DIV 2 );
  WriteString("f(x) = ");
  WriteString(string); crlf(2);cursorr(3);
  WriteString(
  " |      x    |       y     |       y'    |        y''  |       y'''  |");
  WriteLn; cursorr(3);
  WriteString(
  " |-----------|-------------|-------------|-------------|-------------|");
  WriteLn;
  x:= xmin;  
  REPEAT
    cursorr(3);
    WriteString(" |");
    WriteReal(x,m,n); WriteString("   |  ");
    WriteReal(fn(x,0),m,n); WriteString("   |  ");
    WriteReal(fn(x,1),m,n); WriteString("   |  ");
    WriteReal(fn(x,2),m,n); WriteString("   |  "); 
    WriteReal(fn(x,3),m,n); WriteString("   |  "); WriteLn;
    x:= x + dx;
  UNTIL x>xmax;
  cursorr(3);
  WriteString(
  " |-----------|-------------|-------------|-------------|-------------|");
  WriteLn;
  CloseOutput;
  crlf(2); cursorr(22);
  WriteString("Bitte 'RETURN' drcken fr MENU ");
  wartemenu;
END wertetabelle;

    
PROCEDURE wertetabelleif;

CONST
  err = 0.001;

VAR
  x,dx,xmin,xmax,festgrenze,sum		: FFP;
  zuviele				: BOOLEAN;
	
BEGIN
  fktstring(festgrenzestr,1);
  nullbuffer[2]:= "1.0";
  kleinintervall(nullbuffer,ADR("Integralfunktion - Intervall"));
  xmin:= parse(nullbuffer[1],0.0);
  dx:=   parse(nullbuffer[2],0.0);
  xmax:= parse(nullbuffer[3],0.0);
  festgrenze:= parse(festgrenzestr,0.0);
  Write(CLS);
  IF dateiabfrage THEN
    fragedatei();
  END;
  center("TABELLIERUNG DER INTEGRALFUNKTION"); WriteLn; 
  center("---------------------------------"); WriteLn;
  cursorr( 18+(31-Length(string)) DIV 2 );
  WriteString("f(x) = ");
  WriteString(string);
  WriteLn;
  cursorr(22); WriteString("Feste untere Grenze A = ");
  WriteReal(festgrenze,m,n);
  crlf(2);cursorr(20);        
  WriteString("|       z      |     INT(a,z,f() dx)   |"); WriteLn;
  cursorr(20);
  WriteString("|--------------|-----------------------|"); WriteLn;
  x:= xmin;
  IF festgrenze=xmin THEN
    sum:= 0.0;
  ELSE
    sum:= intf(festgrenze,xmin,err,zuviele);
  END;
  REPEAT
    cursorr(20);
    WriteString("|   ");
    WriteReal(x,m,n);
    WriteString("   |      ");
    WriteReal(sum,m,n);
    WriteString("         |");
    WriteLn;
    sum:= sum + intf(x,x+dx,err,zuviele);
    x:= x + dx;
  UNTIL x>xmax;
  cursorr(20); 
  WriteString("|--------------|-----------------------|");
  CloseOutput;
  crlf(2); cursorr(22);
  WriteString("Bitte 'RETURN' drcken fr MENU");
  wartemenu;
END wertetabelleif;
    
  
END wertetabelle.

