MODULE C4P5;  (* Chapter 4  Problem 5 *)
              (* Raise x to y power *)

  (* From the book "Modula-2  A Seafarer's Manual and Shipyard Guide" *)
  (* Page 121   adapted "Amiga M2Modula-2"   08 Mar 1988 *)

FROM InOut IMPORT WriteLn,
                  WriteString;
FROM RealInOut IMPORT WriteReal,
                      ReadReal;
FROM MathLib0 IMPORT exp,
                     ln;

VAR
  z,					(* receives result *)
  x,					(* base from keyboard *)
  y : REAL;				(* exponent from keyboard *)
  CanDo : BOOLEAN;			(* TRUE if power can be evaluated *)
    
PROCEDURE Getxy(VAR base : REAL;	(* get x & y from keyboard *)
                VAR exp : REAL);
  BEGIN
    WriteLn;
    WriteString ("Enter x: ");
    ReadReal (base);
    WriteLn;
    WriteString ("Enter y: ");
    ReadReal (exp);
  END Getxy;
  
PROCEDURE Power(t : REAL;		(* base *)
                e : REAL;		(* exponent *)
                VAR OK : BOOLEAN) : REAL;	(* power can be evaluated? *)
  VAR
    xy : REAL;
  BEGIN
    OK := (t > 0.0);
    IF NOT OK THEN			(* power cannot be evaluated *)
      RETURN 0.0;
    END;
    xy := exp (ln(x) * y);
    RETURN xy;				(* return result *)
  END Power;
   
PROCEDURE DisplayAnswer(xtoy : REAL);
  BEGIN
    WriteLn;
    WriteString ("x to y power = ");
    WriteReal (xtoy,10,2);
    WriteLn;
  END DisplayAnswer;
 
BEGIN					(* MODULE RaisePower *)
  WriteLn;
  WriteString ("Calculating x to y power");
  Getxy(x,y);
  z := Power(x,y,CanDo);
  IF CanDo THEN
    DisplayAnswer(z);
  ELSE
    WriteLn;
    WriteString ("x to y power cannot be evaluated.");
    WriteLn;
    IF (x < 0.0) THEN
      WriteString ("x is negative !!!");
    ELSE
      WriteString ("x is equal to 0 !!!");
    END;
    WriteString (" This is undefined.");
    WriteLn;
  END;
  
END C4P5.
