MODULE C5P4;  (* Chapter 5  Problem 4 *)
              (* A RECORD variant *)

  (* From the book "Modula-2  A Seafarer's Manual and Shipyard Guide" *)
  (* Page 162   adapted "Amiga M2Modula-2"   11 Mar 1988 *)

FROM InOut IMPORT Read,
                  ReadString,
                  WriteString,
                  WriteLn,
                  ReadCard,
                  WriteCard;
FROM RealInOut IMPORT ReadReal,
                      WriteReal;

TYPE
  shape = (rectangle,square,circle);
  
VAR
  dimension : 
    RECORD
      CASE figure : shape OF
        rectangle : height : REAL;
                    width : REAL;
                    |
        square : length : REAL;
                 |
        circle : radius : REAL;
      END;   (* CASE figure *)
    END;   (* RECORD *)
  infig : CHAR;				(* input figure from keyboard *)
  dummy : ARRAY [0..80] OF CHAR;	(* for wrong read procedure *)
  OK : BOOLEAN;				(* correct input? *)

BEGIN
  WriteString ("Demonstrates a RECORD variant.");
  WriteLn; WriteLn;

  OK := FALSE;				(* initialize *)
  WHILE (NOT OK) DO
    WriteString ("Enter shape (R)ectangle, (S)quare or (C)ircle: ");
    Read (infig);
    ReadString (dummy);
    CASE CAP (infig) OF
      "R" : dimension.figure := rectangle;
            OK := TRUE;
            |
      "S" : dimension.figure := square;
            OK := TRUE;
            |
      "C" : dimension.figure := circle;
            OK := TRUE;
            |
      ELSE
        WriteString ("Wrong input!!!  Try again.");
        WriteLn; WriteLn;
    END;   (* IF *)
  END;   (* WHILE *)
  WriteLn; WriteLn;
  
  WITH dimension DO
    CASE figure OF
      rectangle : WriteString ("Enter rectangle height: ");
                  ReadReal (height);
                  WriteString ("Enter rectangle width: ");
                  ReadReal (width);
                  WriteLn;
                  WriteString ("The height of the rectangle is ");
                  WriteReal (height,6,2);
                  WriteString (" and the width is ");
                  WriteReal (width,6,2);
                  WriteLn;
                  WriteString ("The area of the rectangle is ");
                  WriteReal ( (height * width),8,2 );
                  |
      square : WriteString ("Enter length of a square side: ");
               ReadReal (length);
               WriteLn;
               WriteString ("The length of a square side is ");
               WriteReal (length,6,2);
               WriteLn;
               WriteString ("The area of the square is ");
               WriteReal ( (length * length),8,2 );
               |
      circle : WriteString ("Enter circle radius: ");
               ReadReal (radius);
               WriteLn;
               WriteString ("The radius of the circle is ");
               WriteReal (radius,6,2);
               WriteLn;
               WriteString ("The area of the circle is ");
               WriteReal ( (radius * radius * 3.1415926536),8,2 );
    END; (* CASE *)
  END;  (* WITH *)
  WriteLn; WriteLn;
  
END C5P4.mod.
