MODULE RaisePower;   (* Raise x to the y power where y>=0 *)

  (* From the book "Modula-2  A Seafarer's Manual and Shipyard Guide" *)
  (* Page 100   adapted "Amiga M2Modula-2"   08 Mar 1988 *)

FROM InOut IMPORT WriteLn,
                  WriteString,
                  ReadCard;
FROM RealInOut IMPORT WriteReal,
                      ReadReal;
                      
VAR
  z,			(* accumulates result *)
  t,			(* intermediate result *)
  x : REAL;		(* base from keyboard *)
  e,			(* holds exponent *)
  y : CARDINAL;		(* exponent from keyboard *)
  
PROCEDURE Getxy;	(* get x & y from keyboard *)
  BEGIN
    WriteLn;
    WriteString ("Enter x: ");
    ReadReal (x);
    WriteLn;
    WriteString ("Enter y: ");
    ReadCard (y);
  END Getxy;
  
PROCEDURE Power;	(* raise x to y power *)
  BEGIN
    e := y;		(* initialize exponent *)
    t := x;		(* initialize intermediate result *)
    z := 1.0;		(* initialize result *)
    WHILE (e # 0) DO
      WHILE (NOT ODD(e)) DO
        t := t * t;
        e := e DIV 2;
      END;   (* WHILE NOT *)
      z := z * t;
      DEC (e);
    END;   (* WHILE e *)
  END Power;
  
PROCEDURE DisplayAnswer;
  BEGIN
    WriteLn;
    WriteString ("x to y power = ");
    WriteReal (z,10,2);
    WriteLn;
  END DisplayAnswer;

BEGIN			(* MODULE RaisePower *)
  WriteLn;
  WriteString ("Calculating x to y power");
  Getxy;
  Power;
  DisplayAnswer;
  
END RaisePower.
