(**********************************************************************

    :Program.    TestMemSys.mod
    :Contents.   Test Module for MemSystem 1.3
    :Author.     Nicolas Benezan [bne]
    :Address.    Postwiesenstr. 2, D7000 Stuttgart 60
    :Phone.      711/333679
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga A+L V3.2d
    :Imports.    MemSystem1.3 [bne]
    :History.    V1.0 [bne] 29.Mar.1989

**********************************************************************)

MODULE TestMemSys;

FROM Exec       IMPORT AvailMem,MemReqSet;
FROM InOut      IMPORT WriteString, WriteInt, WriteLn;
FROM MemSystem  IMPORT NoCareAllocate, Deallocate, EnterLevel, ExitLevel,
                LevelKey;
FROM SYSTEM     IMPORT ADDRESS;

VAR
  Level:LevelKey;

PROCEDURE PrintFreeMem;
BEGIN
  WriteString("Free memory: ");
  WriteInt(AvailMem(MemReqSet{}),1);
  WriteLn;
END PrintFreeMem;

PROCEDURE AllocHunk;
VAR
  Adr:ADDRESS;
BEGIN
  NoCareAllocate(Adr,100000);
END AllocHunk;

BEGIN
  PrintFreeMem;
  AllocHunk;
  PrintFreeMem;
  WriteString("EnterLevel");
  WriteLn;
  EnterLevel(Level);
  AllocHunk;
  PrintFreeMem;
  WriteString("ExitLevel");
  WriteLn;
  ExitLevel(Level);
  PrintFreeMem;
END TestMemSys.

