(*---------------------------------------------------------------------------
  :Program.    DumpILBM.mod
  :Author.     Stefan Salewski
  :Address.    Stolper Weg 3, D-2160 Stade
  :Shortcut.   [sts]
  :Version.    1.0
  :Date.       2-apr-89
  :Copyright.  Public Domain
  :Language.   Modula-2
  :Translator. M2Amiga AMSoft V3.2d
  :Imports.    ILBMHandler[sts]
  :Contents.   Procedure for printing general dates of a ILBM-Picture
---------------------------------------------------------------------------*)
IMPLEMENTATION MODULE DumpILBM;
(*
  Created:   2/89 by
             Stefan Salewski
             Stolper Weg 3
             2160 Stade   West-Germany
             Tel: 04141/61130
             
*)
FROM InOut IMPORT WriteString,WriteInt,WriteCard,WriteLn;
FROM ILBMHandler IMPORT IFFInfo,IFFTitles,ViewTypes;
FROM Dos IMPORT Delay;



  PROCEDURE DumpInfo(info:IFFInfo);
    (* Use it if you have any trouble with an ILBM-File or yust to
    look at the values of the info-Variable.*)
  VAR
    l:INTEGER;
  BEGIN
    WriteString('Information about the ILBM-File:');WriteLn;
    WriteString('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');WriteLn;
    WriteString('by Stefan Salewski, Stolper Weg 3, D-2160 Stade');WriteLn;
    WriteLn;
    IF (bmhd IN info.IFFTitle) THEN
      WITH info.bmhd DO
        WriteString('BitMapHaeder:');WriteLn;
        WriteString('~~~~~~~~~~~~~');WriteLn;
        WriteString('  Width: ');       WriteInt(width,8);       WriteLn;
        WriteString('  Height: ');      WriteInt(height,8);      WriteLn;
        WriteString('  Left: ');        WriteInt(left,8);        WriteLn;
        WriteString('  Top: ');         WriteInt(top,8);         WriteLn;
        WriteString('  Depth: ');       WriteCard(depth,8);      WriteLn;
        WriteString('  Masking: ');     WriteCard(masking,8);    WriteLn;
        WriteString('  Compression: '); WriteCard(compression,8);WriteLn;
        WriteString('  TransColor: ');  WriteInt(transCol,8);    WriteLn;
        WriteString('  xAspect: ');     WriteCard(xAspect,8);    WriteLn;
        WriteString('  yAspect: ');     WriteCard(yAspect,8);    WriteLn;
        WriteString('  ScreenWidth: '); WriteInt(scrnWidth,8);   WriteLn;
        WriteString('  ScreenHeight: ');WriteInt(scrnHeight,8);  WriteLn;
        WriteLn;
      END;
      Delay(3*50);
    END;
    IF (cmap IN info.IFFTitle) THEN
      WriteString('ColorMap:');WriteLn;
      WriteString('~~~~~~~~~');WriteLn;
      WriteString('  ColorCount: ');WriteCard(info.cmap.colorCnt,8);WriteLn;
      WriteLn;
    END;
    IF (dest IN info.IFFTitle) THEN
      WriteString('Destination:');WriteLn;
      WriteString('~~~~~~~~~~~~');WriteLn;
      WITH info.dest DO
        WriteString('  Depth: ');      WriteCard(depth,8);     WriteLn;
        WriteString('  PlanePick: ');  WriteCard(planePick,8); WriteLn;
        WriteString('  PlaneOnOff: '); WriteCard(planeOnOff,8);WriteLn;
        WriteString('  PlaneMask: ');  WriteCard(planeMask,8); WriteLn;
      END;
      WriteLn;
    END;
    IF (camg IN info.IFFTitle) THEN
      WriteString('ViewModes:');WriteLn;
      WriteString('~~~~~~~~~~');WriteLn;
      WITH info.camg DO
        IF Ersy IN viewType THEN
          WriteString('  Ersy: ');WriteLn;
        END;
        IF Lace IN viewType THEN
          WriteString('  Lace: ');WriteLn;
        END;
        IF LPen IN viewType THEN
          WriteString('  LPen: ');WriteLn;
        END;
        IF Extra IN viewType THEN
          WriteString('  Extra(HB): ');WriteLn;
        END;
        IF Gaud IN viewType THEN
          WriteString('  Gaud: ');WriteLn;
        END;
        IF Color IN viewType THEN
          WriteString('  Color: ');WriteLn;
        END;
        IF DblPF IN viewType THEN
          WriteString('  DblPF: ');WriteLn;
        END;
        IF HoMod IN viewType THEN
          WriteString('  HoMod: ');WriteLn;
        END;
        IF Hires IN viewType THEN
          WriteString('  Hires: ');WriteLn;
        END;
      END;
      WriteLn;
    END;
    IF (crng IN info.IFFTitle) THEN
      WriteString('ColorCycling is on');WriteLn;
      WriteString('~~~~~~~~~~~~~~~~~~');WriteLn;
      WITH info.crng DO
        WriteString('  count: ');WriteCard(count,8);WriteLn;
        FOR l:=0 TO count-1 DO
          WITH data[l] DO
            WriteString('    Rate: ');WriteInt(rate,8);WriteLn;
            IF on THEN
              WriteString('    is on');WriteLn;
            ELSE
              WriteString('    is not on');WriteLn;
            END;
            IF forward THEN
              WriteString('    forward');WriteLn;
            ELSE
              WriteString('    not forward');WriteLn;
            END;
            WriteString('    low: ');WriteCard(low,8);WriteLn;
            WriteString('    high: ');WriteCard(high,8);WriteLn;
            WriteString('--------------------------');WriteLn;
          END;
        END;
      END
    END;
    WriteLn;  
  END DumpInfo;
  
END DumpILBM.
