(*---------------------------------------------------------------------------
  :Program.    DumpPictureDates.mod
  :Author.     Stefan Salewski
  :Address.    Stolper Weg 3, D-2160 Stade
  :Shortcut.   [sts]
  :Version.    1.0
  :Date.       2-apr-89
  :Copyright.  Public Domain
  :Language.   Modula-2
  :Translator. M2Amiga V3.2d
  :Imports.    ILBMHandler[sts], DumpILBM[sts]
  :Contents.   Prints general information about ILBM-Pictures
---------------------------------------------------------------------------*)

MODULE DumpPictureDates;
(*
  Created:   17.3.89 by
             Stefan Salewski
             Stolper Weg 3
             2160 Stade   West-Germany
             Tel: 04141/61130
             
  Note: compiled with AMIGA Modula-2 System, 3.2d, (1.11.88) by AMSoft
   
  This Module may be freely copied.
                  
*)
FROM Arguments IMPORT NumArgs,GetArg;
FROM DumpILBM IMPORT DumpInfo;
FROM ILBMHandler IMPORT IFFInfo,ReadInfo,iffError,IFFErrors;
FROM InOut IMPORT WriteString,WriteInt,WriteLn;

VAR
  file:ARRAY [0..80] OF CHAR;
  len:INTEGER;
  bodyPos:LONGINT;
  info:IFFInfo;
  
BEGIN
  IF NumArgs()#1 THEN
    WriteString('Usage from CLI: DumpPictureDates PictureName');WriteLn;
    WriteString('or from WB: Press and hold down the Shift-Key,');WriteLn;
    WriteString('click on the Picture and than DubleClick the');WriteLn;
    WriteString('Icon of this Program');WriteLn;WriteLn;
  ELSE
    GetArg(1,file,len);
    IF ReadInfo(file,info,bodyPos) THEN
      WriteString('BodyPos = ');
      WriteInt(bodyPos,12);WriteLn;
      WriteString('~~~~~~~~~~~~~~~~~~~~~~');WriteLn;
      DumpInfo(info);
    ELSIF iffError=noILBM THEN
      WriteString('This file is NOT a ILBM-File!');WriteLn;
    ELSIF iffError=openFileFailed THEN
      WriteString('Can NOT open this file!');WriteLn;
    ELSE
      WriteString('Unknown Error! Sorry.');WriteLn;
    END;
  END;
  WriteLn;
END DumpPictureDates.
