(*---------------------------------------------------------------------------
  :Program.    LoadInRastPortDemo.mod
  :Author.     Stefan Salewski
  :Address.    Stolper Weg 3, D-2160 Stade
  :Shortcut.   [sts]
  :Version.    1.0
  :Date.       2-apr-89
  :Copyright.  Public Domain
  :Language.   Modula-2
  :Translator. M2Amiga AMSoft V3.2d
  :Imports.    ILBMHandler[sts]
  :Contents.   Simpel demo for ILBMHandler.LoadInRastPort [sts]
  :Remark.     Needs the picture "rectangle" in directory pictures
---------------------------------------------------------------------------*)

MODULE LoadInRastPortDemo;
(* This is only a simpel demontration of ILBMHandler.LoadInRastPort *)
  IMPORT Intuition;
  IMPORT Graphics;
  IMPORT Dos;
  FROM SYSTEM IMPORT ADR;
  FROM ILBMHandler IMPORT LoadInRastPort,ReadInfo,IFFInfo,
                          MaskPlane,Depth;

  CONST
    FileName="pictures/rectangle" ;
    
  PROCEDURE OpenWindow(x,y,w,h:INTEGER):Intuition.WindowPtr;
    VAR
      nW:Intuition.NewWindow;
  BEGIN
    WITH nW DO
      leftEdge:=x;
      topEdge:=y;
      width:=w;
      height:=h;
      detailPen:=0;
      blockPen:=1;
      idcmpFlags:=Intuition.IDCMPFlagSet{};
      flags:=Intuition.WindowFlagSet{Intuition.windowDrag,
                                     Intuition.windowDepth};
      firstGadget:=NIL;
      checkMark:=NIL;
      title:=ADR('ILBMHandler-Demo');
      screen:=NIL;
      bitMap:=NIL;
      minWidth:=-1;
      minHeight:=-1;
      maxWidth:=-1;
      maxHeight:=-1;
      type:=Intuition.ScreenFlagSet{Intuition.wbenchScreen};
    END;
    RETURN Intuition.OpenWindow(nW);
  END OpenWindow;
  
  VAR
    wPtr1:Intuition.WindowPtr;
    myInfo:IFFInfo;
    bodyPos:LONGINT;
    depth:Depth;
BEGIN
  wPtr1:=OpenWindow(40,20,190,160);
  IF wPtr1#NIL THEN
    Graphics.Move(wPtr1^.rPort,20,20);
    Graphics.Text(wPtr1^.rPort,ADR('The retangle will'),17);
    Graphics.Move(wPtr1^.rPort,20,30);
    Graphics.Text(wPtr1^.rPort,ADR('be displayed at'),15);
    Graphics.Move(wPtr1^.rPort,20,40);
    Graphics.Text(wPtr1^.rPort,ADR('20,50 in 10 secs.'),17);
    Dos.Delay(300);
    IF ReadInfo(FileName,myInfo,bodyPos) THEN
      depth:=myInfo.bmhd.depth;
        IF LoadInRastPort(FileName,wPtr1^.rPort,bodyPos,
                    myInfo.bmhd.width,70,60,20,50,150,
                    100,(MaskPlane(myInfo)+depth-2),
                    (myInfo.bmhd.compression=1)) THEN
          Dos.Delay(800);
        END;
    END;
    Intuition.CloseWindow(wPtr1);
  END;
END LoadInRastPortDemo.
  
