(*---------------------------------------------------------------------------
 :Program.    Personalausweis.mod
 :Author.     Florian Unger
 :Version.    1.0
 :Date.       25-Jan-89
 :Copyright.  PD, spies, agents and chaots are not allowed to use this
 :Language.   Modula-II
 :Translator. M2Amiga v3.1d
 :History.    18-Feb-88, I made it a bit easier to use, [fbs]
 :Contents.   Checks and creates numbers for the new german identity card
---------------------------------------------------------------------------*)
(*
Zweck:       - Dieses Programm kann die maschinenlesbaren Nummern
             des neuen Personalausweises berprfen und solche Nummern
             selbst erzeugen.
Compiler:    - verwendeter Compiler: M2Amiga von A.+L.Meier-Vogt,
             Version 3.1d
Version:     - 25.Januar 1989
Author       - Florian Unger
Copyright:   - PublicDomain (nicht fr feindliche Spione, Agenten,
             Chaoten und andere Destruktivisten; Zuwiederhandlungen
             werden mit BASIC nicht unter 2 Jahren bestraft !)
Bemerkungen: - Das Programm verwendet das Modul RandomNumber, das
             nicht zum Modula2-Standard gehrt. Ansonsten ist das
             Programm weder Amiga- noch sonstwas-spezifisch.
             - Programm ist gegen falsche Eingaben unzureichend
             gesichert. Falsche Eingaben werden von Arts aber voll
             abgefangen.
             - Es wird sicherlich keine neuen Versionen geben.
*)
MODULE Personalausweis ;

FROM RandomNumber IMPORT PutSeed,RND ;
FROM InOut        IMPORT WriteInt,WriteString,WriteLn,
                         Read,ReadLongInt ;

TYPE Typ9 = ARRAY [1..10] OF CARDINAL ;
     Typ6 = ARRAY [1..7] OF CARDINAL ;
     Gesamt = RECORD
                Zahl1 : Typ9 ;
                Zahl2 : Typ6 ;
                Zahl3 : Typ6 ;
                Zahl4 : CARDINAL
              END ;

VAR Zeichen : CHAR ;
    Nummer : Gesamt ;
    seed : LONGINT ;

PROCEDURE ReadLn(VAR c : CHAR) ;
(* wie die gleichnamige Prozedur in PASCAL *)
VAR d : CHAR ;
BEGIN
  Read(c) ;
  Read(d)   (* CR *)
END ReadLn ;

PROCEDURE CharToInt(c : CHAR) : CARDINAL ;
(* ist der Wert von c nicht von "0" bis "9", so ergibt sich ein
Laufzeitfehler, da die Prozedur ohne RETURN abgeschlossen wird *)
BEGIN
  IF (ORD(c)>47) AND (ORD(c)<58) THEN
    RETURN ORD(c)-48
  ELSE
    WriteString("Ungltige Ziffer!"); WriteLn;
    RETURN 0;
  END (* IF *)
END CharToInt ;

PROCEDURE IntToChar(i : CARDINAL) : CHAR ;
(* Laufzeitfehler bei i>10, da kein RETURN *)
BEGIN
  IF (i<11) THEN
    RETURN CHR(i+48)
  END (* IF *)
END IntToChar ;

PROCEDURE LetzteZiffer(i : CARDINAL) : CARDINAL ;
BEGIN
  WHILE (i>9) DO
    DEC(i,10)
  END ; (* WHILE *)
  RETURN(i)
END LetzteZiffer ;

PROCEDURE PruefeNummer(n : Gesamt) : BOOLEAN ;
VAR i,j,k,l,m : CARDINAL ;
    t : BOOLEAN ;
BEGIN
  j := 0 ;
  FOR i := 1 TO 7 BY 3 DO
    j := j + (n.Zahl1[0+i] * 7) ;
    j := j + (n.Zahl1[1+i] * 3) ;
    j := j + (n.Zahl1[2+i] * 1)
  END ; (* FOR *)
  k := 0 ;
  FOR i := 1 TO 4 BY 3 DO
    k := k + (n.Zahl2[0+i] * 7) ;
    k := k + (n.Zahl2[1+i] * 3) ;
    k := k + (n.Zahl2[2+i] * 1)
  END ; (* FOR *)
  l := 0 ;
  FOR i := 1 TO 4 BY 3 DO
    l := l + (n.Zahl3[0+i] * 7) ;
    l := l + (n.Zahl3[1+i] * 3) ;
    l := l + (n.Zahl3[2+i] * 1)
  END ; (* FOR *)
  m := 0 ;
  FOR i := 1 TO 7 BY 3 DO
    m := m + (n.Zahl1[0+i] * 7) ;
    m := m + (n.Zahl1[1+i] * 3) ;
    m := m + (n.Zahl1[2+i] * 1)
  END ; (* FOR *)
  m := m + (n.Zahl1[10] * 7) ;
  FOR i := 1 TO 4 BY 3 DO
    m := m + (n.Zahl2[0+i] * 3) ;
    m := m + (n.Zahl2[1+i] * 1) ;
    m := m + (n.Zahl2[2+i] * 7)
  END ; (* FOR *)
  m := m + (n.Zahl2[7] * 3) ;
  FOR i := 1 TO 4 BY 3 DO
    m := m + (n.Zahl3[0+i] * 1) ;
    m := m + (n.Zahl3[1+i] * 7) ;
    m := m + (n.Zahl3[2+i] * 3)
  END ; (* FOR *)
  m := m + (n.Zahl3[7] * 1) ;
  t := (LetzteZiffer(j)=n.Zahl1[10])
       AND (LetzteZiffer(k)=n.Zahl2[7])
       AND (LetzteZiffer(l)=n.Zahl3[7])
       AND (LetzteZiffer(m)=n.Zahl4) ;
  RETURN t
END PruefeNummer ;

PROCEDURE BerechneNummer(VAR n : Gesamt) ;
VAR i,j : CARDINAL ;
BEGIN
  FOR i := 1 TO 9 DO
    n.Zahl1[i] := RND(10)
  END ; (* FOR *)
  j := 0 ;
  FOR i := 1 TO 7 BY 3 DO
    j := j + (n.Zahl1[0+i] * 7) ;
    j := j + (n.Zahl1[1+i] * 3) ;
    j := j + (n.Zahl1[2+i] * 1)
  END ; (* FOR *)
  n.Zahl1[10] := LetzteZiffer(j) ;
  FOR i := 1 TO 6 DO
    n.Zahl2[i] := RND(10)
  END ; (* FOR *)
  j := 0 ;
  FOR i := 1 TO 4 BY 3 DO
    j := j + (n.Zahl2[0+i] * 7) ;
    j := j + (n.Zahl2[1+i] * 3) ;
    j := j + (n.Zahl2[2+i] * 1)
  END ; (* FOR *)
  n.Zahl2[7] := LetzteZiffer(j) ;
  FOR i := 1 TO 6 DO
    n.Zahl3[i] := RND(10)
  END ; (* FOR *)
  j := 0 ;
  FOR i := 1 TO 4 BY 3 DO
    j := j + (n.Zahl3[0+i] * 7) ;
    j := j + (n.Zahl3[1+i] * 3) ;
    j := j + (n.Zahl3[2+i] * 1)
  END ; (* FOR *)
  n.Zahl3[7] := LetzteZiffer(j) ;
  j := 0 ;
  FOR i := 1 TO 7 BY 3 DO
    j := j + (n.Zahl1[0+i] * 7) ;
    j := j + (n.Zahl1[1+i] * 3) ;
    j := j + (n.Zahl1[2+i] * 1)
  END ; (* FOR *)
  j := j + (n.Zahl1[10] * 7) ;
  FOR i := 1 TO 4 BY 3 DO
    j := j + (n.Zahl2[0+i] * 3) ;
    j := j + (n.Zahl2[1+i] * 1) ;
    j := j + (n.Zahl2[2+i] * 7)
  END ; (* FOR *)
  j := j + (n.Zahl2[7] * 3) ;
  FOR i := 1 TO 4 BY 3 DO
    j := j + (n.Zahl3[0+i] * 1) ;
    j := j + (n.Zahl3[1+i] * 7) ;
    j := j + (n.Zahl3[2+i] * 3)
  END ; (* FOR *)
  j := j + (n.Zahl3[7] * 1) ;
  n.Zahl4 := LetzteZiffer(j)
END BerechneNummer ;

PROCEDURE ReadGesamt(VAR n : Gesamt) ;
VAR c : CHAR ;
    i : CARDINAL ;
BEGIN
  WriteString("Bitte die zu berprfende Zahl ohne Leerstellen eingeben :") ;
  WriteLn;
  WriteString(" (Nur die 25 Ziffern, ohne 'D' und '>'!)");
  WriteLn;
  FOR i := 1 TO 9 DO
    Read(c) ;
    n.Zahl1[i] := CharToInt(c)
  END ; (* FOR *)
  Read(c) ;
  n.Zahl1[10] := CharToInt(c) ;
  FOR i := 1 TO 6 DO
    Read(c) ;
    n.Zahl2[i] := CharToInt(c)
  END ; (* FOR *)
  Read(c) ;
  n.Zahl2[7] := CharToInt(c) ;
  FOR i := 1 TO 6 DO
    Read(c) ;
    n.Zahl3[i] := CharToInt(c)
  END ; (* FOR *)
  Read(c) ;
  n.Zahl3[7] := CharToInt(c) ;
  Read(c) ;
  n.Zahl4 := CharToInt(c)
END ReadGesamt ;

PROCEDURE WriteGesamt(n : Gesamt) ;
VAR i : CARDINAL ;
BEGIN
  FOR i := 1 TO 10 DO
    WriteInt(n.Zahl1[i],1)
  END ; (* FOR *)
  WriteString("D<<") ;
  FOR i := 1 TO 7 DO
    WriteInt(n.Zahl2[i],1)
  END ; (* FOR *)
  WriteString("<") ;
  FOR i := 1 TO 7 DO
    WriteInt(n.Zahl3[i],1)
  END ; (* FOR *)
  WriteString("<<<<<<") ;
  WriteInt(n.Zahl4,1) ;
  WriteLn
END WriteGesamt ;

BEGIN (* main *)
  WriteString("Bitte Anfangswert fr Zufallszahlengenerator eingeben :") ;
  ReadLongInt(seed) ;
  PutSeed(seed) ;    (* fr Zufallszahlen *)
  WriteLn ;
  WriteString("Ende des Programms (0) ,") ;
  WriteLn ;
  WriteString("Berechnen (1) oder") ;
  WriteLn ;
  WriteString("berprfen (2) von Nummern ?") ;
  WriteLn ;
  WriteString("> ") ;
  ReadLn(Zeichen) ;
  WHILE (Zeichen#"0") DO
    CASE Zeichen OF
      "1" : BerechneNummer(Nummer) ;
            IF PruefeNummer(Nummer) THEN
              WriteString("Neue Nummer: ") ;
              WriteGesamt(Nummer)
            END | (* IF *)
      "2" : ReadGesamt(Nummer) ;
            IF PruefeNummer(Nummer) THEN
              WriteGesamt(Nummer) ;
              WriteString("ist eine gltige Nummer !!") ;
              WriteLn
            ELSE
              WriteGesamt(Nummer) ;
              WriteString("ist keine gltige Nummer") ;
              WriteLn
            END | (* IF *)
      ELSE
    END ; (* CASE *)
    WriteLn ;
    WriteString("Ende des Programms (0) ,") ;
    WriteLn ;
    WriteString("Berechnen (1) oder") ;
    WriteLn ;
    WriteString("berprfen (2) von Nummern ?") ;
    WriteLn ;
    WriteString("> ") ;
    ReadLn(Zeichen)
  END (* WHILE *)
END Personalausweis .
