*  Assembler include file for the iff library 
*  by Christian A. Weber, Zurich/Switzerland                 V15.3


		XDEF	_IFFBase,_OpenIFFLib,_CloseIFFLib

IFF:	      MACRO
		movea.l	_IFFBase,a6
		jsr	%1(a6)
	      ENDM


*************** L I B R A R Y - O F F S E T S ****************************

OpenIFF:	equ	-30	; (filename)			(A0)
CloseIFF:	equ	-36	; (ifffile)			(A1)
FindChunk:	equ	-42	; (ifffile,chunkname)		(A1,D0)
GetBMHD:	equ	-48	; (ifffile)			(A1)
GetColorTab:	equ	-54	; (ifffile,colortable)		(A1/A0)
DecodePic:	equ	-60	; (ifffile,bitmap)		(A1/A0)
SaveBitMap:	equ	-66	; (name,bmap,ctab,crmd)		(A0-A2,D0)
SaveClip:	equ	-72	; (name,bmap,ctab,crmd,x,y,w,h)	(A0-A2,D0-D4)
IffError:	equ	-78	; ()				()
GetViewModes:	equ	-84	; (ifffile)			(A1)


*************** E R R O R - C O D E S ************************************

IFF_BADTASK:		equ	-1	; IffError() called by wrong task

IFF_CANTOPENFILE:	equ	16	; File not found
IFF_READERROR:		equ	17	; Error reading file
IFF_NOMEM:		equ	18	; Not enough memory for IFF file
IFF_NOTIFF:		equ	19	; File is not an IFF file
IFF_WRITEERROR:		equ	20	; Error writing file

IFF_NOILBM:		equ	24	; IFF file is not of type ILBM
IFF_NOBMHD:		equ	25	; BMHD chunk not found
IFF_NOBODY:		equ	26	; BODY chunk not found
IFF_TOOMANYPLANES:	equ	27	; Picture has more planes than BitMap
IFF_UNKNOWNCOMPRESSION:	equ	28	; Unknown compression type

