IMPLEMENTATION MODULE popMenu;

(* Implementationsmodul zum Hilfsmodul zur Erstellung eines PopUp-Mens.
 *)

FROM SYSTEM    IMPORT ADDRESS, ADR, BYTE,LONGSET;
FROM Intuition IMPORT MenuItem, IntuiText, MenuItemFlags,
                      MenuItemFlagSet, checkWidth;
FROM Graphics  IMPORT jam2;
FROM pop       IMPORT popMenu, popMenuPtr, popFlags, popFlagSet,
                      PopTitleHeight;

CONST
  wi = 130;        (* width of MenuItems *)

  n  = 8;          (* Anz. d. Items      *)
                   (*  + 1!              *)

VAR
  left            :INTEGER;
  i               :CARDINAL;
  TempFlags       :MenuItemFlagSet;
  MenuStrip       :popMenu;
  Items           :ARRAY[0..n] OF MenuItem;
  SecondText      :ARRAY[0..3] OF IntuiText;
  TextItem        :ARRAY[0..n] OF IntuiText;

PROCEDURE GetMenuAdresse():ADDRESS;
  BEGIN
    RETURN ADR(MenuStrip)
  END GetMenuAdresse;

PROCEDURE InitStrip(VAR m:popMenu;L,T,W,H:INTEGER;str:ADDRESS);
  BEGIN
    WITH m DO
      leftEdge := L;
      topEdge  := T;
      width := W;
      height := H;
      flags    := popFlagSet{menuEnabled,popTidy,popPointRel,
                             popRightButton,popTriggerUp,popRemember};
      menuName := str;
    END
  END InitStrip;

PROCEDURE InitItem(VAR mi:MenuItem;L,T,W,H:INTEGER;
                       inFlags:MenuItemFlagSet);
  BEGIN
    WITH mi DO
      leftEdge := L; topEdge := T; width := W; height := H;
      flags := inFlags;
      nextItem   := NIL; itemFill := NIL;
      selectFill := NIL; subItem  := NIL;
    END
  END InitItem;

PROCEDURE InitText(VAR it:IntuiText;text:ADDRESS;left:INTEGER):ADDRESS;
  BEGIN
    WITH it DO
      frontPen  := 0; backPen := 1;
      drawMode  := jam2;
      leftEdge  := left; topEdge := 2;
      iTextFont := NIL; iText := text;
      nextText  := NIL;
    END;
    RETURN ADR(it)
  END InitText;

BEGIN
  (* PopUpMenStreifen initialisieren *)
  InitStrip(MenuStrip, -1*((102 + PopTitleHeight)/2),
                       -1*PopTitleHeight/2,
                       wi,
                       90 + PopTitleHeight + 2,
                       ADR("MenItems"));

  (* Jeweils 1. MenItem anbinden *)
  MenuStrip.firstItem := ADR(Items[0]);


  (* Items aufbauen *)
  TempFlags := MenuItemFlagSet{itemEnabled,itemText,highBox};
  InitItem(Items[0],0, 0,wi,10,TempFlags);  (*\          *)
  TempFlags := MenuItemFlagSet{itemEnabled,itemText,highComp};
  InitItem(Items[1],0,10,wi,10,TempFlags);  (* draw      *)

  TempFlags := TempFlags + MenuItemFlagSet{checkIt};
  InitItem(Items[2],0,20,wi,10,TempFlags+MenuItemFlagSet{checked});
  InitItem(Items[3],0,30,wi,10,TempFlags);  (*  \        *)
  InitItem(Items[4],0,40,wi,10,TempFlags);  (*   colours *)

  TempFlags := MenuItemFlagSet{itemEnabled,itemText,highComp,highItem};
  InitItem(Items[5],0,50,wi,10,TempFlags);  (* \         *)
  InitItem(Items[6],0,60,wi,10,TempFlags);  (*  \        *)
  InitItem(Items[7],0,70,wi,10,TempFlags);  (*   Infos   *)
  TempFlags := MenuItemFlagSet{itemEnabled,itemText,highBox};
  InitItem(Items[8],0,80,wi,10,TempFlags);
                                (* no command sequence possible *)
  (* Items verbinden *)
  FOR i:=0 TO n-1 DO
    Items[i].nextItem := ADR(Items[i+1]);
  END;

  (* Setup Texte *)
  left := 2;
  Items[0].itemFill     := InitText(TextItem[0],ADR(" Kreis"),left);
  Items[1].itemFill     := InitText(TextItem[1],ADR(" Rechteck"),left);

  left := 2 + checkWidth;
  Items[2].itemFill     := InitText(TextItem[2],ADR(" Farbe rot"),left);
  Items[3].itemFill     := InitText(TextItem[3],ADR(" Farbe gruen"),left);
  Items[4].itemFill     := InitText(TextItem[4],ADR(" Farbe blau"),left);


  (* Setze mutual exclusions *)
  FOR i:=2 TO 4 DO
    Items[i].mutualExclude := LONGSET{2..4} - LONGSET{i};
  END;

  left := 2;
  Items[5].itemFill     := InitText(TextItem[5],ADR(" SIGMA"),left);
  Items[6].itemFill     := InitText(TextItem[6],ADR(" Kurs"),left);
  Items[7].itemFill     := InitText(TextItem[7],ADR(" Echo"),left);

  Items[5].selectFill   := InitText(SecondText[0],ADR(" AMGIS"),left);
  Items[6].selectFill   := InitText(SecondText[1],ADR(" sruK"),left);
  Items[7].selectFill   := InitText(SecondText[3],ADR(" ohcE"),left);

  Items[8].itemFill     := InitText(TextItem[8],ADR(" Quit "),left);

END popMenu.mod


