IMPLEMENTATION MODULE Break;
(*---------------------------------------------------------------------------
    :Program.    Break.mod
    :Author.     Bernd Preusing
    :Address.    Gerhardstr. 16  D-2200 Elmshorn
    :Phone.      04121/22486
    :Shortcut.   [bep]
    :Version.    1.0
    :Date.       19-Mar-89
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga V 3.2
    :Imports.    ---
    :UpDate.     ---
    :Contents.   some procedures to avoid Arts Requester ^C
    :Remark.     We Are The World!
    :Remark.	 Do not use with MODULE MultiTasking!
---------------------------------------------------------------------------*)

FROM SYSTEM	IMPORT	ADR, LONGSET, CAST, SETREG, REG;
FROM Arts	IMPORT	Terminate, CurrentLevel, DetectCtrlC, BreakPoint;
FROM Exec	IMPORT	SetSignal, SetExcept, FindTask, TaskPtr, Forbid,
			Permit,	GetMsg, WaitPort;
FROM Dos	IMPORT	Process, DosPacketPtr;
FROM ASCII	IMPORT	eol;

(* from .def
TYPE
	prWriteString = PROCEDURE(ARRAY OF CHAR);
	Keys = (k0,k1,k2,k3,k4,k5,k6,k7,k8,k9,k10,k11,
		ctrlC, ctrlD, ctrlE, ctrlF, k16);
	KeySet = SET OF Keys;
CONST
	BreakText = ' *** BREAK '; (* patched with eols *)
	NoBreak = KeySet{};
	CBreak = KeySet{ctrlC};
	CDBreak = KeySet{ctrlC,ctrlD};
	FullBreak = KeySet{ctrlC..ctrlF};

VAR (* don't modify, read only! Should be CONST. *)
	BreakMsg: ARRAY [0..31] OF CHAR;

 end .def *)

TYPE
	ProcessPtr = POINTER TO Process;
VAR
	ActualBreak: KeySet;
	ActualWriteProc: prWriteString;
	MyTask: ProcessPtr;
	Packet: DosPacketPtr;

(* $S- $R- $V- $F- $Z- *)

PROCEDURE SetBreakMode(when:KeySet; writeProc: prWriteString);
BEGIN
  ActualBreak := when*FullBreak;
  ActualWriteProc := writeProc
END SetBreakMode;

PROCEDURE Exit();
BEGIN
  ActualWriteProc(BreakMsg);
  Terminate(CurrentLevel())
END Exit;

PROCEDURE Break();
BEGIN
   (* ask and clear all *)
  IF (CAST(KeySet,SetSignal(LONGSET{},CAST(LONGSET,ActualBreak)))*ActualBreak)
  	 # NoBreak THEN
    Exit()
  END;
END Break;

PROCEDURE GetBreak():KeySet;
BEGIN
  (* ask and clear all *)
  RETURN CAST(KeySet,SetSignal(LONGSET{},CAST(LONGSET,ActualBreak)))
  	*ActualBreak;
END GetBreak;

PROCEDURE ExceptProc(received{0}:KeySet); (* should really be :KeySet *) 
BEGIN
  IF ctrlC IN received THEN
    IF 8 IN MyTask^.task.sigRecvd THEN
      Packet:=CAST(DosPacketPtr,GetMsg(ADR(MyTask^.msgPort)));
    END;
    IF 8 IN MyTask^.task.sigWait THEN
      WaitPort(ADR(MyTask^.msgPort));
      Packet:=CAST(DosPacketPtr,GetMsg(ADR(MyTask^.msgPort)));
    END;
    Exit() (* never return *)
  END;
  (* d0 is returned ! *)
END ExceptProc;

PROCEDURE InstallException();
(*	:Semantic.	install an exception procedure in my task structure
	:Semantic.	which Exit()s, when ctrl-C pressed
*)
BEGIN
  Forbid;
  MyTask^.task.exceptCode:=CAST(PROC,ADR(ExceptProc));
  SETREG(0,SetExcept(LONGSET{ORD(ctrlC)},LONGSET{ORD(ctrlC)}));
  Permit;
END InstallException;


PROCEDURE DummyWriteProc(s: ARRAY OF CHAR);
END DummyWriteProc;

BEGIN
  DetectCtrlC(FALSE); (* fuck off Arts *)
  MyTask:=CAST(ProcessPtr,FindTask(NIL));
  (* forbid all excepts *)
  SETREG(0,SetExcept(LONGSET{},CAST(LONGSET,KeySet{ctrlC..ctrlF})));
  BreakMsg:=BreakText;
  BreakMsg[0]:=eol;
  BreakMsg[10]:=eol;
  ActualBreak:=CBreak;
  ActualWriteProc:=DummyWriteProc;
END Break.mod
