(*---------------------------------------------------------------------------
    :Program.     PatternTest.mod
    :Contents.	  Demonstriert Modul LoPattern und HiPattern
    :Author.      Bernd Preusing
    :Address.	  Gerhardstr. 16  D-2200 Elmshorn
    :Phone.	  04121/22486
    :Copyright.	  Public Domain
    :Language.	  Modula-2
    :Translator.  M2Amiga V3.2e
    :History.	  1.0 14-May-89
    :Imports.	  LoPattern, HiPattern, BackDrop (Preusing)
    :Usage.	  einfach starten und dann linke Maustaste drcken
---------------------------------------------------------------------------*)
MODULE PatternTest;

FROM SYSTEM	IMPORT	ADR;
FROM BackDrop	IMPORT	OpenBackDrop, CloseBackDrop, BdRp;
FROM Graphics	IMPORT	RastPortPtr, SetAPen, SetBPen, RectFill;
FROM GfxMacros	IMPORT	SetOPen;
IMPORT LoPattern, HiPattern;


CONST DEPTH = 2;


PROCEDURE WaitButton;
VAR ciaa[0BFE001H]:SET OF [0..7];
BEGIN
  REPEAT
  UNTIL NOT(6 IN ciaa);
  REPEAT
  UNTIL (6 IN ciaa)
END WaitButton;


PROCEDURE LoPattTest(rp: RastPortPtr; width,height:INTEGER);
VAR x,y,i,xw,yh, MaxPatt:INTEGER;
CONST Zeilen = 3;
BEGIN
  MaxPatt:=INTEGER(MAX(LoPattern.Pattern));
  SetAPen(rp,1); SetOPen(rp,2);
  xw:=width/(MaxPatt/Zeilen+1);
  yh:=height/Zeilen;
  x:=0; y:=0;
  FOR i:=0 TO MaxPatt DO
    LoPattern.SetPattern(rp,LoPattern.Pattern(i));
    RectFill(rp,x,y,x+xw-1,y+yh-1);
    INC(x,xw); 
    IF x>width-10 THEN x:=0; INC(y,yh) END;
  END;
  WaitButton;
END LoPattTest;

PROCEDURE HiPattTest(rp: RastPortPtr; width,height:INTEGER);
VAR x,y,i,xw,yh, MaxPatt:INTEGER;
CONST Zeilen = 3;
BEGIN
  MaxPatt:=INTEGER(MAX(HiPattern.Pattern));
  SetAPen(rp,1); SetOPen(rp,2);
  xw:=width/(MaxPatt/Zeilen+1);
  yh:=height/Zeilen;
  x:=0; y:=0;
  FOR i:=0 TO MaxPatt DO
    HiPattern.SetPattern(rp,HiPattern.Pattern(i));
    RectFill(rp,x,y,x+xw-1,y+yh-1);
    INC(x,xw); 
    IF x>width-10 THEN x:=0; INC(y,yh) END;
  END;
  WaitButton;
END HiPattTest;

BEGIN
  OpenBackDrop(DEPTH,640,256,ADR('HiRes'));
  HiPattTest(BdRp,640,256);
  WaitButton;
  CloseBackDrop;
  OpenBackDrop(DEPTH,640,512,ADR('HiRes-Interl'));
  LoPattTest(BdRp,640,512);
  WaitButton;
  CloseBackDrop;
  OpenBackDrop(DEPTH,320,256,ADR('LoRes'));
  LoPattTest(BdRp,320,256);
  WaitButton;
END PatternTest.
