(**********************************************************************

    :Program.    InhibitDemo.mod
    :Contents.   Test and demo module for TrackDiskSupport.InhibitDrive
    :Author.     Fridtjof Siebert [fbs]
    :Author.     Nicolas Benezan [bne]
    :Address.    [bne] Postwiesenstr. 2, D7000 Stuttgart 60
    :Phone.      [bne] 711/333679
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga A+L V3.2d
    :Imports.    TrackDiskSupport2.1 [fbs],[bne]
    :History.    V1.0 [bne] 13.May.1989

**********************************************************************)
MODULE InhibitDemo;

FROM Arts             IMPORT BreakPoint;
FROM Dos              IMPORT Delay;
FROM Exec             IMPORT Byte;
FROM TrackDisk        IMPORT badDriveType;
FROM InOut            IMPORT WriteString, WriteLn, ReadString, WriteInt;
FROM MemSystem        IMPORT NoCareAllocMem, Deallocate;
FROM SYSTEM           IMPORT ADR, CAST;
FROM TrackDiskSupport IMPORT OpenDiskDevice, CloseDiskDevice, DiskUnit,
                             InhibitDrive;

VAR
  DevName: ARRAY [0..7] OF CHAR;
  Unit: DiskUnit;
  Error: Byte;
  Buffer: POINTER TO ARRAY [0..511] OF CHAR;

BEGIN
  LOOP
    WriteString('Device-Namen eingeben (zB. "DF0"): ');
    ReadString(DevName);
    IF DevName[0]=CHR(0) THEN
      EXIT
    END;
    Error:= OpenDiskDevice(DevName,Unit);
    IF Error=badDriveType THEN
      WriteString(" not connected");
      WriteLn;
    ELSIF Error#0 THEN
      WriteString(" Error:");
      WriteInt(Error,4);
      WriteLn;
    ELSE
      WriteString(" ok");
      WriteLn;
      IF InhibitDrive(Unit,TRUE) THEN
        WriteString("drive locked");
        WriteLn;
        Delay(200);
        IF InhibitDrive(Unit,FALSE) THEN
          WriteString("drive unlocked");
          WriteLn;
        END;
      END;
    END;
  END;
END InhibitDemo.

