(*---------------------------------------------------------------------------
    :Program.     BeamRandom.mod
    :Contents.	  Erzeuge Zufallszahlen aus der Strahlposition
    :Author.      Bernd Preusing
    :Address.	  Gerhardstr. 16  D-2200 Elmshorn
    :Phone.	  04121/22486
    :Copyright.	  Public Domain
    :Language.	  Modula-2
    :Translator.  M2Amiga V3.2e
    :History.	  V1.0 1-May-89 Preusing
    :Bugs.	  none
    :Remark.      Nicht SEHR zufllig, aber schneller und krzer als
    :Remark.	  'RandomNunmber'.
---------------------------------------------------------------------------*)
IMPLEMENTATION MODULE BeamRandom;

FROM SYSTEM	IMPORT	BITSET;

VAR
   VHPosR[0DFF006H]: BITSET; (* kein Bock auf Hardware *)

(* $F- $S- *)  (* nicht V- wegen Negation!! *)
PROCEDURE RND(Nr:INTEGER):INTEGER;
(* RETURN [0..Nr-1] bzw. [Nr+1..0] fr Nr<0 *)
TYPE Byte = [0..255];
VAR Val1,Val2: RECORD CASE :INTEGER OF
		| 0: s: BITSET;
		| 1: b1,b2:Byte;
		| 2: i: INTEGER;
		END
	 END;
BEGIN
  Val1.s:=VHPosR;
  Val2.b1:=Val1.b2; Val2.b2:=Val1.b1; (* bichen verwuseln *)
  Val1.s:=Val1.s/Val2.s-BITSET{15}; (* EOR *)
  IF Nr=0 THEN
    RETURN 0
  ELSIF Nr>0 THEN
    RETURN Val1.i REM Nr (* Nicht MOD!!! *)
  ELSE
    RETURN -(Val1.i REM (-Nr))
  END;
END RND;

END BeamRandom.mod
