
(*********************************************************************
 
    :Program.  	 GraphicLib.mod
    :Author.   	 Thomas E. Speer
    :Address.    -
    :Phone.      -
    :shortcut. 	 -
    :Version.  	 1.2.2   
    :Date.     	 14.01.1989
    :Copyright.  Aus dem original TURBO PASCAL Source code:
    :Copyright.  ------------------------------------------
    :Copyright.  Copyright 1984 by Thomas E. Speer 
    :Copyright.  All rights reserved (PLOT V3.3,SIG/M 194)
    :Copyright.  Released to the Public Domain for Non-commercial use only
    :Language. 	 Modula-II
    :Translator. M2Amiga 3.2d
    :Imports.	 MathLibExt [gs], IntegerBoole [gs]
    :UpDate.	 -
    :Contents.   2D-Koordinatenkreuze zeichnen
    :Remark.	 Fr den Amiga Modula-2 Klub / Stuttgart
    :Remark.     Die   meisten   in   dieser   Grafik-Bibliothek   enthaltenen
    :Remark.     Unterprogramme wurden von Thomas E.Speer in der Public Domain
    :Remark.     Serie SIG/M  194 verffentlicht. Diese wurden in TURBO PASCAL
    :Remark.     unter dem Betriebssystem CP/M erstellt.
    :Remark.     Die  Anpassung  an  den  AMIGA  dieser  Bibliothek  wurde  von
    :Remark.     Gary Struhlik vorgenommen.  Die  Prozeduren  wurden  mit Hilfe
    :Remark.     des Compilers M2Amiga von A.+L. AG erstellt. Das ursprngliche
    :Remark.     Programm   war  in  erster  Linie  fr  den  Drucker  gedacht,
    :Remark.     d.h. die Darstellung auf dem  Bildschirm war nicht vorgesehen.
    :Remark.     Die Grafiken  sollen auch  hier  fr  den   spteren  Ausdruck
    :Remark.     erstellt werden(z.Z. nur fr epsonkompatible 9-Nadel Drucker).
    :Remark.     Die Hardcopy Funktion wurde gegenber lteren Versionen
    :Remark.     verbessert.
    :Remark.     Sobald ich mal wieder Zeit haben sollte, werde ich verbesserte
    :Remark.     Versionen herausbringen. 
    :History.    14.10.1988 V1.0.0
    :History.    20.11.1988 V1.1.0
    :History.    19.12.1988 V1.2.0
    :History.    08.01.1989 V1.2.1
    :History.    14.01.1989 V1.2.2
                                                                            
***************************************************************)

IMPLEMENTATION MODULE GraphicLib;


FROM IntegerBoole IMPORT AndInt, IntBitSet;
FROM FileSystem IMPORT File,Lookup,Close,WriteChar;
FROM SYSTEM IMPORT ADR,BITSET;
FROM RealConversions IMPORT RealToStr;
FROM Strings IMPORT Length;
FROM Exec IMPORT ReplyMsg,GetMsg,WaitPort;
FROM Graphics IMPORT RastPortPtr,Draw,Move,
                     SetAPen,SetRast,Text,WritePixel,ReadPixel,DrawEllipse;
FROM Intuition IMPORT IDCMPFlags,IDCMPFlagSet,WindowFlags,WindowFlagSet,
                      ScreenFlags,ScreenFlagSet,NewWindow,WindowPtr,
                      IntuiMessagePtr,OpenWindow,CloseWindow,SetWindowTitles,
                      ScreenPtr;
FROM MathLib0 IMPORT sin,cos,arctan,exp,ln,sqrt;                      
FROM MathLibExt IMPORT log,PwrOfTen;
FROM InOut IMPORT WriteLn, WriteString;
                                        (*    --- Wrter der Bitplane *)
TYPE                                    (*   |                        *)
 BitPlanePtr = POINTER TO ARRAY [0..255],[1..40] OF BITSET;
VAR                       (*      |                    *)
 libname   : STRING;      (*      |_ Bildschirmzeilen  *)  
 nw        : NewWindow;
 window    : WindowPtr;
 scale     : ARRAY [1..4] OF REAL;
 chxsz,chysz,chrot : REAL;
 nxchar,nychar,nxline : INTEGER;
 xmin,xmax,ymin,ymax,sxleft,sxrt,sybot,sytop : REAL;
 f : File;
 Bildspeicher : BitPlanePtr;

PROCEDURE UnableToOpen( name : STRING );
BEGIN
 WriteString(name); WriteString(' kann nicht geffnet werden '); WriteLn;
 HALT
END  UnableToOpen;

PROCEDURE ClrGraphic; (* Fenster lschen *)
BEGIN
	SetRast(window^.rPort,2)
END ClrGraphic;

PROCEDURE GraphOn;  (* Ein Grafikfenster ffnen *)
BEGIN
 WITH nw DO
  leftEdge := 0; topEdge := 0;
  width := 640; height := 256;
  detailPen := 0; blockPen := 1;
  title:=NIL;
  flags := WindowFlagSet{ windowDepth, windowClose,activate,borderless };
  idcmpFlags := IDCMPFlagSet{ closeWindow };
  type :=ScreenFlagSet{ wbenchScreen };
  firstGadget := NIL;
  checkMark := NIL;
  screen := NIL;
  bitMap := NIL;
  minWidth := 640; minHeight := 256;
  maxWidth := 640; maxHeight := 256
 END;
 window := OpenWindow( nw );
 IF window <> NIL THEN
    ClrGraphic; (* Bildschirm (Fenster) lschen *)
    SetAPen( window^.rPort,1) (* weier Zeichenstift *)
 ELSE
    UnableToOpen( 'window' );
 END (* IF *)
END GraphOn;

PROCEDURE BlackPen; (* schwarzer Zeichenstift *)
BEGIN
	SetAPen( window^.rPort,2)
END BlackPen;

PROCEDURE WhitePen; (* weier Zeichenstift *)
BEGIN
	SetAPen( window^.rPort,1)
END WhitePen;

PROCEDURE RedPen; (* roter Zeichenstift *)
BEGIN
	SetAPen( window^.rPort,3)
END RedPen;

PROCEDURE PlotPixel (x,y : INTEGER); (* Punkt zeichnen *)
VAR
	i : INTEGER;
BEGIN
	i:=WritePixel( window^.rPort,x,y)
END PlotPixel;

PROCEDURE ClearPixel (x,y : INTEGER); (* Punkt lschen *)
VAR
	i : INTEGER;
BEGIN
	BlackPen;
	i:=WritePixel( window^.rPort,x,y)
END ClearPixel;

PROCEDURE Ellipse (x,y,a,b : INTEGER); (* Ellipse zeichnen *)
BEGIN
	DrawEllipse( window^.rPort,x,y,a,b)
END Ellipse;

PROCEDURE HardCopy ( lm : CARDINAL); (* linker Rand 0..26 *)
VAR
    x,y,i,ya,j,
    AusgabeZeichenInt  : INTEGER;
    AusgabeZeichen     : CHAR;
    Wort, BitNum : INTEGER;
BEGIN
 Bildspeicher:=window^.rPort^.bitMap^.planes[0]; (* Bitplane 0 *)
 IF (lm <= 26) THEN 
    Lookup( f,'PAR:',1600,TRUE); (* Druckkanal direkt zum Drucker *)
    WriteChar(f,CHR(27)); WriteChar(f,CHR(64)); (* Drucker initialisieren *)
    WriteChar(f,CHR(27)); WriteChar(f,'l'); WriteChar(f,CHR(lm));
    (* Linken Rand einstellen *)
    WriteChar(f,CHR(27)); WriteChar(f,'A'); WriteChar(f,CHR(8));
    (* Zeilenvorschub auf 8/72 Inch voreinstellen *)
    ya:=0;
    WHILE ya < 256 DO
     WriteChar(f,CHR(10)); WriteChar(f,CHR(13)); (* CR und LF *)
     FOR j:=1 TO 2 DO 
         (* zweimal 8 Pkt. Reihen um 1/216 Inch in der Vertikalen *)
         (* nach unten verschoben                                 *)
      WriteChar(f,CHR(27)); WriteChar(f,'*'); WriteChar(f,CHR(1));
      WriteChar(f,CHR(128)); WriteChar(f,CHR(2));
      (* 640 Punkte der 960 Pkt./Zeile-Grafik folgen *)

      FOR Wort:=1 TO 40 DO
        FOR BitNum:=15 TO 0 BY -1 DO
	   AusgabeZeichenInt:=0; (* Alle Bits lschen *)
           FOR y:=ya TO ya+7 DO
              IF BitNum IN Bildspeicher^[y,Wort]  THEN
                 AusgabeZeichenInt:=IntBitSet(AusgabeZeichenInt,7-(y-ya))
                  (* Nadelanordnung in *)                    (* Bits 0..7  *)
                  (*  Kehrlage         *)                    (* ansprechen *)
              END
           END;
           AusgabeZeichen:=CHAR(AusgabeZeichenInt);
           WriteChar(f,AusgabeZeichen) (* Grafikbyte an Drucker *)
        END;
      END;  
      IF j=1 THEN 
        WriteChar(f,CHR(27)); WriteChar(f,'J');
        WriteChar(f,CHR(1)); WriteChar(f,CHR(13))
         (* Zeile um 1/216 Inch vorschieben *)
      END
     END;
     INC(ya,8)
    END;
    WriteChar(f,CHR(27)); WriteChar(f,CHR(64)); (* Drucker initialisieren *)
    Close(f);
 END
END HardCopy;

PROCEDURE DrawLine ( x1,y1,x2,y2 : INTEGER);   (* Linie zeichnen *)
BEGIN
	Move( window^.rPort , x1,y1);
	Draw( window^.rPort , x2,y2)
END DrawLine;

PROCEDURE ClearLine ( x1,y1,x2,y2 : INTEGER);    (* Linie lschen *)
BEGIN
	BlackPen;
	Move( window^.rPort , x1,y1);
	Draw( window^.rPort , x2,y2)
END ClearLine;

PROCEDURE PrintText ( x,y : INTEGER; Zeichenkette : STRING );
              (* Text in Grafik mit Standardzeichensatz *)
BEGIN 
  Move( window^.rPort , x , y ); 
  Text(window^. rPort , ADR(Zeichenkette), Length(Zeichenkette))
END PrintText;

PROCEDURE GraphOff;  (* Warten bis Mausklick an Schlie-Gadget *) 
VAR cl : IDCMPFlagSet;
    msg : IntuiMessagePtr;
BEGIN
 LOOP
  WaitPort(window^.userPort);
  msg:=GetMsg(window^.userPort);
  cl:=msg^.class;
  ReplyMsg(msg);
  IF cl=IDCMPFlagSet{closeWindow} THEN 
   EXIT
  END 
 END; (* LOOP *)  
 CloseWindow( window ) (* Fenster schlieen *)
END GraphOff;

PROCEDURE GraphOffWithOutMouse; (* wie GraphOff, aber ohne auf die Maus zu *)
BEGIN                           (* warten                                  *)
  CloseWindow( window )
END GraphOffWithOutMouse;

PROCEDURE InitCharSize;
BEGIN
	chxsz:=0.0125; chysz:=0.0470; xpos:=0; ypos:=0; chrot:=0.0;
	scale[1]:=1.0; scale[2]:=1.0; scale[3]:=1.0; scale[4]:=0.0
END InitCharSize;

PROCEDURE gmove( x,y :REAL); (* Vektorgrafik mit reellen Zahlen *)
BEGIN
	xpos:=TRUNC(639.0*x);
	ypos:=TRUNC(255.0*y)
END gmove; 

PROCEDURE vector( x,y : REAL); (* Vektorgrafikbefehl *)
VAR x1,y1 : INTEGER;
BEGIN
	x1:=TRUNC(639.0*x);
	y1:=TRUNC(255.0*y);
	DrawLine(xpos,255-ypos,x1,255-y1);
	xpos:=x1;
	ypos:=y1
END vector;

PROCEDURE ChSet ( xsize,ysize, theta : REAL); 
VAR
	t : REAL;
BEGIN
	chxsz:=xsize;
	chysz:=ysize;
	chrot:=theta;
	t:=theta/57.29578;
	scale[3]:=cos(t);
	scale[4]:=sin(t)
END ChSet;

PROCEDURE gchar( cx,cy : REAL; charin : CHAR);

VAR
	tchar : ARRAY [1..721] OF INTEGER;
	ichar : ARRAY [1..95] OF INTEGER;
	schar,cmd,ix,iy : INTEGER;
	i : INTEGER;
	x,y,t : REAL;
BEGIN
	tchar[001]:=255; tchar[002]:=56;  tchar[003]:=181; tchar[004]:=51;
	tchar[005]:=178; tchar[006]:=255; tchar[007]:=40;  tchar[008]:=166;
	tchar[009]:=72;  tchar[010]:=198; tchar[011]:=255; tchar[012]:=40;
	tchar[013]:=162; tchar[014]:=72;  tchar[015]:=194; tchar[016]:=6;
	tchar[017]:=230; tchar[018]:=4;   tchar[019]:=228; tchar[020]:=255;
	tchar[021]:=56;  tchar[022]:=178; tchar[023]:=87;  tchar[024]:=151;   
	tchar[025]:=134; tchar[026]:=149; tchar[027]:=213; tchar[028]:=228;
	tchar[029]:=211; tchar[030]:=147; tchar[031]:=255; tchar[032]:=104;
	tchar[033]:=130; tchar[034]:=8;   tchar[035]:=168; tchar[036]:=166;
	tchar[037]:=134; tchar[038]:=136; tchar[039]:=68;  tchar[040]:=228;
	tchar[041]:=226; tchar[042]:=194; tchar[043]:=196; tchar[044]:=255;
	tchar[045]:=98;  tchar[046]:=151; tchar[047]:=168; tchar[048]:=184;
	tchar[049]:=199; tchar[050]:=198; tchar[051]:=148; tchar[052]:=147;
	tchar[053]:=162; tchar[054]:=178; tchar[055]:=212; tchar[056]:=255;
	tchar[057]:=6;   tchar[058]:=151; tchar[059]:=152; tchar[060]:=136;
	tchar[061]:=135; tchar[062]:=151; tchar[063]:=255; tchar[064]:=72;
	tchar[065]:=182; tchar[066]:=180; tchar[067]:=194; tchar[068]:=255;
	tchar[069]:=40;  tchar[070]:=182; tchar[071]:=180; tchar[072]:=162;	
	tchar[073]:=255; tchar[074]:=21;  tchar[075]:=213; tchar[076]:=39;
	tchar[077]:=195; tchar[078]:=71;  tchar[079]:=163; tchar[080]:=255;
	tchar[081]:=55;  tchar[082]:=179; tchar[083]:=21;  tchar[084]:=213;
	tchar[085]:=255; tchar[086]:=17;  tchar[087]:=162; tchar[088]:=163;
	tchar[089]:=147; tchar[090]:=146; tchar[091]:=162; tchar[092]:=255;
	tchar[093]:=21;  tchar[094]:=213; tchar[095]:=255; tchar[096]:=34;
	tchar[097]:=163; tchar[098]:=147; tchar[099]:=146; tchar[100]:=162;
	
	tchar[101]:=255; tchar[102]:=88;  tchar[103]:=146; tchar[104]:=255;
	tchar[105]:=40;  tchar[106]:=200; tchar[107]:=214; tchar[108]:=212;
	tchar[109]:=194; tchar[110]:=162; tchar[111]:=148; tchar[112]:=150;
	tchar[113]:=168; tchar[114]:=255; tchar[115]:=38;  tchar[116]:=184;
	tchar[117]:=178; tchar[118]:=34;  tchar[119]:=194; tchar[120]:=255;
	tchar[121]:=23;  tchar[122]:=168; tchar[123]:=200; tchar[124]:=215;   
	tchar[125]:=214; tchar[126]:=147; tchar[127]:=146; tchar[128]:=210;
	tchar[129]:=255; tchar[130]:=23;  tchar[131]:=168; tchar[132]:=200;
	tchar[133]:=215; tchar[134]:=214; tchar[135]:=197; tchar[136]:=212;
	tchar[137]:=211; tchar[138]:=194; tchar[139]:=162; tchar[140]:=147;
	tchar[141]:=255; tchar[142]:=72;  tchar[143]:=194; tchar[144]:=55;
	tchar[145]:=148; tchar[146]:=212; tchar[147]:=255; tchar[148]:=88;
	tchar[149]:=152; tchar[150]:=150; tchar[151]:=198; tchar[152]:=213;
	tchar[153]:=211; tchar[154]:=194; tchar[155]:=162; tchar[156]:=147;
	tchar[157]:=255; tchar[158]:=87;  tchar[159]:=200; tchar[160]:=168;
	tchar[161]:=151; tchar[162]:=147; tchar[163]:=162; tchar[164]:=194;
	tchar[165]:=211; tchar[166]:=212; tchar[167]:=197; tchar[168]:=165;
	tchar[169]:=148; tchar[170]:=255; tchar[171]:=24;  tchar[172]:=216;	
	tchar[173]:=162; tchar[174]:=255; tchar[175]:=37;  tchar[176]:=197;
	tchar[177]:=212; tchar[178]:=211; tchar[179]:=194; tchar[180]:=162;
	tchar[181]:=147; tchar[182]:=148; tchar[183]:=165; tchar[184]:=150;
	tchar[185]:=151; tchar[186]:=168; tchar[187]:=200; tchar[188]:=215;
	tchar[189]:=214; tchar[190]:=197; tchar[191]:=255; tchar[192]:=19;
	tchar[193]:=162; tchar[194]:=194; tchar[195]:=211; tchar[196]:=215;
	tchar[197]:=200; tchar[198]:=168; tchar[199]:=151; tchar[200]:=150;
	
	tchar[201]:=165; tchar[202]:=197; tchar[203]:=214; tchar[204]:=255;
	tchar[205]:=23;  tchar[206]:=167; tchar[207]:=166; tchar[208]:=150;
	tchar[209]:=151; tchar[210]:=20;  tchar[211]:=164; tchar[212]:=163;
	tchar[213]:=147; tchar[214]:=148; tchar[215]:=255; tchar[216]:=17;
	tchar[217]:=162; tchar[218]:=163; tchar[219]:=147; tchar[220]:=146;
	tchar[221]:=162; tchar[222]:=22;  tchar[223]:=166; tchar[224]:=165;   
	tchar[225]:=149; tchar[226]:=150; tchar[227]:=255; tchar[228]:=87;
	tchar[229]:=149; tchar[230]:=211; tchar[231]:=255; tchar[232]:=22;
	tchar[233]:=214; tchar[234]:=20;  tchar[235]:=212; tchar[236]:=255;
	tchar[237]:=23;  tchar[238]:=213; tchar[239]:=147; tchar[240]:=255;
	tchar[241]:=23;  tchar[242]:=168; tchar[243]:=200; tchar[244]:=215;
	tchar[245]:=214; tchar[246]:=180; tchar[247]:=50;  tchar[248]:=177;
	tchar[249]:=255; tchar[250]:=23;  tchar[251]:=168; tchar[252]:=200;
	tchar[253]:=215; tchar[254]:=211; tchar[255]:=194; tchar[256]:=162;
	tchar[257]:=147; tchar[258]:=148; tchar[259]:=165; tchar[260]:=181;
	tchar[261]:=178; tchar[262]:=255; tchar[263]:=2;   tchar[264]:=184;
	tchar[265]:=226; tchar[266]:=20;  tchar[267]:=212; tchar[268]:=255;
	tchar[269]:=5;   tchar[270]:=197; tchar[271]:=212; tchar[272]:=211;	
	tchar[273]:=194; tchar[274]:=130; tchar[275]:=136; tchar[276]:=200;
	tchar[277]:=215; tchar[278]:=214; tchar[279]:=197; tchar[280]:=255;
	tchar[281]:=87;  tchar[282]:=200; tchar[283]:=152; tchar[284]:=135;
	tchar[285]:=131; tchar[286]:=146; tchar[287]:=194; tchar[288]:=211;
	tchar[289]:=255; tchar[290]:=2;   tchar[291]:=136; tchar[292]:=200;
	tchar[293]:=214; tchar[294]:=212; tchar[295]:=194; tchar[296]:=130;
	tchar[297]:=255; tchar[298]:=88;  tchar[299]:=136; tchar[300]:=130;
		
	tchar[301]:=210; tchar[302]:=53;  tchar[303]:=133; tchar[304]:=255;
	tchar[305]:=88;  tchar[306]:=136; tchar[307]:=130; tchar[308]:=53;
	tchar[309]:=133; tchar[310]:=255; tchar[311]:=87;  tchar[312]:=200;
	tchar[313]:=152; tchar[314]:=135; tchar[315]:=131; tchar[316]:=146;
	tchar[317]:=194; tchar[318]:=211; tchar[319]:=213; tchar[320]:=181;
	tchar[321]:=255; tchar[322]:=2;   tchar[323]:=136; tchar[324]:=88;   
	tchar[325]:=210; tchar[326]:=85;  tchar[327]:=133; tchar[328]:=255;
	tchar[329]:=40;  tchar[330]:=200; tchar[331]:=56;  tchar[332]:=178;
	tchar[333]:=34;  tchar[334]:=194; tchar[335]:=255; tchar[336]:=20;
	tchar[337]:=147; tchar[338]:=162; tchar[339]:=178; tchar[340]:=195;
	tchar[341]:=200; tchar[342]:=56;  tchar[343]:=216; tchar[344]:=255;
	tchar[345]:=8;   tchar[346]:=130; tchar[347]:=88;  tchar[348]:=133;
	tchar[349]:=210; tchar[350]:=255; tchar[351]:=24;  tchar[352]:=146;
	tchar[353]:=210; tchar[354]:=255; tchar[355]:=2;   tchar[356]:=136;
	tchar[357]:=181; tchar[358]:=232; tchar[359]:=226; tchar[360]:=255;
	tchar[361]:=2;   tchar[362]:=136; tchar[363]:=226; tchar[364]:=232;
	tchar[365]:=255; tchar[366]:=7;   tchar[367]:=152; tchar[368]:=216;
	tchar[369]:=231; tchar[370]:=227; tchar[371]:=210; tchar[372]:=146;	
	tchar[373]:=131; tchar[374]:=135; tchar[375]:=255; tchar[376]:=2;
	tchar[377]:=136; tchar[378]:=200; tchar[379]:=215; tchar[380]:=214;
	tchar[381]:=197; tchar[382]:=133; tchar[383]:=255; tchar[384]:=7;
	tchar[385]:=152; tchar[386]:=216; tchar[387]:=231; tchar[388]:=228;
	tchar[389]:=194; tchar[390]:=146; tchar[391]:=131; tchar[392]:=135;
	tchar[393]:=68;  tchar[394]:=226; tchar[395]:=255; tchar[396]:=2;
	tchar[397]:=136; tchar[398]:=200; tchar[399]:=215; tchar[400]:=214;
		
	tchar[401]:=197; tchar[402]:=133; tchar[403]:=53;  tchar[404]:=210;
	tchar[405]:=255; tchar[406]:=87;  tchar[407]:=200; tchar[408]:=152;
	tchar[409]:=135; tchar[410]:=134; tchar[411]:=149; tchar[412]:=197;
	tchar[413]:=212; tchar[414]:=211; tchar[415]:=194; tchar[416]:=146;
	tchar[417]:=131; tchar[418]:=255; tchar[419]:=8;   tchar[420]:=232;
	tchar[421]:=56;  tchar[422]:=178; tchar[423]:=255; tchar[424]:=24;   
	tchar[425]:=147; tchar[426]:=162; tchar[427]:=194; tchar[428]:=211;
	tchar[429]:=216; tchar[430]:=255; tchar[431]:=8;   tchar[432]:=178;
	tchar[433]:=232; tchar[434]:=255; tchar[435]:=8;   tchar[436]:=146;
	tchar[437]:=181; tchar[438]:=210; tchar[439]:=232; tchar[440]:=255;
	tchar[441]:=8;   tchar[442]:=226; tchar[443]:=104; tchar[444]:=130;
	tchar[445]:=255; tchar[446]:=24;  tchar[447]:=180; tchar[448]:=178;
	tchar[449]:=88;  tchar[450]:=180; tchar[451]:=255; tchar[452]:=8;
	tchar[453]:=232; tchar[454]:=130; tchar[455]:=226; tchar[456]:=255;
	tchar[457]:=88;  tchar[458]:=184; tchar[459]:=178; tchar[460]:=210;
	tchar[461]:=255; tchar[462]:=24;  tchar[463]:=210; tchar[464]:=255;
	tchar[465]:=24;  tchar[466]:=184; tchar[467]:=178; tchar[468]:=146;
	tchar[469]:=255; tchar[470]:=22;  tchar[471]:=184; tchar[472]:=214;	
	tchar[473]:=255; tchar[474]:=0;   tchar[475]:=224; tchar[476]:=255;
	tchar[477]:=102; tchar[478]:=215; tchar[479]:=216; tchar[480]:=232;
	tchar[481]:=231; tchar[482]:=215; tchar[483]:=255; tchar[484]:=5;
	tchar[485]:=150; tchar[486]:=182; tchar[487]:=197; tchar[488]:=195;
	tchar[489]:=178; tchar[490]:=146; tchar[491]:=131; tchar[492]:=148;
	tchar[493]:=196; tchar[494]:=67;  tchar[495]:=210; tchar[496]:=255;
	tchar[497]:=24;  tchar[498]:=146; tchar[499]:=194; tchar[500]:=211;
		
	tchar[501]:=212; tchar[502]:=197; tchar[503]:=149; tchar[504]:=255;
	tchar[505]:=85;  tchar[506]:=165; tchar[507]:=148; tchar[508]:=147;
	tchar[509]:=162; tchar[510]:=210; tchar[511]:=255; tchar[512]:=88;
	tchar[513]:=210; tchar[514]:=162; tchar[515]:=147; tchar[516]:=148;
	tchar[517]:=165; tchar[518]:=213; tchar[519]:=255; tchar[520]:=82;
	tchar[521]:=162; tchar[522]:=147; tchar[523]:=148; tchar[524]:=165;   
	tchar[525]:=197; tchar[526]:=212; tchar[527]:=148; tchar[528]:=255;
	tchar[529]:=87;  tchar[530]:=200; tchar[531]:=184; tchar[532]:=167;
	tchar[533]:=162; tchar[534]:=21;  tchar[535]:=197; tchar[536]:=255;
	tchar[537]:=17;  tchar[538]:=160; tchar[539]:=176; tchar[540]:=193;
	tchar[541]:=197; tchar[542]:=165; tchar[543]:=148; tchar[544]:=147;
	tchar[545]:=162; tchar[546]:=194; tchar[547]:=255; tchar[548]:=18;
	tchar[549]:=152; tchar[550]:=21;  tchar[551]:=181; tchar[552]:=196;
	tchar[553]:=194; tchar[554]:=255; tchar[555]:=50;  tchar[556]:=181;
	tchar[557]:=55;  tchar[558]:=184; tchar[559]:=255; tchar[560]:=18;
	tchar[561]:=145; tchar[562]:=160; tchar[563]:=176; tchar[564]:=193;
	tchar[565]:=197; tchar[566]:=71;  tchar[567]:=200; tchar[568]:=255;
	tchar[569]:=24;  tchar[570]:=146; tchar[571]:=20;  tchar[572]:=199;	
	tchar[573]:=37;  tchar[574]:=210; tchar[575]:=255; tchar[576]:=40;
	tchar[577]:=184; tchar[578]:=178; tchar[579]:=34;  tchar[580]:=194;
	tchar[581]:=255; tchar[582]:=2;   tchar[583]:=133; tchar[584]:=4;
	tchar[585]:=149; tchar[586]:=165; tchar[587]:=180; tchar[588]:=178;
	tchar[589]:=52;  tchar[590]:=197; tchar[591]:=213; tchar[592]:=228;
	tchar[593]:=226; tchar[594]:=255; tchar[595]:=18;  tchar[596]:=149;
	tchar[597]:=20;  tchar[598]:=165; tchar[599]:=197; tchar[600]:=212;
		
	tchar[601]:=210; tchar[602]:=255; tchar[603]:=20;  tchar[604]:=165;
	tchar[605]:=197; tchar[606]:=212; tchar[607]:=211; tchar[608]:=194;
	tchar[609]:=162; tchar[610]:=147; tchar[611]:=148; tchar[612]:=255;
	tchar[613]:=16;  tchar[614]:=149; tchar[615]:=197; tchar[616]:=212;
	tchar[617]:=211; tchar[618]:=194; tchar[619]:=146; tchar[620]:=255;
	tchar[621]:=80;  tchar[622]:=213; tchar[623]:=165; tchar[624]:=148;   
	tchar[625]:=147; tchar[626]:=162; tchar[627]:=210; tchar[628]:=255;
	tchar[629]:=18;  tchar[630]:=149; tchar[631]:=20;  tchar[632]:=165;
	tchar[633]:=181; tchar[634]:=196; tchar[635]:=255; tchar[636]:=19;
	tchar[637]:=162; tchar[638]:=194; tchar[639]:=211; tchar[640]:=196;
	tchar[641]:=164; tchar[642]:=149; tchar[643]:=166; tchar[644]:=198;
	tchar[645]:=213; tchar[646]:=255; tchar[647]:=40;  tchar[648]:=163;
	tchar[649]:=178; tchar[650]:=194; tchar[651]:=211; tchar[652]:=212;
	tchar[653]:=22;  tchar[654]:=182; tchar[655]:=255; tchar[656]:=21;
	tchar[657]:=147; tchar[658]:=162; tchar[659]:=194; tchar[660]:=211;
	tchar[661]:=213; tchar[662]:=83;  tchar[663]:=226; tchar[664]:=255;
	tchar[665]:=21;  tchar[666]:=178; tchar[667]:=213; tchar[668]:=255;
	tchar[669]:=21;  tchar[670]:=162; tchar[671]:=180; tchar[672]:=194;	
	tchar[673]:=213; tchar[674]:=255; tchar[675]:=21;  tchar[676]:=194;
	tchar[677]:=18;  tchar[678]:=197; tchar[679]:=255; tchar[680]:=21;
	tchar[681]:=178; tchar[682]:=85;  tchar[683]:=178; tchar[684]:=161;
	tchar[685]:=144; tchar[686]:=255; tchar[687]:=21;  tchar[688]:=213;
	tchar[689]:=146; tchar[690]:=210; tchar[691]:=255; tchar[692]:=72;
	tchar[693]:=184; tchar[694]:=167; tchar[695]:=166; tchar[696]:=149;
	tchar[697]:=164; tchar[698]:=163; tchar[699]:=178; tchar[700]:=194;
		
	tchar[701]:=255; tchar[702]:=48;  tchar[703]:=184; tchar[704]:=255;
	tchar[705]:=40;  tchar[706]:=184; tchar[707]:=199; tchar[708]:=198;
	tchar[709]:=213; tchar[710]:=196; tchar[711]:=195; tchar[712]:=178;
	tchar[713]:=162; tchar[714]:=255; tchar[715]:=7;   tchar[716]:=152;
	tchar[717]:=168; tchar[718]:=198; tchar[719]:=214; tchar[720]:=231;
	tchar[721]:=255; 
		

	ichar[001]:=1;   ichar[002]:=2;   ichar[003]:=7;   ichar[004]:=12;
	ichar[005]:=21;  ichar[006]:=32;  ichar[007]:=45;  ichar[008]:=57;
	ichar[009]:=64;  ichar[010]:=69;  ichar[011]:=74;  ichar[012]:=81;
	ichar[013]:=86;  ichar[014]:=93;  ichar[015]:=96;  ichar[016]:=102;
	ichar[017]:=105; ichar[018]:=115; ichar[019]:=121; ichar[020]:=130;
	ichar[021]:=142; ichar[022]:=148; ichar[023]:=158; ichar[024]:=171;   
	ichar[025]:=175; ichar[026]:=192; ichar[027]:=205; ichar[028]:=216;
	ichar[029]:=228; ichar[030]:=232; ichar[031]:=237; ichar[032]:=241;
	ichar[033]:=250; ichar[034]:=263; ichar[035]:=269; ichar[036]:=281;
	ichar[037]:=290; ichar[038]:=298; ichar[039]:=305; ichar[040]:=311;
	ichar[041]:=322; ichar[042]:=329; ichar[043]:=336; ichar[044]:=345;
	ichar[045]:=351; ichar[046]:=355; ichar[047]:=361; ichar[048]:=366;
	ichar[049]:=376; ichar[050]:=384; ichar[051]:=396; ichar[052]:=406;
	ichar[053]:=419; ichar[054]:=424; ichar[055]:=431; ichar[056]:=435;
	ichar[057]:=441; ichar[058]:=446; ichar[059]:=452; ichar[060]:=457;
	ichar[061]:=462; ichar[062]:=465; ichar[063]:=470; ichar[064]:=474;
	ichar[065]:=477; ichar[066]:=484; ichar[067]:=497; ichar[068]:=505;
	ichar[069]:=512; ichar[070]:=520; ichar[071]:=529; ichar[072]:=537;	
	ichar[073]:=548; ichar[074]:=555; ichar[075]:=560; ichar[076]:=569;
	ichar[077]:=576; ichar[078]:=582; ichar[079]:=595; ichar[080]:=603;
	ichar[081]:=613; ichar[082]:=621; ichar[083]:=629; ichar[084]:=636;
	ichar[085]:=647; ichar[086]:=656; ichar[087]:=665; ichar[088]:=669;
	ichar[089]:=675; ichar[090]:=680; ichar[091]:=687; ichar[092]:=692;
	ichar[093]:=702; ichar[094]:=705; ichar[095]:=715; 

		
	schar:=AndInt( ORD(charin),127);
	IF (schar>=32) THEN	
	  i:=schar-31;
	  i:=ichar[i];
	  WHILE tchar[i] < 255 DO
	    cmd:=tchar[i];
	    i:=i+1;
	    iy:=AndInt(cmd, 15);
	    ix:=AndInt(cmd,112);
	    ix:=ix DIV 16;
	    x:=REAL(ix)*chxsz/7.0;
	    y:=REAL(iy)*chysz/9.0;
	    t:=x;
	    x:=cx + scale[3]*t - scale[4]*y;
	    y:=cy + scale[4]*t + scale[3]*y;
	    IF (cmd < 128) THEN
	       gmove(x,y)
	    ELSE
	       vector(x,y)
            END
	  END
	END
END gchar;

PROCEDURE gwrite(x,y : REAL; chars : textline);
VAR
	i : INTEGER;
BEGIN
	FOR i:=0 TO Length(chars)-1 DO
	  gchar(x,y, chars[i]);		
	  x:=x+chxsz*scale[3];
	  y:=y+chxsz*scale[4]
	END
END gwrite;

PROCEDURE Print( x,y : INTEGER; satz : textline); 
BEGIN
	gwrite(REAL(x/639),REAL((255-y)/255),satz)
END Print;

PROCEDURE rx( sxi : REAL ) : REAL; (* Bildkoordinate => Realkoordinate *)
BEGIN
	RETURN scale[1]*(sxi-sxrt) + xmin
END rx;

PROCEDURE ry( syi : REAL ) : REAL; (* siehe rx *)
BEGIN
	RETURN scale[2]*(syi-sybot) + ymin
END ry;

PROCEDURE sx( rxi : REAL ) : REAL; 
	(* Realkoordinate => Bildschirmkoordinate *)
BEGIN
	RETURN (rxi-xmin)/scale[1]+sxleft
END sx;

PROCEDURE sy( ryi : REAL ) : REAL; (* siehe sx *)
BEGIN
	RETURN (ryi-ymin)/scale[2]+sybot
END sy;

PROCEDURE swindo( sxlti,sxrti,syboti,sytopi : REAL ); (* Bildschirmfenster  *)
                                                      (* <> Amiga-Fenster ! *)	
VAR
	t : REAL;
BEGIN
	sxleft:=sxlti;
	sxrt  :=sxrti;
	sybot :=syboti;
	sytop :=sytopi;
	t:=sxrt-sxleft;
	IF (sytop - sybot < t) THEN t:=sytop-sybot END;
	IF (t < 0.0001) THEN
	   WriteString('Error during execution !'); WriteLn
	ELSIF ( (xmax-xmin = 0.0) OR (ymax-ymin = 0.0) ) THEN
           WriteString('Error during execution !'); WriteLn
	ELSE 
	   scale[1]:=(xmax-xmin)/(sxrt-sxleft);
	   scale[2]:=(ymax-ymin)/(sytop-sybot)
	END
END swindo;

PROCEDURE rwindo( xmini,xmaxi,ymini,ymaxi : REAL); (* Real-Fenster *)
BEGIN
	xmin:=xmini;
	xmax:=xmaxi;
	ymin:=ymini;
	ymax:=ymaxi;
	swindo( sxleft, sxrt, sybot, sytop )
END rwindo;

PROCEDURE segmnt (x1,y1,x2,y2 : REAL); (* Liniensegment *)
VAR
	xa,ya,xb,yb : INTEGER;
BEGIN
	xa:=TRUNC(639.0*x1);
	ya:=TRUNC(255.0*y1);
	xb:=TRUNC(639.0*x2);
	yb:=TRUNC(255.0*y2);
	DrawLine(xa,255-ya,xb,255-yb);
	xpos:=xb;
	ypos:=yb
END segmnt;

PROCEDURE InitVector; (* Initialisierung der Vektorgrafik *)
BEGIN
	xpos   :=0;
	ypos   :=0;
	xmin   :=0.0;
	xmax   :=1.0;
	ymin   :=0.0;
	ymax   :=1.0;
	sxleft :=0.0;
	sxrt   :=1.0;
	sybot  :=0.0;
	sytop  :=1.0;
	chxsz  :=0.0218;
	chysz  :=0.0420;
	chrot  :=0.0;
	scale[1]:=1.0;
	scale[2]:=1.0;
	scale[3]:=1.0;
	scale[4]:=0.0;
	nxchar  :=0;
	nychar  :=0;
	nxline  :=1
END InitVector;	   
	
PROCEDURE point (x,y : REAL);  (* Punkt setzen *)
VAR
	x1,y1 : INTEGER;
BEGIN
	IF ( ABS(x) <= 1.0) AND ( ABS(y) <= 1.0) THEN 
	  x1:=TRUNC(639.0*x);
	  y1:=TRUNC(255.0*y);
	  PlotPixel(x1,255-y1);
          xpos:=x1;
          ypos:=y1
	END
END point;

PROCEDURE posang (angle : REAL) : REAL; (* Winkel innerhalb 0..360 grad *)
BEGIN
	IF ( (angle < 360.0) AND (angle >=0.0) ) THEN
	  RETURN angle
	ELSE 
	  angle:=angle - 360.0*REAL(TRUNC(angle/360.0));
	  IF (angle < 0.0) THEN angle:=angle+360.0 END;
	  RETURN angle
	END
END posang;

PROCEDURE ticend (rmin,rmax,dr : REAL; VAR pr1,pr2 : REAL);
VAR
	r1,r2 : REAL;
BEGIN                             (* Gre des Achsenendes *)
	r1:=REAL(TRUNC(rmin/dr))*dr;
	r2:=REAL(TRUNC(rmax/dr))*dr;
	IF ( (r1 < 0.0) OR (r2 < 0.0) ) THEN 
	   IF ( (r1 > 0.0) OR (r2 > 0.0) ) THEN 
	      pr1:=r1;
	      pr2:=r2
	   ELSE 
	      IF ( (dr<0.0) AND (r1>rmin) ) THEN r1:=r1+dr END;
	      IF ( (dr>0.0) AND (r2>rmax) ) THEN r2:=r2-dr END
	   END
	ELSE 
	   IF ( (dr>0.0) AND (r1<rmin) ) THEN r1:=r1+dr END;
	   IF ( (dr<0.0) AND (r2<rmax) ) THEN r2:=r2-dr END
	END;
	pr1:=r1;
	pr2:=r2
END ticend;

PROCEDURE dxdy( x1,x2 : REAL; nx : INTEGER; VAR lblnum,lbldec : INTEGER)
                                                                   : REAL; 
VAR
	xlen,dx,dxlog,dxmant,t,ln10 : REAL;
	dxexp : INTEGER;                      (* Zeichenabstand berechnen *)
BEGIN
    ln10:=ln(10.0);
    xlen:=x2-x1;
    IF (xlen = 0.0) THEN 
        WriteString('Error during execution !');
        WriteLn;
	lbldec:=0;
	lblnum:=0;
	RETURN 0.0
    ELSE 
	dx:=ABS( xlen/REAL(nx));
	dxlog:=ln(dx)/ln10;
	dxexp:=TRUNC(dxlog);
	dxmant:=dxlog-REAL(dxexp);
	IF (dxmant <= 0.0) THEN
	  dxexp:=dxexp-1;
	  dxmant:=dxmant+1.0
	END;
	dx:=1.0;
	IF (dxmant > 0.18) THEN
	  dx:=2.0 END;
	IF (dxmant > 0.40) THEN 
	  dx:=5.0 END;
	IF (dxmant > 0.88) THEN
	  dx:=10.0 END;
	dx:=dx*exp( ln10*REAL(dxexp) )*xlen/ABS( xlen );
	dxlog:=xlen;
	IF (x1 <> 0.0) THEN 
	  t:= ABS(x1);
	  IF (t > dxlog) THEN dxlog:=t END
	END;
	IF (x2 <> 0.0) THEN 
	  t:=ABS(x2);
	  IF (t > dxlog) THEN dxlog:=t END
	END;
	dxlog:=ln(dxlog)/ln10;
	IF ( dxlog > 0.0) THEN
	  lblnum:=TRUNC(dxlog+1.0)
	ELSE
	  lblnum:=0
        END;
	dxlog:=ABS(xlen);
	IF (x1 <> 0.0) THEN 
	  t:=ABS(x1);
	  IF (t < dxlog) THEN dxlog:=t END
	END;
	IF (x2 <> 0.0) THEN 
	  t:=ABS(x2);
	  IF (t < dxlog) THEN dxlog:=t END
	END;
	t:=ABS(dx);
	IF (t < dxlog) THEN dxlog:=t END;
	dxlog:=ln(dxlog)/ln10;
	IF (dxlog < 0.0) THEN
	  lbldec:=TRUNC(-dxlog+1.0)
	ELSE
	  lbldec:=0
        END;
	lblnum:=lblnum + lbldec +2;
	RETURN dx
    END
END dxdy;

PROCEDURE axis( r1,r2,dri,sx1,sy1,sx2,sy2,ticlen,ticang : REAL;
                lblnum,lbldec : INTEGER; lblang : REAL);
	(* Achsen zeichnen *)
VAR
	angtic,anglbl,lentic,xlen,ylen,rlen,dr,rtic,rend,xtic,ytic,
	angtst,xlabel,ylabel,t,radian,x,y,dtic : REAL;
	alabel : STRING;
        logo : BOOLEAN;
BEGIN
	radian:=57.29578;
	IF ( (dri = 0.0) OR (r2-r1 = 0.0) ) THEN 
	   WriteString('Error during execution !'); WriteLn
	ELSE 
	   IF (lblnum < 7) THEN lblnum:=7 END;
	   IF ( ( (r1<0.0) OR (r2<0.0) ) AND (lblnum < 8) ) THEN lblnum:=8 END;
	   angtic:=ticang;
	   IF (ticlen < 0.0) THEN angtic:= -angtic END;
	   angtic:=posang(angtic);
	   anglbl:=posang(lblang);
	   lentic:=ABS(ticlen);	
	   xlen:=sx2-sx1;
	   ylen:=sy2-sy1;
	   rlen:=r2-r1;
	   dr:=ABS(dri) * ABS(rlen)/rlen;
	   ticend(r1,r2,dr,rtic,rend);
	   angtst:=posang(angtic-anglbl);
	   angtic:=angtic/radian;
	   anglbl:=anglbl/radian;
	   xtic:=lentic*cos(angtic);
	   ytic:=lentic*sin(angtic);
	   scale[3]:=cos(anglbl);
	   scale[4]:=sin(anglbl);
	   IF ( (angtst < 45.0) OR (angtst >= 315.0) ) THEN 
		xlabel:=( chxsz*scale[3] + chysz*scale[4]) /2.0;
 	        ylabel:=(-chysz*scale[3] - chxsz*scale[4])/2.0
	   ELSIF ( angtst < 135.0) THEN 
	        t:=REAL(lblnum-lbldec-1) * chxsz;
	        xlabel:=-t*scale[3] - chysz*scale[4]/2.0;
	        ylabel:=-t*scale[4] + chysz*scale[3]/2.0
	   ELSIF ( angtst < 225.0) THEN
	        t:=(REAL(lblnum)+0.5)*chxsz;
	        xlabel:=-scale[4]*chysz/2.0 - t*scale[3];
	        ylabel:=-scale[3]*chysz/2.0 - t*scale[4]
	   ELSIF ( angtst < 315.0) THEN 
	        t:=REAL(lblnum-lbldec-1)*chxsz;
	        xlabel:=-t*scale[3] + chysz*scale[4]*1.5;
	        ylabel:=-t*scale[4] - chysz*scale[3]*1.5
	   END;
	   segmnt( sx1,sy1, sx2, sy2);
	   WHILE ( (dr<0.0) AND (rtic>=rend) ) OR ( (dr>0.0) AND (rtic<=rend))
	   DO 
	        dtic:=(rtic-r1)/rlen;
	        x:=xlen*dtic+sx1;
	        y:=ylen*dtic+sy1;
	        gmove(x,y);
	        x:=x+xtic;
	        y:=y+ytic;
	        vector(x,y);
	        x:=x+xlabel;
	        y:=y+ylabel;
       	        RealToStr(rtic,alabel,lblnum,lbldec,FALSE,logo);
                gwrite(x,y,alabel);
	        rtic:=rtic+dr
	   END;
	   t:=chrot/radian;
	   scale[3]:=cos(t);
	   scale[4]:=sin(t)
	END
END axis;
	        
PROCEDURE graph1 ( grid : CARDINAL; xmini,xmaxi : REAL; 
                 nx : INTEGER; ymini,ymaxi : REAL; 
	         ny : INTEGER; sxl,sxr,syb,syt : REAL;
                 titel,xcom,ycom : STRING); 
	      (* Koordinatenkreuz zeichnen *)
VAR
	dx,dy,tic,xdot,ydot,dxydot,xydot,ticnd : REAL;	
	lblnum,lbldec : INTEGER;
BEGIN
       chxsz:=0.0218;
       chysz:=0.0420;
       chrot:=0.0;
       xmin:=xmini;
       ymin:=ymini;
       xmax:=xmaxi;
       ymax:=ymaxi;
       swindo(sxl,sxr,syb,syt);
       dx:=dxdy(xmin,xmax,nx,lblnum,lbldec);
       nxchar:=lblnum;
       axis(xmin,xmax,dx,sxl,syb,sxr,syb,0.0148,270.0,lblnum,lbldec,0.0);
       dy:=dxdy(ymin,ymax,ny,lblnum,lbldec);
       nychar:=lblnum;
       axis(ymin,ymax,dy,sxl,syb,sxl,syt,0.0101,180.0,lblnum,lbldec,0.0);
       IF ((grid=2) OR (grid=1)) THEN   
	ticend(xmin,xmax,dx,tic,ticnd);
	dxydot:=dy/5.0;
	IF (tic=xmin) THEN tic:=tic+dx END;
	WHILE ((dx>0.0) AND (tic<=ticnd)) OR ((dx<0.0) AND (tic>=ticnd)) DO
         CASE grid OF 
         1:
      	         xdot:=sx(tic);     (* in vertikaler Richtung Punktraster *)
	         tic:=tic+dx;
	         xydot:=ymin+dxydot;
	         WHILE ((dxydot>0.0) AND (xydot<=ymax)) OR 
	               ((dxydot<0.0) AND (xydot>=ymax)) DO
	            ydot:=sy(xydot);
	            xydot:=xydot + dxydot;
	            point(xdot,ydot)
	         END |
         2:    xdot:=sx(tic);    (* geschlossenes Raster vertikal *)
                 tic:=tic+dx;
                 ydot:=sy(ymin);
                 gmove(xdot,ydot);
                 ydot:=sy(ymax);
                 vector(xdot,ydot)         
         END; (* CASE *)        
	END;
	ticend(ymin,ymax,dy,tic,ticnd);
	dxydot:=dx/5.0;
	IF (tic=ymin) THEN tic:=tic+dy END;
	WHILE ((dy>0.0) AND (tic<=ticnd)) OR ((dy<0.0) AND (tic>=ticnd)) DO
         CASE grid OF
         1:            (* horizontale Linie mit Punkten *)
       	         ydot:=sy(tic);
	         tic:=tic+dy;
	         xydot:=xmin+dxydot;
	         WHILE ((dxydot>0.0) AND (xydot<=xmax)) OR
	               ((dxydot<0.0) AND (xydot>=xmax)) DO
	            xdot:=sx(xydot);
	            xydot:=xydot+dxydot;
	            point(xdot,ydot)
	         END |
         2:    ydot:=sy(tic);  (* geschlossene Raster horizontal *)
                 tic:=tic+dy;    
                 xdot:=sx(xmin);
                 gmove(xdot,ydot);
                 xdot:=sx(xmax);
                 vector(xdot,ydot)  
         END (* CASE *)        
       	END
       END; 
       gwrite(sxl,syt+0.02,titel);
       gwrite(sxl,syb-0.125,xcom);
       ChSet(1.5*chxsz,0.6674*chysz,90.0);
       gwrite(sxl-0.12,syb,ycom)
END graph1;
	
PROCEDURE sxlog (rx : REAL) : REAL;
BEGIN
	RETURN sx(log(ABS(rx))) 	
END sxlog;

PROCEDURE sylog (ry : REAL) : REAL;
BEGIN
	RETURN sy(20.0*log(ABS(ry)))
END sylog;

PROCEDURE logstep (x,logst : REAL) : REAL;
BEGIN
	RETURN PwrOfTen(log(ABS(x))+ABS(logst))
END logstep;

PROCEDURE linstep (x,linst : REAL) : REAL;
BEGIN
	RETURN x+linst
END linstep;

PROCEDURE graph2 ( grid : CARDINAL; xanf, xende, yanf, yende : REAL;
                   ny : INTEGER;
                   sxl,sxr,syb,syt : REAL;
                   titel,xcom,ycom : STRING);
VAR	
	ydot, dx,dy,tic,ticnd,xdot : REAL;
        lblnum, lbldec, nx, i,j : INTEGER;
        grid2 : CARDINAL;
BEGIN
       xanf :=log(ABS(xanf ));
       xende:=log(ABS(xende));
       nx:=ABS( TRUNC(xende)-TRUNC(xanf)); (* Anzahl der Intervalle *)
       IF grid=3 THEN grid2:=2 
       ELSIF grid=2 THEN grid2:=2  
       ELSE grid2:=0 END;
       graph1( grid2, xanf, xende, nx, yanf, yende, ny, sxl, sxr, syb, syt,
                titel,xcom,ycom);  
        dx:=dxdy(xanf, xende, nx, lblnum, lbldec);
        ticend(xanf, xende, dx, tic, ticnd);
        FOR j:=1 TO nx DO
          FOR i:=1 TO 9 DO
            xdot:=sx(tic+log(REAL(i)));
            ydot:=sy(yanf)-0.01;
            gmove(xdot,ydot);
            IF grid=2 THEN
              IF NOT ODD(i) THEN
                 ydot:=sy(yende)
              ELSE
                 ydot:=sy(yanf)
              END
            ELSE
              ydot:=sy(yanf)
            END;  
            vector(xdot,ydot)
          END;
	  tic:=tic+dx
        END
END graph2;

PROCEDURE SetCross; (* Kreuz an aktuelle Cursorposition *)
BEGIN
	DrawLine( xpos-4, 255-ypos, xpos+4, 255-ypos);
        DrawLine(   xpos, 253-ypos,   xpos, 257-ypos)
END SetCross;

PROCEDURE SetCircle; (* Kreis an aktuelle Cursorposition *) 
BEGIN
	Ellipse( xpos, 255-ypos, 4, 2)
END SetCircle;

END GraphicLib.	   
