(*
Zweck:       - Dieses Programm kann die maschinenlesbaren Nummern
             des neuen Personalausweises berprfen und solche Nummern
             selbst erzeugen.
Compiler:    - verwendeter Compiler: M2Amiga von A.+L.Meier-Vogt,
             Version 3.2d (geht auch mit 3.1d)
Version:     - 20.April 1989
             (jetzt mit Eingabe des Geburtsdatums, gewnschten Ablauf-
             datums und der Ausweisnummer bei Berechnung neuer
             Zahlen und der Ausgabe dieser Daten bei der berprfung
             gltiger Nummern)
Author       - Florian Unger
Copyright:   - PublicDomain (nicht fr feindliche Spione, Agenten,
             Chaoten und andere Destruktivisten; Zuwiderhandlungen
             werden mit BASIC nicht unter 2 Jahren bestraft !)
Bemerkungen: - Programm ist gegen falsche Eingaben nicht
             gesichert. Falsche Eingaben werden von Arts aber voll
             abgefangen.
*)
MODULE Personalausweis ;

FROM InOut        IMPORT WriteInt,WriteString,WriteLn,
                         Read,ReadLongInt ;

TYPE Typ9 = ARRAY [1..10] OF CARDINAL ;
     Typ6 = ARRAY [1..7] OF CARDINAL ;
     Gesamt = RECORD
                Zahl1 : Typ9 ;
                Zahl2 : Typ6 ;
                Zahl3 : Typ6 ;
                Zahl4 : CARDINAL
              END ;

VAR Zeichen : CHAR ;
    Nummer : Gesamt ;

PROCEDURE ReadLn(VAR c : CHAR) ;
(* wie die gleichnamige Prozedur in PASCAL *)
VAR d : CHAR ;
BEGIN
  Read(c) ;
  Read(d)   (* CR *)
END ReadLn ;

PROCEDURE CharToInt(c : CHAR) : CARDINAL ;
(* ist der Wert von c nicht von "0" bis "9", so ergibt sich ein
Laufzeitfehler, da die Prozedur ohne RETURN abgeschlossen wird *)
BEGIN
  IF (ORD(c)>47) AND (ORD(c)<58) THEN
    RETURN ORD(c)-48
  END (* IF *)
END CharToInt ;

PROCEDURE IntToChar(i : CARDINAL) : CHAR ;
(* Laufzeitfehler bei i>10, da kein RETURN *)
BEGIN
  IF (i<11) THEN
    RETURN CHR(i+48)
  END (* IF *)
END IntToChar ;

PROCEDURE LetzteZiffer(i : CARDINAL) : CARDINAL ;
BEGIN
  WHILE (i>9) DO
    DEC(i,10)
  END ; (* WHILE *)
  RETURN(i)
END LetzteZiffer ;

PROCEDURE PruefeNummer(n : Gesamt) : BOOLEAN ;
VAR i,j,k,l,m : CARDINAL ;
    t : BOOLEAN ;
BEGIN
  j := 0 ;
  FOR i := 1 TO 7 BY 3 DO
    j := j + (n.Zahl1[0+i] * 7) ;
    j := j + (n.Zahl1[1+i] * 3) ;
    j := j + (n.Zahl1[2+i] * 1)
  END ; (* FOR *)
  k := 0 ;
  FOR i := 1 TO 4 BY 3 DO
    k := k + (n.Zahl2[0+i] * 7) ;
    k := k + (n.Zahl2[1+i] * 3) ;
    k := k + (n.Zahl2[2+i] * 1)
  END ; (* FOR *)
  l := 0 ;
  FOR i := 1 TO 4 BY 3 DO
    l := l + (n.Zahl3[0+i] * 7) ;
    l := l + (n.Zahl3[1+i] * 3) ;
    l := l + (n.Zahl3[2+i] * 1)
  END ; (* FOR *)
  m := 0 ;
  FOR i := 1 TO 7 BY 3 DO
    m := m + (n.Zahl1[0+i] * 7) ;
    m := m + (n.Zahl1[1+i] * 3) ;
    m := m + (n.Zahl1[2+i] * 1)
  END ; (* FOR *)
  m := m + (n.Zahl1[10] * 7) ;
  FOR i := 1 TO 4 BY 3 DO
    m := m + (n.Zahl2[0+i] * 3) ;
    m := m + (n.Zahl2[1+i] * 1) ;
    m := m + (n.Zahl2[2+i] * 7)
  END ; (* FOR *)
  m := m + (n.Zahl2[7] * 3) ;
  FOR i := 1 TO 4 BY 3 DO
    m := m + (n.Zahl3[0+i] * 1) ;
    m := m + (n.Zahl3[1+i] * 7) ;
    m := m + (n.Zahl3[2+i] * 3)
  END ; (* FOR *)
  m := m + (n.Zahl3[7] * 1) ;
  t := (LetzteZiffer(j)=n.Zahl1[10])
       AND (LetzteZiffer(k)=n.Zahl2[7])
       AND (LetzteZiffer(l)=n.Zahl3[7])
       AND (LetzteZiffer(m)=n.Zahl4) ;
  RETURN t
END PruefeNummer ;

PROCEDURE PruefeDaten(n : Gesamt) ;
VAR i : INTEGER ;
BEGIN
  WriteString("Ausweisnummer ist : ") ;
  FOR i := 1 TO 9 DO
    WriteInt(n.Zahl1[i],1)
  END ; (* FOR *)
  WriteLn ;
  WriteString("Geburtstag des Inhabers (TT-MM-JJ) ist : ") ;
  WriteInt(n.Zahl2[5],1) ;
  WriteInt(n.Zahl2[6],1) ;
  WriteString("-") ;
  WriteInt(n.Zahl2[3],1) ;
  WriteInt(n.Zahl2[4],1) ;
  WriteString("-") ;
  WriteInt(n.Zahl2[1],1) ;
  WriteInt(n.Zahl2[2],1) ;
  WriteLn ;
  WriteString("Ablaufdatum (TT-MM-JJ) ist : ") ;
  WriteInt(n.Zahl3[5],1) ;
  WriteInt(n.Zahl3[6],1) ;
  WriteString("-") ;
  WriteInt(n.Zahl3[3],1) ;
  WriteInt(n.Zahl3[4],1) ;
  WriteString("-") ;
  WriteInt(n.Zahl3[1],1) ;
  WriteInt(n.Zahl3[2],1) ;
  WriteLn
END PruefeDaten ;

PROCEDURE BerechneNummer(VAR n : Gesamt) ;
VAR i,j : CARDINAL ;
    ch : CHAR ;
BEGIN
(* erste Teilzahl *)
  WriteString("gewnschte Ausweisnummer eingeben (9 Ziffern) > ") ;
  FOR i := 1 TO 9 DO
    Read(ch) ;
    n.Zahl1[i] := CharToInt(ch)
  END ; (* FOR *)
  Read(ch) ;  (* das CR *)
  j := 0 ;
  FOR i := 1 TO 7 BY 3 DO
    j := j + (n.Zahl1[0+i] * 7) ;
    j := j + (n.Zahl1[1+i] * 3) ;
    j := j + (n.Zahl1[2+i] * 1)
  END ; (* FOR *)
  n.Zahl1[10] := LetzteZiffer(j) ;
(* zweite Teilzahl *)
  WriteString("Geburtsdatum eingeben (TT-MM-JJ) > ") ;
  Read(ch) ;
  n.Zahl2[5] := CharToInt(ch) ;
  Read(ch) ;
  n.Zahl2[6] := CharToInt(ch) ;
  Read(ch) ; (* das "-" *)
  Read(ch) ;
  n.Zahl2[3] := CharToInt(ch) ;
  Read(ch) ;
  n.Zahl2[4] := CharToInt(ch) ;
  Read(ch) ; (* das "-" *)
  Read(ch) ;
  n.Zahl2[1] := CharToInt(ch) ;
  ReadLn(ch) ;
  n.Zahl2[2] := CharToInt(ch) ;
  j := 0 ;
  FOR i := 1 TO 4 BY 3 DO
    j := j + (n.Zahl2[0+i] * 7) ;
    j := j + (n.Zahl2[1+i] * 3) ;
    j := j + (n.Zahl2[2+i] * 1)
  END ; (* FOR *)
  n.Zahl2[7] := LetzteZiffer(j) ;
(* dritte Teilzahl *)
  WriteString("gewnschtes Ablaufdatum eingeben (TT-MM-JJ) > ") ;
  Read(ch) ;
  n.Zahl3[5] := CharToInt(ch) ;
  Read(ch) ;
  n.Zahl3[6] := CharToInt(ch) ;
  Read(ch) ; (* das "-" *)
  Read(ch) ;
  n.Zahl3[3] := CharToInt(ch) ;
  Read(ch) ;
  n.Zahl3[4] := CharToInt(ch) ;
  Read(ch) ; (* das "-" *)
  Read(ch) ;
  n.Zahl3[1] := CharToInt(ch) ;
  ReadLn(ch) ;
  n.Zahl3[2] := CharToInt(ch) ;
  j := 0 ;
  FOR i := 1 TO 4 BY 3 DO
    j := j + (n.Zahl3[0+i] * 7) ;
    j := j + (n.Zahl3[1+i] * 3) ;
    j := j + (n.Zahl3[2+i] * 1)
  END ; (* FOR *)
  n.Zahl3[7] := LetzteZiffer(j) ;
  j := 0 ;
  FOR i := 1 TO 7 BY 3 DO
    j := j + (n.Zahl1[0+i] * 7) ;
    j := j + (n.Zahl1[1+i] * 3) ;
    j := j + (n.Zahl1[2+i] * 1)
  END ; (* FOR *)
  j := j + (n.Zahl1[10] * 7) ;
  FOR i := 1 TO 4 BY 3 DO
    j := j + (n.Zahl2[0+i] * 3) ;
    j := j + (n.Zahl2[1+i] * 1) ;
    j := j + (n.Zahl2[2+i] * 7)
  END ; (* FOR *)
  j := j + (n.Zahl2[7] * 3) ;
  FOR i := 1 TO 4 BY 3 DO
    j := j + (n.Zahl3[0+i] * 1) ;
    j := j + (n.Zahl3[1+i] * 7) ;
    j := j + (n.Zahl3[2+i] * 3)
  END ; (* FOR *)
  j := j + (n.Zahl3[7] * 1) ;
  n.Zahl4 := LetzteZiffer(j)
END BerechneNummer ;

PROCEDURE ReadGesamt(VAR n : Gesamt) ;
VAR c : CHAR ;
    i : CARDINAL ;
BEGIN
  WriteString("Bitte die zu berprfende Zahl ohne Leerstellen eingeben :") ;
  WriteLn ;
  WriteString("> ") ;
  FOR i := 1 TO 10 DO
    Read(c) ;
    n.Zahl1[i] := CharToInt(c)
  END ; (* FOR *)
  FOR i := 1 TO 7 DO
    Read(c) ;
    n.Zahl2[i] := CharToInt(c)
  END ; (* FOR *)
  FOR i := 1 TO 7 DO
    Read(c) ;
    n.Zahl3[i] := CharToInt(c)
  END ; (* FOR *)
  ReadLn(c) ;
  n.Zahl4 := CharToInt(c)
END ReadGesamt ;

PROCEDURE WriteGesamt(n : Gesamt) ;
VAR i : CARDINAL ;
BEGIN
  FOR i := 1 TO 10 DO
    WriteInt(n.Zahl1[i],1)
  END ; (* FOR *)
  WriteString("D<<") ;
  FOR i := 1 TO 7 DO
    WriteInt(n.Zahl2[i],1)
  END ; (* FOR *)
  WriteString("<") ;
  FOR i := 1 TO 7 DO
    WriteInt(n.Zahl3[i],1)
  END ; (* FOR *)
  WriteString("<<<<<<") ;
  WriteInt(n.Zahl4,1) ;
  WriteLn
END WriteGesamt ;

BEGIN (* main *)
  WriteString("Ende des Programms (0) ,") ;
  WriteLn ;
  WriteString("Berechnen (1) oder") ;
  WriteLn ;
  WriteString("berprfen (2) von Nummern ?") ;
  WriteLn ;
  WriteString("> ") ;
  ReadLn(Zeichen) ;
  WHILE (Zeichen#"0") DO
    CASE Zeichen OF
      "1" : BerechneNummer(Nummer) ;
            IF PruefeNummer(Nummer) THEN
              WriteString("Neue Nummer: ") ;
              WriteGesamt(Nummer)
            END | (* IF *)
      "2" : ReadGesamt(Nummer) ;
            IF PruefeNummer(Nummer) THEN
              WriteGesamt(Nummer) ;
              WriteString("ist eine gltige Nummer !!") ;
              WriteLn ;
              PruefeDaten(Nummer)
            ELSE
              WriteGesamt(Nummer) ;
              WriteString("ist keine gltige Nummer") ;
              WriteLn
            END | (* IF *)
      ELSE
        Read(Zeichen)
    END ; (* CASE *)
    WriteLn ;
    WriteString("Ende des Programms (0) ,") ;
    WriteLn ;
    WriteString("Berechnen (1) oder") ;
    WriteLn ;
    WriteString("berprfen (2) von Nummern ?") ;
    WriteLn ;
    WriteString("> ") ;
    ReadLn(Zeichen)
  END (* WHILE *)
END Personalausweis .
