(*--------------------------------------------------------------------------

:Program.    Topinc.MOD 
:Author.     Uwe Meyer
:Address.    Alex. v. Wacker P.4, 5000 Kln 71 
:Phone,      0221/704915
:Shortcut.   [umk]
:Version.    1.0
:Date.       07.Mar-89
:Copyright.  Public Domain
:Language.   Modula II
:Translator. M2Amiga v3.2d
:Imports.    InituiStruct, Nicolas Benezan [bne]
:Contents.   Hilfsprozeduren fr Top.MOD
----------------------------------------------------------------------------*)


IMPLEMENTATION MODULE Topinc;


FROM SYSTEM IMPORT
 ADR, ADDRESS, LONGSET, CAST;

FROM Arts IMPORT
 TermProcedure, CurrentLevel, Assert;
 
FROM Conversions IMPORT
 ValToStr;

FROM Dos IMPORT
 FileInfoBlockPtr, FileLockPtr, FileInfoBlock, InfoData, InfoDataPtr,
 Examine, ExNext, Info, Lock, UnLock, sharedLock, writeProtect, Delay,
 ProcessPtr;
 
FROM Exec IMPORT
 WaitPort, GetMsg, ReplyMsg, FindTask;

FROM Graphics IMPORT
 Move, Draw, Text, SetAPen, SetRast,
 ViewModes, ViewModeSet, RastPortPtr;

FROM Heap IMPORT
 AllocMem, Deallocate;
  
FROM Intuition IMPORT
 NewScreen, OpenScreen, CloseScreen, ScreenFlags, ScreenFlagSet, ScreenPtr,
 stdScreenHeight, customScreen,
 NewWindow, OpenWindow, CloseWindow, WindowFlags, WindowFlagSet, WindowPtr,
 SetWindowTitles, RefreshWindowFrame,
 IDCMPFlags, IDCMPFlagSet, IntuiMessagePtr,
 Gadget, GadgetFlags, GadgetFlagSet, ActivationFlags, ActivationFlagSet,
 boolGadget, GadgetPtr, RefreshGadgets, AddGadget, RemoveGList,
 propGadget, PropInfo, PropInfoFlags, PropInfoFlagSet, ModifyProp, Image,
 SetMenuStrip, MenuPtr, MenuItemFlagSet, MenuItemFlags,
 DrawImage;
 
FROM IntuiStruct IMPORT
 AllocProc, DeallocProc,
 StructScreen, StructWindow, StructProp, StructGadget, FreeImage,
 Item, LinkMenu, UnlinkMenu;
 
FROM Str IMPORT
 Copy, Length, Compare, Concat, CapString, FirstPos, LastPos, 
 first, last, noOccur;

FROM Topimg IMPORT
 dirimg, fileimg, diskimg, unprotimg, protimg;

 
VAR	processptr	: ProcessPtr;			(* Prozestruktur  *)
	syswin		: WindowPtr;			(* alter Sysrequ.  *)

 
PROCEDURE Init;

CONST	MENUBAR		= 11;				(* Pixelhhe Menu  *)
	DISKSPACE	= 28;				(* Platz Diskgads  *)
		
VAR	size		: INTEGER;			(* Windowhhe      *)
	ok		: BOOLEAN;			(* Status          *)
	i		: INTEGER;			(* Zhler          *)

BEGIN
(*--------------------------------------------------------------------------)
Vorbelegung der Variablen: act = aktives Fenster; entries = Dateien im Win.;
path = Pfadnamen der Windows; device = angeschlossene Gerte;
(--------------------------------------------------------------------------*)

 act := 0;
 entries[0] := -1;
 entries[1] := -1;
 path[0] := "DF0: ";
 path[1] := "DF1:";
 device[0] := "DF0:";
 device[1] := "DF1:";
 device[2] := "DF2:";
 device[3] := "DH0:";
 device[4] := "DH1:";
 device[5] := "DH2:";
 device[6] := "DH3:";
 device[7] := "RAM:";
 device[8] := "RAD:";

(*--------------------------------------------------------------------------)
Hier werden die beiden Proportionalgadgets initialisiert
(--------------------------------------------------------------------------*)

 FOR i := 0 TO 1 DO
  StructProp (prop[i], PropInfoFlagSet {autoKnob, freeVert}, 0, 0, 0, 65535);
  StructGadget (gad[i], -15, 10, 16, 88, GadgetFlagSet {gRelRight},
                ActivationFlagSet {relVerify}, propGadget, ADR (image),
                NIL, LONGSET {}, PROP, NIL);
  gad[i].specialInfo := ADR (prop[i]); 
 END;

(*--------------------------------------------------------------------------)
Erzeugen der Screenstruktur und ffnen des Screens mit Test auf Erfolg
(--------------------------------------------------------------------------*)

 StructScreen (ns, 2, 0, 1, ViewModeSet {hires}, customScreen,
               ADR ("SwA-Top 1.0  1989"));
 scr := OpenScreen (ns);
 Assert (scr # NIL, ADR ("Error scr"));

(*--------------------------------------------------------------------------)
Aufbau der Devicegadgets
(--------------------------------------------------------------------------*)

 FOR i := 0 TO DRIVES DO
  StructGadget (dgad[i], 20 + i * 60, scr^.height - DISKSPACE, 40, 20,
                GadgetFlagSet {gadgImage},
                ActivationFlagSet {relVerify}, boolGadget, ADR (diskimg),
                NIL, LONGSET {}, i, NIL);
  IF i = DRIVES THEN
   dgad[i].nextGadget := NIL;
  ELSE
   dgad[i].nextGadget := ADR (dgad[i + 1]);
  END;
 END;

(*--------------------------------------------------------------------------)
Erzeugen des Hauptwindows und ffnen des Windows mit Test auf Erfolg
(--------------------------------------------------------------------------*)

 StructWindow (nw, 0, 0, 640, scr^.height, 0, 1, IDCMPFlagSet {gadgetUp},
               WindowFlagSet {backDrop, borderless}, NIL, scr, customScreen);
 nw.firstGadget := ADR (dgad[0]);
 window := OpenWindow (nw);
 Assert (window # NIL, ADR ("Error BackWindow"));
 
(*--------------------------------------------------------------------------)
Beschriften der Devicegadgets mit den Devicename (df0: df1: ...)
(--------------------------------------------------------------------------*)

 SetAPen (window^.rPort, 1);
 FOR i := 0 TO DRIVES DO
  Move (window^.rPort, 26 + i * 60, scr^.height - 1);
  Text (window^.rPort, ADR (device[i]), Length (device[i]));
 END;

(*--------------------------------------------------------------------------)
Erzeugen der Directorywindows, anhngen der Propgadgets, Menus und ffnen
(--------------------------------------------------------------------------*)

 size := 3 * YSPACE + 28;
 StructWindow (nw, 0, MENUBAR, 640, size, 0, 1,
               IDCMPFlagSet {activeWindow, newSize, closeWindow, gadgetUp,
               menuPick}, WindowFlagSet {windowSizing, windowDrag,
               windowDepth, windowClose}, NIL, scr, customScreen);
 WITH nw DO
  firstGadget := ADR (gad[0]);
  minWidth := 110; minHeight := 40; maxHeight := scr^.height;
  win[0] := OpenWindow (nw);
  Assert (win[0] # NIL, ADR ("Error win0"));
  topEdge := (scr^.height - MENUBAR - DISKSPACE) / 2 + MENUBAR + 1;
  firstGadget := ADR (gad[1]);
  win[1] := OpenWindow (nw);
  Assert (win[1] # NIL, ADR ("Error win1"));
 END;
 ok := SetMenuStrip (win[0], menustripptr);
 Assert (ok # FALSE, ADR ("Error menu0"));
 ok := SetMenuStrip (win[1], menustripptr);
 Assert (ok # FALSE, ADR ("Error menu1"));

(*--------------------------------------------------------------------------)
Alle Systemrequester auf dem eigenen Schirm erscheinen lassen 
(--------------------------------------------------------------------------*)

 processptr := CAST (ProcessPtr, FindTask (0));
 syswin := processptr^.windowPtr;
 processptr^.windowPtr := window;
END Init;


PROCEDURE QSort (VAR a : ARRAY OF directory; count : INTEGER);

 PROCEDURE Sort (l, r : INTEGER);
 
 VAR	i		: INTEGER;
 	j		: INTEGER;
	name		: ARRAY [0..NAMELEN] OF CHAR;	(* Upcase Compname *)
	name1		: ARRAY [0..NAMELEN] OF CHAR;	(* Upcase Filename *)
        swap		: ARRAY [0..1] OF directory;	(* Tauschvariablen *)

 BEGIN
  i := l;
  j := r;
  swap[0] := a[(l + r) DIV 2];
  Copy (name, swap[0].name);
  CapString (name);
  REPEAT
   Copy (name1, a[i].name);
   CapString (name1);
   WHILE (a[i].type > swap[0].type) OR 
         ((a[i].type = swap[0].type) AND (Compare (name, name1) > 0)) DO
    INC (i);
    Copy (name1, a[i].name);
    CapString (name1);
   END;
   Copy (name1, a[j].name);
   CapString (name1);
   WHILE (swap[0].type > a[j].type) OR 
         ((a[j].type = swap[0].type) AND (Compare (name1, name) > 0)) DO
    DEC (j);
    Copy (name1, a[j].name);
    CapString (name1);
   END;
   IF i <= j THEN
    swap[1] := a[i];
    a[i] := a[j];
    a[j] := swap[1];
    INC (i);
    DEC (j);
   END;
  UNTIL i > j;
  IF l < j THEN
   Sort (l, j);
  END;
  IF i < r THEN
   Sort (i, r);
  END;
 END Sort;

BEGIN
 Sort (0, count);
END QSort;


PROCEDURE FindSelected (firstgad : INTEGER; VAR gad : filegadgets) : INTEGER;

VAR	i		: INTEGER;
	nextgadget	: GadgetPtr;
	
BEGIN
 i := 0;
 WHILE gad[i].gadgetID < firstgad DO
  INC (i);
  IF i > MAXDIR THEN
   RETURN (-1);
  END;
 END;
 REPEAT
  IF selected IN gad[i].flags THEN
   EXCL (gad[i].flags, selected);
   nextgadget := gad[i].nextGadget;
   gad[i].nextGadget := NIL;
   RefreshGadgets (ADR (gad[i]), win[act], NIL);
   gad[i].nextGadget := nextgadget;
   RETURN (gad[i].gadgetID);
  END;
 INC (i);
 UNTIL gad[i - 1].nextGadget = NIL;
 RETURN (-1);
END FindSelected;


PROCEDURE CountSelected (VAR gad : filegadgets) : INTEGER;

VAR	count		: INTEGER;			(* selekt. Zhler *)
	i		: INTEGER;
	
BEGIN
 count := 0;
 i := 0;
 REPEAT
  IF selected IN gad[i].flags THEN
   INC (count);
  END;
  INC (i);
 UNTIL gad[i - 1].nextGadget = NIL;
 RETURN (count);
END CountSelected;


PROCEDURE MakeGadgets (act : INTEGER; VAR cat : ARRAY OF directory;
                       entries : INTEGER);

CONST	ALL		= -1;				(* Code fr RemGL. *)
	NEXT		= -1;				(* Code fr AddGad.*)
	XSTART		= 28;				(* x Zeichenstart  *)
	YSTART		= 12;				(* y Zeichenstart  *)
	WIDTH		= 32;				(* ImageBreite     *)
	HEIGHT		= 16;				(* ImageHhe       *)
        CHEIGHT		= 8;				(* Zeichenhhe     *)
        CWIDTH		= 8;				(* Zeichenbreite   *)
	DIR		= 2;				(* Kennung SubDir  *)

 VAR	pos		: INTEGER;			(* GadListPosition *)
	width		: INTEGER;			(* Windowbreite    *)
	height		: INTEGER;			(* Windowhhe      *)
	x		: INTEGER;			(* x-Position      *)
        y		: INTEGER;			(* y-Position      *)
	len		: INTEGER;			(* Lnge Filename  *)
        dummy		: INTEGER;
	i		: INTEGER;			(* File Zhler     *)
	j		: INTEGER;			(* Gadget Zhler   *)
	rport		: RastPortPtr;
	str		: ARRAY [0..9] OF CHAR;		(* Akt. Filename   *)
	stat		: ARRAY [0..60] OF CHAR;	(* Statusstring    *)
	gadperrow	: INTEGER;			(* Gadgets / Zeile *)
	gadpercol	: INTEGER;			(* sicht. Zeilen   *)
	ok		: BOOLEAN;			(* Status ValToStr *)
	
BEGIN
(*--------------------------------------------------------------------------)
RastPort speichern, alle UserGadgets lschen und Zeichenstart definieren.
Das erste zu zeichnende Gadget kommt in die linke obere Ecke
(--------------------------------------------------------------------------*)

 rport := win[act]^.rPort;
 SetRast (rport, 0);
 dummy := RemoveGList (win[act], ADR (fgad[act,0]), ALL);
 width := win[act]^.width;
 height := win[act]^.height;
 gadperrow := width / XSPACE;
 gadpercol := (height - 13) / YSPACE;
 IF gadpercol > (entries / gadperrow + 1) THEN
  prop[act].vertBody := 65535;
  i := 0;
 ELSE
  prop[act].vertBody := 65535 / (entries / gadperrow + 1) * gadpercol;
  i := LONGINT (prop[act].vertPot) * (entries / gadperrow + 1 - gadpercol)
       / 65535;
  i := i * gadperrow;
 END;
 
 j := 0;
 
 x := XSTART;
 y := YSTART;

 LOOP

(*--------------------------------------------------------------------------)
Gadget mit x und y Pos erstellen und an die Gadgetliste anhngen
(--------------------------------------------------------------------------*)

  IF entries = -1 THEN
   EXIT;
  END;
  StructGadget (fgad[act,j], x, y, WIDTH, HEIGHT, GadgetFlagSet {gadgImage},
                ActivationFlagSet {relVerify, toggleSelect}, boolGadget,
                NIL, NIL, LONGSET {}, i, NIL);
  fgad[act,j].nextGadget := ADR (fgad[act,j + 1]);
  pos := AddGadget (win[act], ADR (fgad[act,j]), NEXT);

(*--------------------------------------------------------------------------)
Gadget beschriften (wei fr Dateien und rot fr Verzeichnisse)
(--------------------------------------------------------------------------*)

  Copy (str, cat[i].name);
  len := Length (str);
  IF cat[i].type = DIR THEN
   SetAPen (rport, 3);
   fgad[act,j].gadgetRender := ADR (dirimg);
  ELSE
   SetAPen (rport, 1);
   fgad[act,j].gadgetRender := ADR (fileimg);
  END;
  Move (rport, x + (WIDTH - len * CWIDTH) / 2, y + HEIGHT + CHEIGHT);
  Text (rport, ADR (str), len);

(*--------------------------------------------------------------------------)
x und y Pos ggf. erhhen und mit Fenstergre vergleichen
(--------------------------------------------------------------------------*)

  INC (x, XSPACE);
  IF x > width THEN
   x := XSTART;
   INC (y, YSPACE);
   IF y + YSPACE > height THEN
    EXIT;
   END;
  END;

  INC (j);
  INC (i);
  IF i > entries THEN
   EXIT;
  END;
 END; 

(*--------------------------------------------------------------------------)
Statuszeile mit Disknamen freien Blcken und Anzahl Dateien beschriften
(--------------------------------------------------------------------------*)

 Move (rport, 0, height - 14);
 Draw (rport, width, height - 14);
 stat := "Name : ";
 Concat (stat, diskname[act]);
 Concat (stat, "    Freie Blcke : ");
 ValToStr (diskfree[act], FALSE, str, 10, 4, " ", ok);
 Concat (stat, str);
 Concat (stat, "    Dateien : ");
 ValToStr (entries + 1, FALSE, str, 10, 3, " ", ok);
 Concat (stat, str);
 SetAPen (rport, 1);
 Move (rport, 6, height - 4);
 Text (rport, ADR (stat), Length (stat));
 
 IF diskstate[act] = writeProtect THEN
  DrawImage (rport, ADR (protimg), width - 38, height - 12);
 ELSE
  DrawImage (rport, ADR (unprotimg), width - 38, height - 12);
 END;

 fgad[act,j].nextGadget := NIL;
 RefreshWindowFrame (win[act]);
END MakeGadgets;


PROCEDURE ParentPath (VAR path : ARRAY OF CHAR);

CONST	NULL		= 0C;				(* Str.endekennung *)
	
VAR	mark		: INTEGER;			(* Pos im Pfad     *)
	       
BEGIN
 mark := LastPos (path, last, "/");
 IF mark = noOccur THEN
  mark := FirstPos (path, first, ":") + 1;
 END;
 path[mark] := CHAR (NULL);
END ParentPath;


PROCEDURE ReadDir (VAR cat : ARRAY OF directory; path : ARRAY OF CHAR)
		   : INTEGER;


VAR	lockptr		: FileLockPtr;
	fileblockptr	: FileInfoBlockPtr;
	infodataptr	: InfoDataPtr;
 	ok		: BOOLEAN;			(* Fehler Status   *)
	count		: INTEGER;			(* Dir-Eintrge -1 *)

BEGIN
(*--------------------------------------------------------------------------)
Diskettenstatus und Anzahl der freien Blcke aus Info ermitteln
(--------------------------------------------------------------------------*)

 lockptr := Lock (ADR (path), sharedLock);
 IF lockptr = NIL THEN
  count := -2;
 ELSE
  AllocMem (infodataptr, SIZE (InfoData), FALSE);
  ok := Info (lockptr, infodataptr);
  diskstate[act] := infodataptr^.diskState;
  diskfree[act] := infodataptr^.numBlocks - infodataptr^.numBlocksUsed;
  Deallocate (infodataptr);
 
(*--------------------------------------------------------------------------)
 Eintrge auf -1 setzen, Speicher fr Fileblock reservieren, Lock auf den
 Pfad setzen, den Diskettennamen in diskname kopierne und solange Filenamen
 lesen bis ExNext Fehler meldet
(--------------------------------------------------------------------------*)

  count := -1;
  AllocMem (fileblockptr, SIZE (FileInfoBlock), FALSE);
  ok := Examine (lockptr, fileblockptr);
  Copy (diskname[act], fileblockptr^.fileName);
  IF ok THEN
   REPEAT
    ok := ExNext (lockptr, fileblockptr);
    IF ok  THEN
     INC (count);
     Copy (cat[count].name, fileblockptr^.fileName);
     cat[count].type := fileblockptr^.entryType;
    END;
   UNTIL NOT ok;

(*--------------------------------------------------------------------------)
 Pfadnamen "unlocken" und reservierten Speicher freigeben
(--------------------------------------------------------------------------*)

   UnLock (lockptr);
   Deallocate (fileblockptr);
  END;

(*--------------------------------------------------------------------------)
Sortiertroutine (QuickSort) aufrufen, falls mehr als ein Eintrag
(--------------------------------------------------------------------------*)

  IF count > 0 THEN
   QSort (cat, count);
  END;
 END;
 RETURN (count);
END ReadDir;


PROCEDURE SubPath (VAR path : ARRAY OF CHAR; VAR subdir : ARRAY OF CHAR);

BEGIN
 IF path[Length (path) - 1] # ":" THEN
  Concat (path, "/");
 END;
 Concat (path, subdir);
END SubPath;


PROCEDURE DefineMenus;

VAR	ok		: BOOLEAN;				(* Status  *)
	flags		: MenuItemFlagSet;			(* Menuflg *)

BEGIN
 menustripptr := NIL;
 flags := MenuItemFlagSet {itemText, itemEnabled, highComp, commSeq};

 Item (ADR ("Lschen"), 120, flags, LONGSET {0}, "D");
 Item (ADR ("Kopieren"), 120, flags, LONGSET {0}, "C");
 Item (ADR ("Umbenennen"), 120, flags, LONGSET {0}, "R");
 Item (ADR ("Neues Dir"), 120, flags, LONGSET {0}, "M");
 Item (ADR ("Info"), 120, flags, LONGSET {0}, "I");
 ok := LinkMenu (menustripptr, ADR ("Datei"), 90, 48, TRUE);
 Assert (ok # FALSE, ADR ("Error FileMenu"));

 Item (ADR ("Quit"), 80, flags, LONGSET {0}, "Q");
 Item (ADR ("Info"), 80, MenuItemFlagSet {itemText, itemEnabled, highComp},
       LONGSET {0}, CHAR (0));
 ok := LinkMenu (menustripptr, ADR ("Top"), 10, 34, TRUE);
 Assert (ok # FALSE, ADR ("Error AboutMenu"));
END DefineMenus;

 
PROCEDURE Cleanup;

BEGIN
 IF mylevel >= CurrentLevel () THEN
  FreeImage (dirimg);
  FreeImage (fileimg);
  FreeImage (diskimg);
  FreeImage (unprotimg);
  FreeImage (protimg);
  processptr^.windowPtr := syswin;
  IF menustripptr # NIL THEN UnlinkMenu (menustripptr); END;
  IF win[1] # NIL THEN CloseWindow (win[1]); END;
  IF win[0] # NIL THEN CloseWindow (win[0]); END;
  IF window # NIL THEN CloseWindow (window); END;
  IF scr # NIL THEN CloseScreen (scr); END;
 END;
END Cleanup;

END Topinc.

